/* ListModel.c generated by valac 0.56.17, the Vala compiler
 * generated from ListModel.vala, do not modify */

/* Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "pantheon-files-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FILES_LIST_MODEL_0_PROPERTY,
	FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY,
	FILES_LIST_MODEL_ICON_SIZE_PROPERTY,
	FILES_LIST_MODEL_HAS_CHILD_PROPERTY,
	FILES_LIST_MODEL_SORT_PENDING_PROPERTY,
	FILES_LIST_MODEL_NUM_PROPERTIES
};
static GParamSpec* files_list_model_properties[FILES_LIST_MODEL_NUM_PROPERTIES];
typedef enum  {
	FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY = FILES_LIST_MODEL_COLUMN_ID_NUM_COLUMNS
} FilesListModelPrivColumnID;

#define FILES_LIST_MODEL_TYPE_PRIV_COLUMN_ID (files_list_model_priv_column_id_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
typedef struct _Block16Data Block16Data;
enum  {
	FILES_LIST_MODEL_SUBDIRECTORY_UNLOADED_SIGNAL,
	FILES_LIST_MODEL_NUM_SIGNALS
};
static guint files_list_model_signals[FILES_LIST_MODEL_NUM_SIGNALS] = {0};

struct _FilesListModelPrivate {
	gboolean _show_hidden_files;
	gint _icon_size;
	gboolean _has_child;
	gboolean sort_directories_first;
	GeeTreeMap* file_treerow_map;
	guint resort_timeout_id;
	gboolean delay_resort;
};

struct _Block16Data {
	int _ref_count_;
	FilesListModel* self;
	gboolean found;
	FilesFile* file;
};

static gint FilesListModel_private_offset;
static gpointer files_list_model_parent_class = NULL;
static GtkTreeModelIface * files_list_model_gtk_tree_model_parent_iface = NULL;

static GType files_list_model_priv_column_id_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gint _____lambda4_ (FilesListModel* self);
static gint ______lambda4__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                GtkTreeIter* a,
                                                GtkTreeIter* b,
                                                gpointer self);
static gint files_list_model_file_entry_compare_func (FilesListModel* self,
                                               GtkTreeIter* a,
                                               GtkTreeIter* b);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static gboolean files_list_model_get_first_iter_for_file (FilesListModel* self,
                                                   FilesFile* file,
                                                   GtkTreeIter** iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static void files_list_model_real_get_value (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      gint column,
                                      GValue* value);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block16Data* _data16_,
                     GtkTreeModel* model,
                     GtkTreePath* path,
                     GtkTreeIter* iter);
static gboolean ___lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                  GtkTreePath* path,
                                                  GtkTreeIter* iter,
                                                  gpointer self);
static void files_list_model_resort (FilesListModel* self);
static gboolean ___lambda8_ (FilesListModel* self);
static gboolean ____lambda8__gsource_func (gpointer self);
static GObject * files_list_model_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static GtkTreeRowReference* _vala_GtkTreeRowReference_copy (GtkTreeRowReference* self);
static void files_list_model_finalize (GObject * obj);
static GType files_list_model_get_type_once (void);
static void _vala_files_list_model_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_files_list_model_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

VALA_EXTERN const gchar* FILES_PREFERENCES_TAGS_COLORS[12];

static inline gpointer
files_list_model_get_instance_private (FilesListModel* self)
{
	return G_STRUCT_MEMBER_P (self, FilesListModel_private_offset);
}

FilesListModelColumnID
files_list_model_column_id_from_string (const gchar* column_id)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 31 "../libcore/ListModel.vala"
	static GQuark _tmp1_label0 = 0;
#line 31 "../libcore/ListModel.vala"
	static GQuark _tmp1_label1 = 0;
#line 31 "../libcore/ListModel.vala"
	static GQuark _tmp1_label2 = 0;
#line 31 "../libcore/ListModel.vala"
	static GQuark _tmp1_label3 = 0;
#line 157 "ListModel.c"
	FilesListModelColumnID result;
#line 30 "../libcore/ListModel.vala"
	g_return_val_if_fail (column_id != NULL, 0);
#line 31 "../libcore/ListModel.vala"
	_tmp0_ = column_id;
#line 31 "../libcore/ListModel.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 31 "../libcore/ListModel.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("name")))) {
#line 31 "../libcore/ListModel.vala"
		switch (0) {
#line 169 "ListModel.c"
			default:
			{
#line 33 "../libcore/ListModel.vala"
				result = FILES_LIST_MODEL_COLUMN_ID_FILENAME;
#line 33 "../libcore/ListModel.vala"
				return result;
#line 176 "ListModel.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("size")))) {
#line 31 "../libcore/ListModel.vala"
		switch (0) {
#line 182 "ListModel.c"
			default:
			{
#line 35 "../libcore/ListModel.vala"
				result = FILES_LIST_MODEL_COLUMN_ID_SIZE;
#line 35 "../libcore/ListModel.vala"
				return result;
#line 189 "ListModel.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("type")))) {
#line 31 "../libcore/ListModel.vala"
		switch (0) {
#line 195 "ListModel.c"
			default:
			{
#line 37 "../libcore/ListModel.vala"
				result = FILES_LIST_MODEL_COLUMN_ID_TYPE;
#line 37 "../libcore/ListModel.vala"
				return result;
#line 202 "ListModel.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("modified")))) {
#line 31 "../libcore/ListModel.vala"
		switch (0) {
#line 208 "ListModel.c"
			default:
			{
#line 39 "../libcore/ListModel.vala"
				result = FILES_LIST_MODEL_COLUMN_ID_MODIFIED;
#line 39 "../libcore/ListModel.vala"
				return result;
#line 215 "ListModel.c"
			}
		}
	} else {
#line 31 "../libcore/ListModel.vala"
		switch (0) {
#line 221 "ListModel.c"
			default:
			{
#line 41 "../libcore/ListModel.vala"
				result = (FilesListModelColumnID) -1;
#line 41 "../libcore/ListModel.vala"
				return result;
#line 228 "ListModel.c"
			}
		}
	}
}

const gchar*
files_list_model_column_id_to_string (FilesListModelColumnID self)
{
	const gchar* result;
#line 46 "../libcore/ListModel.vala"
	switch (self) {
#line 46 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_FILENAME:
#line 242 "ListModel.c"
		{
#line 48 "../libcore/ListModel.vala"
			result = "name";
#line 48 "../libcore/ListModel.vala"
			return result;
#line 248 "ListModel.c"
		}
#line 46 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_SIZE:
#line 252 "ListModel.c"
		{
#line 50 "../libcore/ListModel.vala"
			result = "size";
#line 50 "../libcore/ListModel.vala"
			return result;
#line 258 "ListModel.c"
		}
#line 46 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_TYPE:
#line 262 "ListModel.c"
		{
#line 52 "../libcore/ListModel.vala"
			result = "type";
#line 52 "../libcore/ListModel.vala"
			return result;
#line 268 "ListModel.c"
		}
#line 46 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_MODIFIED:
#line 272 "ListModel.c"
		{
#line 54 "../libcore/ListModel.vala"
			result = "modified";
#line 54 "../libcore/ListModel.vala"
			return result;
#line 278 "ListModel.c"
		}
		default:
		{
#line 56 "../libcore/ListModel.vala"
			g_critical ("ListModel.vala:56: COLUMN id %u unsupported", (guint) self);
#line 57 "../libcore/ListModel.vala"
			result = "";
#line 57 "../libcore/ListModel.vala"
			return result;
#line 288 "ListModel.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
files_list_model_column_id_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, "FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN", "file-column"}, {FILES_LIST_MODEL_COLUMN_ID_COLOR, "FILES_LIST_MODEL_COLUMN_ID_COLOR", "color"}, {FILES_LIST_MODEL_COLUMN_ID_PIXBUF, "FILES_LIST_MODEL_COLUMN_ID_PIXBUF", "pixbuf"}, {FILES_LIST_MODEL_COLUMN_ID_FILENAME, "FILES_LIST_MODEL_COLUMN_ID_FILENAME", "filename"}, {FILES_LIST_MODEL_COLUMN_ID_SIZE, "FILES_LIST_MODEL_COLUMN_ID_SIZE", "size"}, {FILES_LIST_MODEL_COLUMN_ID_TYPE, "FILES_LIST_MODEL_COLUMN_ID_TYPE", "type"}, {FILES_LIST_MODEL_COLUMN_ID_MODIFIED, "FILES_LIST_MODEL_COLUMN_ID_MODIFIED", "modified"}, {FILES_LIST_MODEL_COLUMN_ID_NUM_COLUMNS, "FILES_LIST_MODEL_COLUMN_ID_NUM_COLUMNS", "num-columns"}, {0, NULL, NULL}};
	GType files_list_model_column_id_type_id;
	files_list_model_column_id_type_id = g_enum_register_static ("FilesListModelColumnID", values);
	return files_list_model_column_id_type_id;
}

GType
files_list_model_column_id_get_type (void)
{
	static volatile gsize files_list_model_column_id_type_id__once = 0;
	if (g_once_init_enter (&files_list_model_column_id_type_id__once)) {
		GType files_list_model_column_id_type_id;
		files_list_model_column_id_type_id = files_list_model_column_id_get_type_once ();
		g_once_init_leave (&files_list_model_column_id_type_id__once, files_list_model_column_id_type_id);
	}
	return files_list_model_column_id_type_id__once;
}

 G_GNUC_NO_INLINE static GType
files_list_model_priv_column_id_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, "FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY", "dummy"}, {0, NULL, NULL}};
	GType files_list_model_priv_column_id_type_id;
	files_list_model_priv_column_id_type_id = g_enum_register_static ("FilesListModelPrivColumnID", values);
	return files_list_model_priv_column_id_type_id;
}

static GType
files_list_model_priv_column_id_get_type (void)
{
	static volatile gsize files_list_model_priv_column_id_type_id__once = 0;
	if (g_once_init_enter (&files_list_model_priv_column_id_type_id__once)) {
		GType files_list_model_priv_column_id_type_id;
		files_list_model_priv_column_id_type_id = files_list_model_priv_column_id_get_type_once ();
		g_once_init_leave (&files_list_model_priv_column_id_type_id__once, files_list_model_priv_column_id_type_id);
	}
	return files_list_model_priv_column_id_type_id__once;
}

static gint
_____lambda4_ (FilesListModel* self)
{
	gint result;
#line 101 "../libcore/ListModel.vala"
	result = 0;
#line 101 "../libcore/ListModel.vala"
	return result;
#line 343 "ListModel.c"
}

static gint
______lambda4__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                           GtkTreeIter* a,
                                           GtkTreeIter* b,
                                           gpointer self)
{
	gint result;
	result = _____lambda4_ ((FilesListModel*) self);
#line 101 "../libcore/ListModel.vala"
	return result;
#line 356 "ListModel.c"
}

void
files_list_model_set_sorting_off (FilesListModel* self)
{
#line 99 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 364 "ListModel.c"
	{
		gint i = 0;
#line 100 "../libcore/ListModel.vala"
		i = 0;
#line 369 "ListModel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 100 "../libcore/ListModel.vala"
			_tmp0_ = TRUE;
#line 100 "../libcore/ListModel.vala"
			while (TRUE) {
#line 100 "../libcore/ListModel.vala"
				if (!_tmp0_) {
#line 378 "ListModel.c"
					gint _tmp1_;
#line 100 "../libcore/ListModel.vala"
					_tmp1_ = i;
#line 100 "../libcore/ListModel.vala"
					i = _tmp1_ + 1;
#line 384 "ListModel.c"
				}
#line 100 "../libcore/ListModel.vala"
				_tmp0_ = FALSE;
#line 100 "../libcore/ListModel.vala"
				if (!(i < ((gint) FILES_LIST_MODEL_COLUMN_ID_NUM_COLUMNS))) {
#line 100 "../libcore/ListModel.vala"
					break;
#line 392 "ListModel.c"
				}
#line 101 "../libcore/ListModel.vala"
				gtk_tree_sortable_set_sort_func ((GtkTreeSortable*) self, i, ______lambda4__gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
#line 396 "ListModel.c"
			}
		}
	}
}

void
files_list_model_set_sorting_on (FilesListModel* self)
{
#line 106 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 407 "ListModel.c"
	{
		gint i = 0;
#line 107 "../libcore/ListModel.vala"
		i = 0;
#line 412 "ListModel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 107 "../libcore/ListModel.vala"
			_tmp0_ = TRUE;
#line 107 "../libcore/ListModel.vala"
			while (TRUE) {
#line 107 "../libcore/ListModel.vala"
				if (!_tmp0_) {
#line 421 "ListModel.c"
					gint _tmp1_;
#line 107 "../libcore/ListModel.vala"
					_tmp1_ = i;
#line 107 "../libcore/ListModel.vala"
					i = _tmp1_ + 1;
#line 427 "ListModel.c"
				}
#line 107 "../libcore/ListModel.vala"
				_tmp0_ = FALSE;
#line 107 "../libcore/ListModel.vala"
				if (!(i < ((gint) FILES_LIST_MODEL_COLUMN_ID_NUM_COLUMNS))) {
#line 107 "../libcore/ListModel.vala"
					break;
#line 435 "ListModel.c"
				}
#line 108 "../libcore/ListModel.vala"
				gtk_tree_sortable_set_sort_func ((GtkTreeSortable*) self, i, (GtkTreeIterCompareFunc) files_list_model_file_entry_compare_func, g_object_ref (self), g_object_unref);
#line 439 "ListModel.c"
			}
		}
	}
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 115 "../libcore/ListModel.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 450 "ListModel.c"
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 115 "../libcore/ListModel.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 458 "ListModel.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 115 "../libcore/ListModel.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 466 "ListModel.c"
}

FilesFile*
files_list_model_file_for_path (FilesListModel* self,
                                GtkTreePath* path)
{
	FilesFile* file = NULL;
	GtkTreeIter* iter = NULL;
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkTreeIter _tmp2_;
	GtkTreeIter* _tmp3_;
	FilesFile* result;
#line 112 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../libcore/ListModel.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 113 "../libcore/ListModel.vala"
	file = NULL;
#line 115 "../libcore/ListModel.vala"
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
#line 115 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 115 "../libcore/ListModel.vala"
	_tmp2_ = _tmp0_;
#line 115 "../libcore/ListModel.vala"
	_tmp3_ = __vala_GtkTreeIter_copy0 (&_tmp2_);
#line 115 "../libcore/ListModel.vala"
	iter = _tmp3_;
#line 115 "../libcore/ListModel.vala"
	if (_tmp1_) {
#line 498 "ListModel.c"
		GtkTreeIter* _tmp4_;
		GtkTreeIter _tmp5_;
#line 116 "../libcore/ListModel.vala"
		_tmp4_ = iter;
#line 116 "../libcore/ListModel.vala"
		_tmp5_ = *_tmp4_;
#line 116 "../libcore/ListModel.vala"
		gtk_tree_model_get ((GtkTreeModel*) self, &_tmp5_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &file, -1);
#line 507 "ListModel.c"
	}
#line 119 "../libcore/ListModel.vala"
	result = file;
#line 119 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 119 "../libcore/ListModel.vala"
	return result;
#line 515 "ListModel.c"
}

FilesFile*
files_list_model_file_for_iter (FilesListModel* self,
                                GtkTreeIter* iter)
{
	FilesFile* file = NULL;
	GtkTreeIter _tmp0_;
	FilesFile* result;
#line 122 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "../libcore/ListModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 123 "../libcore/ListModel.vala"
	file = NULL;
#line 124 "../libcore/ListModel.vala"
	_tmp0_ = *iter;
#line 124 "../libcore/ListModel.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &file, -1);
#line 125 "../libcore/ListModel.vala"
	result = file;
#line 125 "../libcore/ListModel.vala"
	return result;
#line 539 "ListModel.c"
}

guint
files_list_model_get_length (FilesListModel* self)
{
	guint result;
#line 128 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 129 "../libcore/ListModel.vala"
	result = (guint) gtk_tree_model_iter_n_children ((GtkTreeModel*) self, NULL);
#line 129 "../libcore/ListModel.vala"
	return result;
#line 552 "ListModel.c"
}

GtkTreePath*
files_list_model_get_path_for_first_file (FilesListModel* self,
                                          FilesFile* file)
{
	GtkTreeIter* iter = NULL;
	GtkTreeIter* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkTreePath* result;
#line 132 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../libcore/ListModel.vala"
	if (file == NULL) {
#line 134 "../libcore/ListModel.vala"
		result = NULL;
#line 134 "../libcore/ListModel.vala"
		return result;
#line 571 "ListModel.c"
	}
#line 137 "../libcore/ListModel.vala"
	iter = NULL;
#line 138 "../libcore/ListModel.vala"
	_tmp1_ = files_list_model_get_first_iter_for_file (self, file, &_tmp0_);
#line 138 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 138 "../libcore/ListModel.vala"
	iter = _tmp0_;
#line 138 "../libcore/ListModel.vala"
	if (_tmp1_) {
#line 583 "ListModel.c"
		GtkTreeIter* _tmp2_;
		GtkTreeIter _tmp3_;
		GtkTreePath* _tmp4_;
#line 139 "../libcore/ListModel.vala"
		_tmp2_ = iter;
#line 139 "../libcore/ListModel.vala"
		_tmp3_ = *_tmp2_;
#line 139 "../libcore/ListModel.vala"
		_tmp4_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp3_);
#line 139 "../libcore/ListModel.vala"
		result = _tmp4_;
#line 139 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 139 "../libcore/ListModel.vala"
		return result;
#line 599 "ListModel.c"
	} else {
#line 141 "../libcore/ListModel.vala"
		result = NULL;
#line 141 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 141 "../libcore/ListModel.vala"
		return result;
#line 607 "ListModel.c"
	}
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 155 "../libcore/ListModel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 616 "ListModel.c"
}

static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
#line 156 "../libcore/ListModel.vala"
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
#line 624 "ListModel.c"
}

static gboolean
files_list_model_get_first_iter_for_file (FilesListModel* self,
                                          FilesFile* file,
                                          GtkTreeIter** iter)
{
	GtkTreeIter* _vala_iter = NULL;
	GtkTreeRowReference* row = NULL;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	GtkTreeRowReference* _tmp4_;
	gboolean result;
#line 145 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (_vala_iter);
#line 146 "../libcore/ListModel.vala"
	_vala_iter = NULL;
#line 148 "../libcore/ListModel.vala"
	if (file == NULL) {
#line 149 "../libcore/ListModel.vala"
		result = FALSE;
#line 149 "../libcore/ListModel.vala"
		if (iter) {
#line 149 "../libcore/ListModel.vala"
			*iter = _vala_iter;
#line 654 "ListModel.c"
		} else {
#line 149 "../libcore/ListModel.vala"
			__vala_GtkTreeIter_free0 (_vala_iter);
#line 658 "ListModel.c"
		}
#line 149 "../libcore/ListModel.vala"
		return result;
#line 662 "ListModel.c"
	}
#line 152 "../libcore/ListModel.vala"
	_tmp0_ = self->priv->file_treerow_map;
#line 152 "../libcore/ListModel.vala"
	_tmp1_ = files_file_get_uri (file);
#line 152 "../libcore/ListModel.vala"
	_tmp2_ = _tmp1_;
#line 152 "../libcore/ListModel.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 152 "../libcore/ListModel.vala"
	row = (GtkTreeRowReference*) _tmp3_;
#line 153 "../libcore/ListModel.vala"
	_tmp4_ = row;
#line 153 "../libcore/ListModel.vala"
	if (_tmp4_ != NULL) {
#line 678 "ListModel.c"
		GtkTreeRowReference* _tmp5_;
#line 154 "../libcore/ListModel.vala"
		_tmp5_ = row;
#line 154 "../libcore/ListModel.vala"
		if (gtk_tree_row_reference_valid (_tmp5_)) {
#line 684 "ListModel.c"
			GtkTreeRowReference* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
			GtkTreeIter _tmp9_ = {0};
			GtkTreeIter _tmp10_;
			GtkTreeIter* _tmp11_;
#line 155 "../libcore/ListModel.vala"
			_tmp6_ = row;
#line 155 "../libcore/ListModel.vala"
			_tmp7_ = gtk_tree_row_reference_get_path (_tmp6_);
#line 155 "../libcore/ListModel.vala"
			_tmp8_ = _tmp7_;
#line 155 "../libcore/ListModel.vala"
			gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp9_, _tmp8_);
#line 155 "../libcore/ListModel.vala"
			__vala_GtkTreeIter_free0 (_vala_iter);
#line 155 "../libcore/ListModel.vala"
			_tmp10_ = _tmp9_;
#line 155 "../libcore/ListModel.vala"
			_tmp11_ = __vala_GtkTreeIter_copy0 (&_tmp10_);
#line 155 "../libcore/ListModel.vala"
			_vala_iter = _tmp11_;
#line 155 "../libcore/ListModel.vala"
			__vala_GtkTreePath_free0 (_tmp8_);
#line 156 "../libcore/ListModel.vala"
			result = TRUE;
#line 156 "../libcore/ListModel.vala"
			__vala_GtkTreeRowReference_free0 (row);
#line 156 "../libcore/ListModel.vala"
			if (iter) {
#line 156 "../libcore/ListModel.vala"
				*iter = _vala_iter;
#line 717 "ListModel.c"
			} else {
#line 156 "../libcore/ListModel.vala"
				__vala_GtkTreeIter_free0 (_vala_iter);
#line 721 "ListModel.c"
			}
#line 156 "../libcore/ListModel.vala"
			return result;
#line 725 "ListModel.c"
		} else {
			GeeTreeMap* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 158 "../libcore/ListModel.vala"
			_tmp12_ = self->priv->file_treerow_map;
#line 158 "../libcore/ListModel.vala"
			_tmp13_ = files_file_get_uri (file);
#line 158 "../libcore/ListModel.vala"
			_tmp14_ = _tmp13_;
#line 158 "../libcore/ListModel.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp12_, _tmp14_, NULL);
#line 738 "ListModel.c"
		}
	}
#line 162 "../libcore/ListModel.vala"
	result = FALSE;
#line 162 "../libcore/ListModel.vala"
	__vala_GtkTreeRowReference_free0 (row);
#line 162 "../libcore/ListModel.vala"
	if (iter) {
#line 162 "../libcore/ListModel.vala"
		*iter = _vala_iter;
#line 749 "ListModel.c"
	} else {
#line 162 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (_vala_iter);
#line 753 "ListModel.c"
	}
#line 162 "../libcore/ListModel.vala"
	return result;
#line 757 "ListModel.c"
}

static void
files_list_model_real_get_value (GtkTreeModel* base,
                                 GtkTreeIter* iter,
                                 gint column,
                                 GValue* value)
{
	FilesListModel * self;
	GValue _vala_value = {0};
	GValue file_value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	FilesFile* file = NULL;
	GObject* _tmp2_;
#line 165 "../libcore/ListModel.vala"
	self = (FilesListModel*) base;
#line 165 "../libcore/ListModel.vala"
	g_return_if_fail (iter != NULL);
#line 167 "../libcore/ListModel.vala"
	_tmp0_ = *iter;
#line 167 "../libcore/ListModel.vala"
	files_list_model_gtk_tree_model_parent_iface->get_value ((GtkTreeModel*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_store_get_type (), GtkTreeStore), &_tmp0_, (gint) FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp1_);
#line 167 "../libcore/ListModel.vala"
	G_IS_VALUE (&file_value) ? (g_value_unset (&file_value), NULL) : NULL;
#line 167 "../libcore/ListModel.vala"
	file_value = _tmp1_;
#line 168 "../libcore/ListModel.vala"
	_tmp2_ = g_value_get_object (&file_value);
#line 168 "../libcore/ListModel.vala"
	file = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, FILES_TYPE_FILE, FilesFile);
#line 170 "../libcore/ListModel.vala"
	switch (column) {
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN:
#line 793 "ListModel.c"
		{
			GValue _tmp3_ = {0};
			FilesFile* _tmp4_;
#line 172 "../libcore/ListModel.vala"
			g_value_init (&_tmp3_, FILES_TYPE_FILE);
#line 172 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 172 "../libcore/ListModel.vala"
			_vala_value = _tmp3_;
#line 173 "../libcore/ListModel.vala"
			_tmp4_ = file;
#line 173 "../libcore/ListModel.vala"
			g_value_set_object (&_vala_value, (GObject*) _tmp4_);
#line 174 "../libcore/ListModel.vala"
			break;
#line 809 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_COLOR:
#line 813 "ListModel.c"
		{
			GValue _tmp5_ = {0};
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			FilesFile* _tmp8_;
#line 176 "../libcore/ListModel.vala"
			g_value_init (&_tmp5_, G_TYPE_STRING);
#line 176 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 176 "../libcore/ListModel.vala"
			_vala_value = _tmp5_;
#line 178 "../libcore/ListModel.vala"
			_tmp8_ = file;
#line 178 "../libcore/ListModel.vala"
			if (_tmp8_ != NULL) {
#line 829 "ListModel.c"
				FilesFile* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 179 "../libcore/ListModel.vala"
				_tmp9_ = file;
#line 179 "../libcore/ListModel.vala"
				_tmp10_ = files_file_get_color (_tmp9_);
#line 179 "../libcore/ListModel.vala"
				_tmp11_ = _tmp10_;
#line 179 "../libcore/ListModel.vala"
				_tmp7_ = _tmp11_ >= 0;
#line 841 "ListModel.c"
			} else {
#line 178 "../libcore/ListModel.vala"
				_tmp7_ = FALSE;
#line 845 "ListModel.c"
			}
#line 178 "../libcore/ListModel.vala"
			if (_tmp7_) {
#line 849 "ListModel.c"
				FilesFile* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 180 "../libcore/ListModel.vala"
				_tmp12_ = file;
#line 180 "../libcore/ListModel.vala"
				_tmp13_ = files_file_get_color (_tmp12_);
#line 180 "../libcore/ListModel.vala"
				_tmp14_ = _tmp13_;
#line 180 "../libcore/ListModel.vala"
				_tmp6_ = _tmp14_ < G_N_ELEMENTS (FILES_PREFERENCES_TAGS_COLORS);
#line 861 "ListModel.c"
			} else {
#line 178 "../libcore/ListModel.vala"
				_tmp6_ = FALSE;
#line 865 "ListModel.c"
			}
#line 177 "../libcore/ListModel.vala"
			if (_tmp6_) {
#line 869 "ListModel.c"
				FilesFile* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				const gchar* _tmp18_;
#line 182 "../libcore/ListModel.vala"
				_tmp15_ = file;
#line 182 "../libcore/ListModel.vala"
				_tmp16_ = files_file_get_color (_tmp15_);
#line 182 "../libcore/ListModel.vala"
				_tmp17_ = _tmp16_;
#line 182 "../libcore/ListModel.vala"
				_tmp18_ = FILES_PREFERENCES_TAGS_COLORS[_tmp17_];
#line 182 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp18_);
#line 884 "ListModel.c"
			} else {
				const gchar* _tmp19_;
#line 184 "../libcore/ListModel.vala"
				_tmp19_ = FILES_PREFERENCES_TAGS_COLORS[0];
#line 184 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp19_);
#line 891 "ListModel.c"
			}
#line 187 "../libcore/ListModel.vala"
			break;
#line 895 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_PIXBUF:
#line 899 "ListModel.c"
		{
			GValue _tmp20_ = {0};
			FilesFile* _tmp21_;
#line 189 "../libcore/ListModel.vala"
			g_value_init (&_tmp20_, gdk_pixbuf_get_type ());
#line 189 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 189 "../libcore/ListModel.vala"
			_vala_value = _tmp20_;
#line 190 "../libcore/ListModel.vala"
			_tmp21_ = file;
#line 190 "../libcore/ListModel.vala"
			if (_tmp21_ != NULL) {
#line 913 "ListModel.c"
				FilesFile* _tmp22_;
				gint _tmp23_;
				FilesFile* _tmp24_;
				FilesFile* _tmp25_;
				GdkPixbuf* _tmp26_;
#line 191 "../libcore/ListModel.vala"
				_tmp22_ = file;
#line 191 "../libcore/ListModel.vala"
				_tmp23_ = self->priv->_icon_size;
#line 191 "../libcore/ListModel.vala"
				_tmp24_ = file;
#line 191 "../libcore/ListModel.vala"
				files_file_update_icon (_tmp22_, _tmp23_, _tmp24_->pix_scale);
#line 192 "../libcore/ListModel.vala"
				_tmp25_ = file;
#line 192 "../libcore/ListModel.vala"
				_tmp26_ = _tmp25_->pix;
#line 192 "../libcore/ListModel.vala"
				if (_tmp26_ != NULL) {
#line 933 "ListModel.c"
					FilesFile* _tmp27_;
					GdkPixbuf* _tmp28_;
#line 193 "../libcore/ListModel.vala"
					_tmp27_ = file;
#line 193 "../libcore/ListModel.vala"
					_tmp28_ = _tmp27_->pix;
#line 193 "../libcore/ListModel.vala"
					g_value_set_object (&_vala_value, (GObject*) _tmp28_);
#line 942 "ListModel.c"
				}
			}
#line 197 "../libcore/ListModel.vala"
			break;
#line 947 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_FILENAME:
#line 951 "ListModel.c"
		{
			GValue _tmp29_ = {0};
			FilesFile* _tmp30_;
#line 199 "../libcore/ListModel.vala"
			g_value_init (&_tmp29_, G_TYPE_STRING);
#line 199 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 199 "../libcore/ListModel.vala"
			_vala_value = _tmp29_;
#line 200 "../libcore/ListModel.vala"
			_tmp30_ = file;
#line 200 "../libcore/ListModel.vala"
			if (_tmp30_ != NULL) {
#line 965 "ListModel.c"
				FilesFile* _tmp31_;
				const gchar* _tmp32_;
#line 201 "../libcore/ListModel.vala"
				_tmp31_ = file;
#line 201 "../libcore/ListModel.vala"
				_tmp32_ = files_file_get_display_name (_tmp31_);
#line 201 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp32_);
#line 974 "ListModel.c"
			} else {
#line 203 "../libcore/ListModel.vala"
				g_value_set_static_string (&_vala_value, "");
#line 978 "ListModel.c"
			}
#line 206 "../libcore/ListModel.vala"
			break;
#line 982 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_SIZE:
#line 986 "ListModel.c"
		{
			GValue _tmp33_ = {0};
			FilesFile* _tmp34_;
#line 208 "../libcore/ListModel.vala"
			g_value_init (&_tmp33_, G_TYPE_STRING);
#line 208 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 208 "../libcore/ListModel.vala"
			_vala_value = _tmp33_;
#line 209 "../libcore/ListModel.vala"
			_tmp34_ = file;
#line 209 "../libcore/ListModel.vala"
			if (_tmp34_ != NULL) {
#line 1000 "ListModel.c"
				FilesFile* _tmp35_;
				const gchar* _tmp36_;
#line 210 "../libcore/ListModel.vala"
				_tmp35_ = file;
#line 210 "../libcore/ListModel.vala"
				_tmp36_ = _tmp35_->format_size;
#line 210 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp36_);
#line 1009 "ListModel.c"
			} else {
#line 212 "../libcore/ListModel.vala"
				g_value_set_static_string (&_vala_value, "");
#line 1013 "ListModel.c"
			}
#line 215 "../libcore/ListModel.vala"
			break;
#line 1017 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_TYPE:
#line 1021 "ListModel.c"
		{
			GValue _tmp37_ = {0};
			FilesFile* _tmp38_;
#line 217 "../libcore/ListModel.vala"
			g_value_init (&_tmp37_, G_TYPE_STRING);
#line 217 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 217 "../libcore/ListModel.vala"
			_vala_value = _tmp37_;
#line 218 "../libcore/ListModel.vala"
			_tmp38_ = file;
#line 218 "../libcore/ListModel.vala"
			if (_tmp38_ != NULL) {
#line 1035 "ListModel.c"
				FilesFile* _tmp39_;
				const gchar* _tmp40_;
#line 219 "../libcore/ListModel.vala"
				_tmp39_ = file;
#line 219 "../libcore/ListModel.vala"
				_tmp40_ = _tmp39_->formated_type;
#line 219 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp40_);
#line 1044 "ListModel.c"
			} else {
#line 221 "../libcore/ListModel.vala"
				g_value_set_static_string (&_vala_value, "");
#line 1048 "ListModel.c"
			}
#line 224 "../libcore/ListModel.vala"
			break;
#line 1052 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_COLUMN_ID_MODIFIED:
#line 1056 "ListModel.c"
		{
			GValue _tmp41_ = {0};
			FilesFile* _tmp42_;
#line 226 "../libcore/ListModel.vala"
			g_value_init (&_tmp41_, G_TYPE_STRING);
#line 226 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 226 "../libcore/ListModel.vala"
			_vala_value = _tmp41_;
#line 227 "../libcore/ListModel.vala"
			_tmp42_ = file;
#line 227 "../libcore/ListModel.vala"
			if (_tmp42_ != NULL) {
#line 1070 "ListModel.c"
				FilesFile* _tmp43_;
				const gchar* _tmp44_;
#line 228 "../libcore/ListModel.vala"
				_tmp43_ = file;
#line 228 "../libcore/ListModel.vala"
				_tmp44_ = _tmp43_->formated_modified;
#line 228 "../libcore/ListModel.vala"
				g_value_set_string (&_vala_value, _tmp44_);
#line 1079 "ListModel.c"
			} else {
#line 230 "../libcore/ListModel.vala"
				g_value_set_static_string (&_vala_value, "");
#line 1083 "ListModel.c"
			}
#line 233 "../libcore/ListModel.vala"
			break;
#line 1087 "ListModel.c"
		}
#line 170 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY:
#line 1091 "ListModel.c"
		{
			GValue _tmp45_ = {0};
			FilesFile* _tmp46_;
#line 235 "../libcore/ListModel.vala"
			g_value_init (&_tmp45_, G_TYPE_BOOLEAN);
#line 235 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 235 "../libcore/ListModel.vala"
			_vala_value = _tmp45_;
#line 236 "../libcore/ListModel.vala"
			_tmp46_ = file;
#line 236 "../libcore/ListModel.vala"
			g_value_set_boolean (&_vala_value, _tmp46_ == NULL);
#line 237 "../libcore/ListModel.vala"
			break;
#line 1107 "ListModel.c"
		}
		default:
		{
			GValue _tmp47_ = {0};
#line 239 "../libcore/ListModel.vala"
			g_value_init (&_tmp47_, G_TYPE_INVALID);
#line 239 "../libcore/ListModel.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 239 "../libcore/ListModel.vala"
			_vala_value = _tmp47_;
#line 240 "../libcore/ListModel.vala"
			break;
#line 1120 "ListModel.c"
		}
	}
#line 165 "../libcore/ListModel.vala"
	G_IS_VALUE (&file_value) ? (g_value_unset (&file_value), NULL) : NULL;
#line 165 "../libcore/ListModel.vala"
	if (value) {
#line 165 "../libcore/ListModel.vala"
		*value = _vala_value;
#line 1129 "ListModel.c"
	} else {
#line 165 "../libcore/ListModel.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 1133 "ListModel.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 244 "../libcore/ListModel.vala"
	return self ? g_object_ref (self) : NULL;
#line 1142 "ListModel.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 244 "../libcore/ListModel.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 244 "../libcore/ListModel.vala"
	return _data16_;
#line 1152 "ListModel.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 244 "../libcore/ListModel.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 1162 "ListModel.c"
		FilesListModel* self;
#line 244 "../libcore/ListModel.vala"
		self = _data16_->self;
#line 244 "../libcore/ListModel.vala"
		_g_object_unref0 (_data16_->file);
#line 244 "../libcore/ListModel.vala"
		_g_object_unref0 (self);
#line 244 "../libcore/ListModel.vala"
		g_slice_free (Block16Data, _data16_);
#line 1172 "ListModel.c"
	}
}

static gboolean
__lambda7_ (Block16Data* _data16_,
            GtkTreeModel* model,
            GtkTreePath* path,
            GtkTreeIter* iter)
{
	FilesListModel* self;
	FilesFile* iter_file = NULL;
	GtkTreeIter _tmp0_;
	FilesFile* _tmp1_;
	gboolean result;
#line 246 "../libcore/ListModel.vala"
	self = _data16_->self;
#line 246 "../libcore/ListModel.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 246 "../libcore/ListModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 246 "../libcore/ListModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 247 "../libcore/ListModel.vala"
	iter_file = NULL;
#line 248 "../libcore/ListModel.vala"
	_tmp0_ = *iter;
#line 248 "../libcore/ListModel.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &iter_file, -1);
#line 249 "../libcore/ListModel.vala"
	_tmp1_ = iter_file;
#line 249 "../libcore/ListModel.vala"
	if (_tmp1_ == _data16_->file) {
#line 1205 "ListModel.c"
		GtkTreeIter _tmp2_;
#line 250 "../libcore/ListModel.vala"
		_tmp2_ = *iter;
#line 250 "../libcore/ListModel.vala"
		gtk_tree_model_row_changed (model, path, &_tmp2_);
#line 251 "../libcore/ListModel.vala"
		_data16_->found = TRUE;
#line 252 "../libcore/ListModel.vala"
		result = TRUE;
#line 252 "../libcore/ListModel.vala"
		_g_object_unref0 (iter_file);
#line 252 "../libcore/ListModel.vala"
		return result;
#line 1219 "ListModel.c"
	}
#line 255 "../libcore/ListModel.vala"
	result = FALSE;
#line 255 "../libcore/ListModel.vala"
	_g_object_unref0 (iter_file);
#line 255 "../libcore/ListModel.vala"
	return result;
#line 1227 "ListModel.c"
}

static gboolean
___lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, model, path, iter);
#line 246 "../libcore/ListModel.vala"
	return result;
#line 1240 "ListModel.c"
}

void
files_list_model_file_changed (FilesListModel* self,
                               FilesFile* file,
                               FilesDirectory* dir)
{
	Block16Data* _data16_;
	FilesFile* _tmp0_;
#line 244 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 244 "../libcore/ListModel.vala"
	g_return_if_fail (file != NULL);
#line 244 "../libcore/ListModel.vala"
	g_return_if_fail (dir != NULL);
#line 244 "../libcore/ListModel.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 244 "../libcore/ListModel.vala"
	_data16_->_ref_count_ = 1;
#line 244 "../libcore/ListModel.vala"
	_data16_->self = g_object_ref (self);
#line 244 "../libcore/ListModel.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 244 "../libcore/ListModel.vala"
	_g_object_unref0 (_data16_->file);
#line 244 "../libcore/ListModel.vala"
	_data16_->file = _tmp0_;
#line 245 "../libcore/ListModel.vala"
	_data16_->found = FALSE;
#line 246 "../libcore/ListModel.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) self, ___lambda7__gtk_tree_model_foreach_func, _data16_);
#line 258 "../libcore/ListModel.vala"
	if (!_data16_->found) {
#line 259 "../libcore/ListModel.vala"
		files_list_model_add_file (self, _data16_->file, dir);
#line 1276 "ListModel.c"
	}
#line 244 "../libcore/ListModel.vala"
	block16_data_unref (_data16_);
#line 244 "../libcore/ListModel.vala"
	_data16_ = NULL;
#line 1282 "ListModel.c"
}

void
files_list_model_set_should_sort_directories_first (FilesListModel* self,
                                                    gboolean sort_directories_first)
{
#line 263 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 264 "../libcore/ListModel.vala"
	if (self->priv->sort_directories_first == sort_directories_first) {
#line 265 "../libcore/ListModel.vala"
		return;
#line 1295 "ListModel.c"
	}
#line 268 "../libcore/ListModel.vala"
	self->priv->sort_directories_first = sort_directories_first;
#line 269 "../libcore/ListModel.vala"
	files_list_model_resort (self);
#line 1301 "ListModel.c"
}

static gboolean
___lambda8_ (FilesListModel* self)
{
	gboolean result;
#line 283 "../libcore/ListModel.vala"
	if (self->priv->delay_resort) {
#line 284 "../libcore/ListModel.vala"
		self->priv->delay_resort = FALSE;
#line 285 "../libcore/ListModel.vala"
		result = G_SOURCE_CONTINUE;
#line 285 "../libcore/ListModel.vala"
		return result;
#line 1316 "ListModel.c"
	} else {
		gint sort_column_id = 0;
		GtkSortType order = 0;
		gint _tmp0_ = 0;
		GtkSortType _tmp1_ = 0;
		gboolean _tmp2_;
#line 287 "../libcore/ListModel.vala"
		self->priv->delay_resort = TRUE;
#line 290 "../libcore/ListModel.vala"
		_tmp2_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) self, &_tmp0_, &_tmp1_);
#line 290 "../libcore/ListModel.vala"
		sort_column_id = _tmp0_;
#line 290 "../libcore/ListModel.vala"
		order = _tmp1_;
#line 290 "../libcore/ListModel.vala"
		if (!_tmp2_) {
#line 291 "../libcore/ListModel.vala"
			sort_column_id = (gint) FILES_LIST_MODEL_COLUMN_ID_FILENAME;
#line 292 "../libcore/ListModel.vala"
			order = GTK_SORT_ASCENDING;
#line 1337 "ListModel.c"
		}
#line 295 "../libcore/ListModel.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, order);
#line 296 "../libcore/ListModel.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, sort_column_id, order);
#line 297 "../libcore/ListModel.vala"
		self->priv->resort_timeout_id = (guint) 0;
#line 298 "../libcore/ListModel.vala"
		result = G_SOURCE_REMOVE;
#line 298 "../libcore/ListModel.vala"
		return result;
#line 1349 "ListModel.c"
	}
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ ((FilesListModel*) self);
#line 282 "../libcore/ListModel.vala"
	return result;
#line 1360 "ListModel.c"
}

static void
files_list_model_resort (FilesListModel* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 280 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 281 "../libcore/ListModel.vala"
	_tmp0_ = files_list_model_get_sort_pending (self);
#line 281 "../libcore/ListModel.vala"
	_tmp1_ = _tmp0_;
#line 281 "../libcore/ListModel.vala"
	if (!_tmp1_) {
#line 282 "../libcore/ListModel.vala"
		self->priv->resort_timeout_id = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 1378 "ListModel.c"
	} else {
#line 302 "../libcore/ListModel.vala"
		self->priv->delay_resort = TRUE;
#line 1382 "ListModel.c"
	}
}

gboolean
files_list_model_get_subdirectory (FilesListModel* self,
                                   GtkTreePath* path,
                                   FilesDirectory** dir)
{
	FilesDirectory* _vala_dir = NULL;
	FilesFile* file = NULL;
	GtkTreeIter* iter = NULL;
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkTreeIter _tmp2_;
	GtkTreeIter* _tmp3_;
	FilesDirectory* _tmp10_;
	gboolean result;
#line 306 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 306 "../libcore/ListModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 307 "../libcore/ListModel.vala"
	_g_object_unref0 (_vala_dir);
#line 307 "../libcore/ListModel.vala"
	_vala_dir = NULL;
#line 308 "../libcore/ListModel.vala"
	file = NULL;
#line 310 "../libcore/ListModel.vala"
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
#line 310 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 310 "../libcore/ListModel.vala"
	_tmp2_ = _tmp0_;
#line 310 "../libcore/ListModel.vala"
	_tmp3_ = __vala_GtkTreeIter_copy0 (&_tmp2_);
#line 310 "../libcore/ListModel.vala"
	iter = _tmp3_;
#line 310 "../libcore/ListModel.vala"
	if (_tmp1_) {
#line 1422 "ListModel.c"
		GtkTreeIter* _tmp4_;
		GtkTreeIter _tmp5_;
		FilesFile* _tmp6_ = NULL;
		FilesFile* _tmp7_;
#line 311 "../libcore/ListModel.vala"
		_tmp4_ = iter;
#line 311 "../libcore/ListModel.vala"
		_tmp5_ = *_tmp4_;
#line 311 "../libcore/ListModel.vala"
		gtk_tree_model_get ((GtkTreeModel*) self, &_tmp5_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp6_, -1);
#line 311 "../libcore/ListModel.vala"
		_g_object_unref0 (file);
#line 311 "../libcore/ListModel.vala"
		file = _tmp6_;
#line 312 "../libcore/ListModel.vala"
		_tmp7_ = file;
#line 312 "../libcore/ListModel.vala"
		if (_tmp7_ != NULL) {
#line 1441 "ListModel.c"
			FilesFile* _tmp8_;
			FilesDirectory* _tmp9_;
#line 313 "../libcore/ListModel.vala"
			_tmp8_ = file;
#line 313 "../libcore/ListModel.vala"
			_tmp9_ = files_directory_from_file (_tmp8_);
#line 313 "../libcore/ListModel.vala"
			_g_object_unref0 (_vala_dir);
#line 313 "../libcore/ListModel.vala"
			_vala_dir = _tmp9_;
#line 1452 "ListModel.c"
		}
	}
#line 317 "../libcore/ListModel.vala"
	_tmp10_ = _vala_dir;
#line 317 "../libcore/ListModel.vala"
	result = _tmp10_ != NULL;
#line 317 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 317 "../libcore/ListModel.vala"
	_g_object_unref0 (file);
#line 317 "../libcore/ListModel.vala"
	if (dir) {
#line 317 "../libcore/ListModel.vala"
		*dir = _vala_dir;
#line 1467 "ListModel.c"
	} else {
#line 317 "../libcore/ListModel.vala"
		_g_object_unref0 (_vala_dir);
#line 1471 "ListModel.c"
	}
#line 317 "../libcore/ListModel.vala"
	return result;
#line 1475 "ListModel.c"
}

void
files_list_model_load_subdirectory (FilesListModel* self,
                                    FilesDirectory* dir)
{
	GtkTreeIter* parent_iter = NULL;
	GtkTreeIter* child_iter = NULL;
	gboolean change_dummy = FALSE;
	FilesFile* _tmp0_;
	FilesFile* _tmp1_;
	GtkTreeIter* _tmp2_ = NULL;
	gboolean _tmp3_;
#line 320 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 320 "../libcore/ListModel.vala"
	g_return_if_fail (dir != NULL);
#line 321 "../libcore/ListModel.vala"
	parent_iter = NULL;
#line 321 "../libcore/ListModel.vala"
	child_iter = NULL;
#line 322 "../libcore/ListModel.vala"
	change_dummy = TRUE;
#line 323 "../libcore/ListModel.vala"
	_tmp0_ = files_directory_get_file (dir);
#line 323 "../libcore/ListModel.vala"
	_tmp1_ = _tmp0_;
#line 323 "../libcore/ListModel.vala"
	_tmp3_ = files_list_model_get_first_iter_for_file (self, _tmp1_, &_tmp2_);
#line 323 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 323 "../libcore/ListModel.vala"
	parent_iter = _tmp2_;
#line 323 "../libcore/ListModel.vala"
	if (_tmp3_) {
#line 1511 "ListModel.c"
		GList* files = NULL;
		GList* _tmp4_;
		GtkTreeIter* _tmp5_;
		GtkTreeIter _tmp6_ = {0};
		gboolean _tmp7_;
		GtkTreeIter _tmp8_;
		GtkTreeIter* _tmp9_;
		GList* _tmp13_;
#line 324 "../libcore/ListModel.vala"
		_tmp4_ = files_directory_get_files (dir);
#line 324 "../libcore/ListModel.vala"
		files = _tmp4_;
#line 325 "../libcore/ListModel.vala"
		_tmp5_ = parent_iter;
#line 325 "../libcore/ListModel.vala"
		_tmp7_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) self, &_tmp6_, _tmp5_, 0);
#line 325 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 325 "../libcore/ListModel.vala"
		_tmp8_ = _tmp6_;
#line 325 "../libcore/ListModel.vala"
		_tmp9_ = __vala_GtkTreeIter_copy0 (&_tmp8_);
#line 325 "../libcore/ListModel.vala"
		child_iter = _tmp9_;
#line 325 "../libcore/ListModel.vala"
		if (_tmp7_) {
#line 1538 "ListModel.c"
			GtkTreeIter* _tmp10_;
			GtkTreeIter _tmp11_;
			gboolean _tmp12_ = FALSE;
#line 326 "../libcore/ListModel.vala"
			_tmp10_ = child_iter;
#line 326 "../libcore/ListModel.vala"
			_tmp11_ = *_tmp10_;
#line 326 "../libcore/ListModel.vala"
			gtk_tree_model_get ((GtkTreeModel*) self, &_tmp11_, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, &_tmp12_, -1);
#line 326 "../libcore/ListModel.vala"
			change_dummy = _tmp12_;
#line 1550 "ListModel.c"
		} else {
#line 328 "../libcore/ListModel.vala"
			g_critical ("ListModel.vala:328: folder item with no child");
#line 1554 "ListModel.c"
		}
#line 333 "../libcore/ListModel.vala"
		if (!change_dummy) {
#line 334 "../libcore/ListModel.vala"
			(files == NULL) ? NULL : (files = (g_list_free (files), NULL));
#line 334 "../libcore/ListModel.vala"
			__vala_GtkTreeIter_free0 (child_iter);
#line 334 "../libcore/ListModel.vala"
			__vala_GtkTreeIter_free0 (parent_iter);
#line 334 "../libcore/ListModel.vala"
			return;
#line 1566 "ListModel.c"
		}
#line 337 "../libcore/ListModel.vala"
		files_list_model_set_sorting_off (self);
#line 338 "../libcore/ListModel.vala"
		_tmp13_ = files;
#line 1572 "ListModel.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 338 "../libcore/ListModel.vala"
			file_collection = _tmp13_;
#line 338 "../libcore/ListModel.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1580 "ListModel.c"
				FilesFile* file = NULL;
#line 338 "../libcore/ListModel.vala"
				file = (FilesFile*) file_it->data;
#line 1584 "ListModel.c"
				{
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_;
					GeeTreeMap* _tmp29_;
					FilesFile* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					GtkTreeIter* _tmp33_;
					GtkTreeIter _tmp34_;
					GtkTreePath* _tmp35_;
					GtkTreePath* _tmp36_;
					GtkTreeRowReference* _tmp37_;
					GtkTreeRowReference* _tmp38_;
					FilesFile* _tmp39_;
#line 339 "../libcore/ListModel.vala"
					_tmp15_ = self->priv->_show_hidden_files;
#line 339 "../libcore/ListModel.vala"
					if (!_tmp15_) {
#line 1603 "ListModel.c"
						FilesFile* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
#line 339 "../libcore/ListModel.vala"
						_tmp16_ = file;
#line 339 "../libcore/ListModel.vala"
						_tmp17_ = files_file_get_is_hidden (_tmp16_);
#line 339 "../libcore/ListModel.vala"
						_tmp18_ = _tmp17_;
#line 339 "../libcore/ListModel.vala"
						_tmp14_ = _tmp18_;
#line 1615 "ListModel.c"
					} else {
#line 339 "../libcore/ListModel.vala"
						_tmp14_ = FALSE;
#line 1619 "ListModel.c"
					}
#line 339 "../libcore/ListModel.vala"
					if (_tmp14_) {
#line 340 "../libcore/ListModel.vala"
						continue;
#line 1625 "ListModel.c"
					}
#line 343 "../libcore/ListModel.vala"
					if (change_dummy) {
#line 1629 "ListModel.c"
						GtkTreeIter* _tmp19_;
						FilesFile* _tmp20_;
						GtkTreeIter _tmp21_;
#line 345 "../libcore/ListModel.vala"
						_tmp19_ = child_iter;
#line 345 "../libcore/ListModel.vala"
						_tmp20_ = file;
#line 345 "../libcore/ListModel.vala"
						_tmp21_ = *_tmp19_;
#line 345 "../libcore/ListModel.vala"
						gtk_tree_store_set ((GtkTreeStore*) self, &_tmp21_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, _tmp20_, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, FALSE, -1, -1);
#line 346 "../libcore/ListModel.vala"
						change_dummy = FALSE;
#line 1643 "ListModel.c"
					} else {
						GtkTreeIter* _tmp22_;
						GtkTreeIter _tmp23_ = {0};
						GtkTreeIter _tmp24_;
						GtkTreeIter* _tmp25_;
						GtkTreeIter* _tmp26_;
						FilesFile* _tmp27_;
						GtkTreeIter _tmp28_;
#line 348 "../libcore/ListModel.vala"
						_tmp22_ = parent_iter;
#line 348 "../libcore/ListModel.vala"
						gtk_tree_store_insert ((GtkTreeStore*) self, &_tmp23_, _tmp22_, -1);
#line 348 "../libcore/ListModel.vala"
						__vala_GtkTreeIter_free0 (child_iter);
#line 348 "../libcore/ListModel.vala"
						_tmp24_ = _tmp23_;
#line 348 "../libcore/ListModel.vala"
						_tmp25_ = __vala_GtkTreeIter_copy0 (&_tmp24_);
#line 348 "../libcore/ListModel.vala"
						child_iter = _tmp25_;
#line 349 "../libcore/ListModel.vala"
						_tmp26_ = child_iter;
#line 349 "../libcore/ListModel.vala"
						_tmp27_ = file;
#line 349 "../libcore/ListModel.vala"
						_tmp28_ = *_tmp26_;
#line 349 "../libcore/ListModel.vala"
						gtk_tree_store_set ((GtkTreeStore*) self, &_tmp28_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, _tmp27_, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, FALSE, -1, -1);
#line 1672 "ListModel.c"
					}
#line 352 "../libcore/ListModel.vala"
					_tmp29_ = self->priv->file_treerow_map;
#line 352 "../libcore/ListModel.vala"
					_tmp30_ = file;
#line 352 "../libcore/ListModel.vala"
					_tmp31_ = files_file_get_uri (_tmp30_);
#line 352 "../libcore/ListModel.vala"
					_tmp32_ = _tmp31_;
#line 352 "../libcore/ListModel.vala"
					_tmp33_ = child_iter;
#line 352 "../libcore/ListModel.vala"
					_tmp34_ = *_tmp33_;
#line 352 "../libcore/ListModel.vala"
					_tmp35_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp34_);
#line 352 "../libcore/ListModel.vala"
					_tmp36_ = _tmp35_;
#line 352 "../libcore/ListModel.vala"
					_tmp37_ = gtk_tree_row_reference_new ((GtkTreeModel*) self, _tmp36_);
#line 352 "../libcore/ListModel.vala"
					_tmp38_ = _tmp37_;
#line 352 "../libcore/ListModel.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp32_, _tmp38_);
#line 352 "../libcore/ListModel.vala"
					__vala_GtkTreeRowReference_free0 (_tmp38_);
#line 352 "../libcore/ListModel.vala"
					__vala_GtkTreePath_free0 (_tmp36_);
#line 354 "../libcore/ListModel.vala"
					_tmp39_ = file;
#line 354 "../libcore/ListModel.vala"
					if (files_file_is_folder (_tmp39_)) {
#line 1704 "ListModel.c"
						GtkTreeIter* _tmp40_;
						GtkTreeIter _tmp41_ = {0};
						GtkTreeIter _tmp42_;
						GtkTreeIter* _tmp43_;
#line 356 "../libcore/ListModel.vala"
						_tmp40_ = child_iter;
#line 356 "../libcore/ListModel.vala"
						gtk_tree_store_insert_with_values ((GtkTreeStore*) self, &_tmp41_, _tmp40_, -1, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, TRUE, -1);
#line 356 "../libcore/ListModel.vala"
						__vala_GtkTreeIter_free0 (child_iter);
#line 356 "../libcore/ListModel.vala"
						_tmp42_ = _tmp41_;
#line 356 "../libcore/ListModel.vala"
						_tmp43_ = __vala_GtkTreeIter_copy0 (&_tmp42_);
#line 356 "../libcore/ListModel.vala"
						child_iter = _tmp43_;
#line 1721 "ListModel.c"
					}
				}
			}
		}
#line 360 "../libcore/ListModel.vala"
		files_list_model_set_sorting_on (self);
#line 323 "../libcore/ListModel.vala"
		(files == NULL) ? NULL : (files = (g_list_free (files), NULL));
#line 1730 "ListModel.c"
	}
#line 320 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (child_iter);
#line 320 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 1736 "ListModel.c"
}

gboolean
files_list_model_unload_subdirectory (FilesListModel* self,
                                      GtkTreeIter* parent_iter)
{
	FilesFile* file = NULL;
	GtkTreeIter _tmp0_;
	FilesFile* _tmp1_ = NULL;
	FilesFile* _tmp2_;
	gboolean result;
#line 364 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 364 "../libcore/ListModel.vala"
	g_return_val_if_fail (parent_iter != NULL, FALSE);
#line 365 "../libcore/ListModel.vala"
	file = NULL;
#line 366 "../libcore/ListModel.vala"
	_tmp0_ = *parent_iter;
#line 366 "../libcore/ListModel.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp1_, -1);
#line 366 "../libcore/ListModel.vala"
	_g_object_unref0 (file);
#line 366 "../libcore/ListModel.vala"
	file = _tmp1_;
#line 367 "../libcore/ListModel.vala"
	_tmp2_ = file;
#line 367 "../libcore/ListModel.vala"
	if (_tmp2_ != NULL) {
#line 1766 "ListModel.c"
		FilesDirectory* dir = NULL;
		FilesFile* _tmp3_;
		FilesDirectory* _tmp4_;
		FilesDirectory* _tmp5_;
		GtkTreeIter* child_iter = NULL;
		FilesFile* child_file = NULL;
		GtkTreeIter _tmp6_;
		GtkTreeIter _tmp7_ = {0};
		gboolean _tmp8_;
		GtkTreeIter _tmp9_;
		GtkTreeIter* _tmp10_;
		GtkTreeIter _tmp21_;
		GtkTreeIter _tmp22_ = {0};
		GtkTreeIter _tmp23_;
		GtkTreeIter* _tmp24_;
		FilesDirectory* _tmp25_;
#line 368 "../libcore/ListModel.vala"
		_tmp3_ = file;
#line 368 "../libcore/ListModel.vala"
		_tmp4_ = files_directory_from_file (_tmp3_);
#line 368 "../libcore/ListModel.vala"
		dir = _tmp4_;
#line 369 "../libcore/ListModel.vala"
		_tmp5_ = dir;
#line 369 "../libcore/ListModel.vala"
		files_directory_cancel (_tmp5_);
#line 370 "../libcore/ListModel.vala"
		child_iter = NULL;
#line 371 "../libcore/ListModel.vala"
		child_file = NULL;
#line 374 "../libcore/ListModel.vala"
		files_list_model_set_sorting_off (self);
#line 375 "../libcore/ListModel.vala"
		_tmp6_ = *parent_iter;
#line 375 "../libcore/ListModel.vala"
		_tmp8_ = gtk_tree_model_iter_children ((GtkTreeModel*) self, &_tmp7_, &_tmp6_);
#line 375 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 375 "../libcore/ListModel.vala"
		_tmp9_ = _tmp7_;
#line 375 "../libcore/ListModel.vala"
		_tmp10_ = __vala_GtkTreeIter_copy0 (&_tmp9_);
#line 375 "../libcore/ListModel.vala"
		child_iter = _tmp10_;
#line 375 "../libcore/ListModel.vala"
		if (_tmp8_) {
#line 1813 "ListModel.c"
			{
				gboolean _tmp11_ = FALSE;
#line 376 "../libcore/ListModel.vala"
				_tmp11_ = TRUE;
#line 376 "../libcore/ListModel.vala"
				while (TRUE) {
#line 1820 "ListModel.c"
					GtkTreeIter* _tmp13_;
					GtkTreeIter _tmp14_;
					FilesFile* _tmp15_ = NULL;
					FilesFile* _tmp16_;
#line 376 "../libcore/ListModel.vala"
					if (!_tmp11_) {
#line 1827 "ListModel.c"
						gboolean _tmp12_;
#line 381 "../libcore/ListModel.vala"
						_tmp12_ = gtk_tree_store_remove ((GtkTreeStore*) self, child_iter);
#line 381 "../libcore/ListModel.vala"
						if (!_tmp12_) {
#line 381 "../libcore/ListModel.vala"
							break;
#line 1835 "ListModel.c"
						}
					}
#line 376 "../libcore/ListModel.vala"
					_tmp11_ = FALSE;
#line 377 "../libcore/ListModel.vala"
					_tmp13_ = child_iter;
#line 377 "../libcore/ListModel.vala"
					_tmp14_ = *_tmp13_;
#line 377 "../libcore/ListModel.vala"
					gtk_tree_model_get ((GtkTreeModel*) self, &_tmp14_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp15_, -1);
#line 377 "../libcore/ListModel.vala"
					_g_object_unref0 (child_file);
#line 377 "../libcore/ListModel.vala"
					child_file = _tmp15_;
#line 378 "../libcore/ListModel.vala"
					_tmp16_ = child_file;
#line 378 "../libcore/ListModel.vala"
					if (_tmp16_ != NULL) {
#line 1854 "ListModel.c"
						GeeTreeMap* _tmp17_;
						FilesFile* _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
#line 379 "../libcore/ListModel.vala"
						_tmp17_ = self->priv->file_treerow_map;
#line 379 "../libcore/ListModel.vala"
						_tmp18_ = child_file;
#line 379 "../libcore/ListModel.vala"
						_tmp19_ = files_file_get_uri (_tmp18_);
#line 379 "../libcore/ListModel.vala"
						_tmp20_ = _tmp19_;
#line 379 "../libcore/ListModel.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp17_, _tmp20_, NULL);
#line 1869 "ListModel.c"
					}
				}
			}
		}
#line 385 "../libcore/ListModel.vala"
		_tmp21_ = *parent_iter;
#line 385 "../libcore/ListModel.vala"
		gtk_tree_store_insert_with_values ((GtkTreeStore*) self, &_tmp22_, &_tmp21_, -1, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, TRUE, -1);
#line 385 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 385 "../libcore/ListModel.vala"
		_tmp23_ = _tmp22_;
#line 385 "../libcore/ListModel.vala"
		_tmp24_ = __vala_GtkTreeIter_copy0 (&_tmp23_);
#line 385 "../libcore/ListModel.vala"
		child_iter = _tmp24_;
#line 386 "../libcore/ListModel.vala"
		_tmp25_ = dir;
#line 386 "../libcore/ListModel.vala"
		g_signal_emit (self, files_list_model_signals[FILES_LIST_MODEL_SUBDIRECTORY_UNLOADED_SIGNAL], 0, _tmp25_);
#line 387 "../libcore/ListModel.vala"
		files_list_model_set_sorting_on (self);
#line 388 "../libcore/ListModel.vala"
		result = TRUE;
#line 388 "../libcore/ListModel.vala"
		_g_object_unref0 (child_file);
#line 388 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 388 "../libcore/ListModel.vala"
		_g_object_unref0 (dir);
#line 388 "../libcore/ListModel.vala"
		_g_object_unref0 (file);
#line 388 "../libcore/ListModel.vala"
		return result;
#line 1904 "ListModel.c"
	}
#line 391 "../libcore/ListModel.vala"
	result = FALSE;
#line 391 "../libcore/ListModel.vala"
	_g_object_unref0 (file);
#line 391 "../libcore/ListModel.vala"
	return result;
#line 1912 "ListModel.c"
}

gboolean
files_list_model_insert_sorted (FilesListModel* self,
                                FilesFile* file,
                                FilesDirectory* dir)
{
	gboolean result;
#line 394 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../libcore/ListModel.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 394 "../libcore/ListModel.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 395 "../libcore/ListModel.vala"
	if (files_list_model_add_file (self, file, dir)) {
#line 396 "../libcore/ListModel.vala"
		files_list_model_resort (self);
#line 397 "../libcore/ListModel.vala"
		result = TRUE;
#line 397 "../libcore/ListModel.vala"
		return result;
#line 1935 "ListModel.c"
	}
#line 400 "../libcore/ListModel.vala"
	result = FALSE;
#line 400 "../libcore/ListModel.vala"
	return result;
#line 1941 "ListModel.c"
}

gboolean
files_list_model_add_file (FilesListModel* self,
                           FilesFile* file,
                           FilesDirectory* dir)
{
	GtkTreeIter* parent_iter = NULL;
	GtkTreeIter* file_iter = NULL;
	GtkTreeIter* dummy_iter = NULL;
	gboolean change_dummy = FALSE;
	GtkTreeIter* _tmp0_ = NULL;
	gboolean _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	GtkTreeIter* _tmp4_ = NULL;
	gboolean _tmp5_;
	gboolean result;
#line 403 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 403 "../libcore/ListModel.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 403 "../libcore/ListModel.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 405 "../libcore/ListModel.vala"
	change_dummy = FALSE;
#line 407 "../libcore/ListModel.vala"
	_tmp1_ = files_list_model_get_first_iter_for_file (self, file, &_tmp0_);
#line 407 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (file_iter);
#line 407 "../libcore/ListModel.vala"
	file_iter = _tmp0_;
#line 407 "../libcore/ListModel.vala"
	if (_tmp1_) {
#line 408 "../libcore/ListModel.vala"
		result = FALSE;
#line 408 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (dummy_iter);
#line 408 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (file_iter);
#line 408 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 408 "../libcore/ListModel.vala"
		return result;
#line 1986 "ListModel.c"
	}
#line 411 "../libcore/ListModel.vala"
	_tmp2_ = files_directory_get_file (dir);
#line 411 "../libcore/ListModel.vala"
	_tmp3_ = _tmp2_;
#line 411 "../libcore/ListModel.vala"
	_tmp5_ = files_list_model_get_first_iter_for_file (self, _tmp3_, &_tmp4_);
#line 411 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 411 "../libcore/ListModel.vala"
	parent_iter = _tmp4_;
#line 411 "../libcore/ListModel.vala"
	if (_tmp5_) {
#line 2000 "ListModel.c"
		GtkTreeIter* _tmp6_;
		GtkTreeIter _tmp7_ = {0};
		gboolean _tmp8_;
		GtkTreeIter _tmp9_;
		GtkTreeIter* _tmp10_;
#line 412 "../libcore/ListModel.vala"
		_tmp6_ = parent_iter;
#line 412 "../libcore/ListModel.vala"
		_tmp8_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) self, &_tmp7_, _tmp6_, 0);
#line 412 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (file_iter);
#line 412 "../libcore/ListModel.vala"
		_tmp9_ = _tmp7_;
#line 412 "../libcore/ListModel.vala"
		_tmp10_ = __vala_GtkTreeIter_copy0 (&_tmp9_);
#line 412 "../libcore/ListModel.vala"
		file_iter = _tmp10_;
#line 412 "../libcore/ListModel.vala"
		if (_tmp8_) {
#line 2020 "ListModel.c"
			GtkTreeIter* _tmp11_;
			GtkTreeIter _tmp12_;
			gboolean _tmp13_ = FALSE;
#line 413 "../libcore/ListModel.vala"
			_tmp11_ = file_iter;
#line 413 "../libcore/ListModel.vala"
			_tmp12_ = *_tmp11_;
#line 413 "../libcore/ListModel.vala"
			gtk_tree_model_get ((GtkTreeModel*) self, &_tmp12_, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, &_tmp13_, -1);
#line 413 "../libcore/ListModel.vala"
			change_dummy = _tmp13_;
#line 414 "../libcore/ListModel.vala"
			if (change_dummy) {
#line 2034 "ListModel.c"
				GtkTreeIter* _tmp14_;
				GtkTreeIter _tmp15_;
				GeeTreeMap* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				GtkTreeIter* _tmp19_;
				GtkTreeIter _tmp20_;
				GtkTreePath* _tmp21_;
				GtkTreePath* _tmp22_;
				GtkTreeRowReference* _tmp23_;
				GtkTreeRowReference* _tmp24_;
#line 416 "../libcore/ListModel.vala"
				_tmp14_ = file_iter;
#line 416 "../libcore/ListModel.vala"
				_tmp15_ = *_tmp14_;
#line 416 "../libcore/ListModel.vala"
				gtk_tree_store_set ((GtkTreeStore*) self, &_tmp15_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, file, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, FALSE, -1, -1);
#line 417 "../libcore/ListModel.vala"
				_tmp16_ = self->priv->file_treerow_map;
#line 417 "../libcore/ListModel.vala"
				_tmp17_ = files_file_get_uri (file);
#line 417 "../libcore/ListModel.vala"
				_tmp18_ = _tmp17_;
#line 417 "../libcore/ListModel.vala"
				_tmp19_ = file_iter;
#line 417 "../libcore/ListModel.vala"
				_tmp20_ = *_tmp19_;
#line 417 "../libcore/ListModel.vala"
				_tmp21_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp20_);
#line 417 "../libcore/ListModel.vala"
				_tmp22_ = _tmp21_;
#line 417 "../libcore/ListModel.vala"
				_tmp23_ = gtk_tree_row_reference_new ((GtkTreeModel*) self, _tmp22_);
#line 417 "../libcore/ListModel.vala"
				_tmp24_ = _tmp23_;
#line 417 "../libcore/ListModel.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, _tmp18_, _tmp24_);
#line 417 "../libcore/ListModel.vala"
				__vala_GtkTreeRowReference_free0 (_tmp24_);
#line 417 "../libcore/ListModel.vala"
				__vala_GtkTreePath_free0 (_tmp22_);
#line 2076 "ListModel.c"
			}
		} else {
#line 421 "../libcore/ListModel.vala"
			g_critical ("ListModel.vala:421: folder item with no child");
#line 2081 "ListModel.c"
		}
	} else {
#line 424 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 424 "../libcore/ListModel.vala"
		parent_iter = NULL;
#line 2088 "ListModel.c"
	}
#line 427 "../libcore/ListModel.vala"
	if (!change_dummy) {
#line 2092 "ListModel.c"
		GtkTreeIter* _tmp25_;
		GtkTreeIter _tmp26_ = {0};
		GtkTreeIter _tmp27_;
		GtkTreeIter* _tmp28_;
		GeeTreeMap* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		GtkTreeIter* _tmp32_;
		GtkTreeIter _tmp33_;
		GtkTreePath* _tmp34_;
		GtkTreePath* _tmp35_;
		GtkTreeRowReference* _tmp36_;
		GtkTreeRowReference* _tmp37_;
#line 429 "../libcore/ListModel.vala"
		_tmp25_ = parent_iter;
#line 429 "../libcore/ListModel.vala"
		gtk_tree_store_insert_with_values ((GtkTreeStore*) self, &_tmp26_, _tmp25_, -1, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, file, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, FALSE, -1);
#line 429 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (file_iter);
#line 429 "../libcore/ListModel.vala"
		_tmp27_ = _tmp26_;
#line 429 "../libcore/ListModel.vala"
		_tmp28_ = __vala_GtkTreeIter_copy0 (&_tmp27_);
#line 429 "../libcore/ListModel.vala"
		file_iter = _tmp28_;
#line 435 "../libcore/ListModel.vala"
		_tmp29_ = self->priv->file_treerow_map;
#line 435 "../libcore/ListModel.vala"
		_tmp30_ = files_file_get_uri (file);
#line 435 "../libcore/ListModel.vala"
		_tmp31_ = _tmp30_;
#line 435 "../libcore/ListModel.vala"
		_tmp32_ = file_iter;
#line 435 "../libcore/ListModel.vala"
		_tmp33_ = *_tmp32_;
#line 435 "../libcore/ListModel.vala"
		_tmp34_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp33_);
#line 435 "../libcore/ListModel.vala"
		_tmp35_ = _tmp34_;
#line 435 "../libcore/ListModel.vala"
		_tmp36_ = gtk_tree_row_reference_new ((GtkTreeModel*) self, _tmp35_);
#line 435 "../libcore/ListModel.vala"
		_tmp37_ = _tmp36_;
#line 435 "../libcore/ListModel.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp31_, _tmp37_);
#line 435 "../libcore/ListModel.vala"
		__vala_GtkTreeRowReference_free0 (_tmp37_);
#line 435 "../libcore/ListModel.vala"
		__vala_GtkTreePath_free0 (_tmp35_);
#line 2142 "ListModel.c"
	}
#line 438 "../libcore/ListModel.vala"
	if (files_file_is_folder (file)) {
#line 2146 "ListModel.c"
		GtkTreeIter* _tmp38_;
		GtkTreeIter _tmp39_ = {0};
		GtkTreeIter _tmp40_;
		GtkTreeIter* _tmp41_;
#line 440 "../libcore/ListModel.vala"
		_tmp38_ = file_iter;
#line 440 "../libcore/ListModel.vala"
		gtk_tree_store_insert_with_values ((GtkTreeStore*) self, &_tmp39_, _tmp38_, -1, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, TRUE, -1);
#line 440 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (dummy_iter);
#line 440 "../libcore/ListModel.vala"
		_tmp40_ = _tmp39_;
#line 440 "../libcore/ListModel.vala"
		_tmp41_ = __vala_GtkTreeIter_copy0 (&_tmp40_);
#line 440 "../libcore/ListModel.vala"
		dummy_iter = _tmp41_;
#line 2163 "ListModel.c"
	}
#line 443 "../libcore/ListModel.vala"
	result = TRUE;
#line 443 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (dummy_iter);
#line 443 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (file_iter);
#line 443 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 443 "../libcore/ListModel.vala"
	return result;
#line 2175 "ListModel.c"
}

gboolean
files_list_model_remove_file (FilesListModel* self,
                              FilesFile* file,
                              FilesDirectory* dir)
{
	GtkTreeIter* parent_iter = NULL;
	GtkTreeIter* child_iter = NULL;
	GtkTreeIter* file_iter = NULL;
	GtkTreeIter* dummy_iter = NULL;
	GtkTreeIter* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkTreeIter* _tmp2_;
	gboolean result;
#line 447 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 447 "../libcore/ListModel.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 447 "../libcore/ListModel.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 450 "../libcore/ListModel.vala"
	_tmp1_ = files_list_model_get_first_iter_for_file (self, file, &_tmp0_);
#line 450 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (file_iter);
#line 450 "../libcore/ListModel.vala"
	file_iter = _tmp0_;
#line 450 "../libcore/ListModel.vala"
	if (!_tmp1_) {
#line 451 "../libcore/ListModel.vala"
		result = FALSE;
#line 451 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (dummy_iter);
#line 451 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (file_iter);
#line 451 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 451 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 451 "../libcore/ListModel.vala"
		return result;
#line 2217 "ListModel.c"
	}
#line 454 "../libcore/ListModel.vala"
	_tmp2_ = file_iter;
#line 454 "../libcore/ListModel.vala"
	if (_tmp2_ != NULL) {
#line 2223 "ListModel.c"
		FilesFile* _tmp3_;
		FilesFile* _tmp4_;
		GtkTreeIter* _tmp5_ = NULL;
		gboolean _tmp6_;
		GeeTreeMap* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
#line 455 "../libcore/ListModel.vala"
		_tmp3_ = files_directory_get_file (dir);
#line 455 "../libcore/ListModel.vala"
		_tmp4_ = _tmp3_;
#line 455 "../libcore/ListModel.vala"
		_tmp6_ = files_list_model_get_first_iter_for_file (self, _tmp4_, &_tmp5_);
#line 455 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 455 "../libcore/ListModel.vala"
		parent_iter = _tmp5_;
#line 455 "../libcore/ListModel.vala"
		if (_tmp6_) {
#line 2243 "ListModel.c"
			GtkTreeIter* _tmp7_;
			GtkTreeIter _tmp8_ = {0};
			gboolean _tmp9_;
			GtkTreeIter _tmp10_;
			GtkTreeIter* _tmp11_;
#line 456 "../libcore/ListModel.vala"
			_tmp7_ = parent_iter;
#line 456 "../libcore/ListModel.vala"
			_tmp9_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) self, &_tmp8_, _tmp7_, 1);
#line 456 "../libcore/ListModel.vala"
			__vala_GtkTreeIter_free0 (child_iter);
#line 456 "../libcore/ListModel.vala"
			_tmp10_ = _tmp8_;
#line 456 "../libcore/ListModel.vala"
			_tmp11_ = __vala_GtkTreeIter_copy0 (&_tmp10_);
#line 456 "../libcore/ListModel.vala"
			child_iter = _tmp11_;
#line 456 "../libcore/ListModel.vala"
			if (!_tmp9_) {
#line 2263 "ListModel.c"
				GtkTreeIter* _tmp12_;
				GtkTreeIter _tmp13_ = {0};
				GtkTreeIter _tmp14_;
				GtkTreeIter* _tmp15_;
#line 458 "../libcore/ListModel.vala"
				_tmp12_ = parent_iter;
#line 458 "../libcore/ListModel.vala"
				gtk_tree_store_insert_with_values ((GtkTreeStore*) self, &_tmp13_, _tmp12_, -1, FILES_LIST_MODEL_PRIV_COLUMN_ID_DUMMY, TRUE, -1);
#line 458 "../libcore/ListModel.vala"
				__vala_GtkTreeIter_free0 (dummy_iter);
#line 458 "../libcore/ListModel.vala"
				_tmp14_ = _tmp13_;
#line 458 "../libcore/ListModel.vala"
				_tmp15_ = __vala_GtkTreeIter_copy0 (&_tmp14_);
#line 458 "../libcore/ListModel.vala"
				dummy_iter = _tmp15_;
#line 2280 "ListModel.c"
			}
		}
#line 462 "../libcore/ListModel.vala"
		gtk_tree_store_remove ((GtkTreeStore*) self, file_iter);
#line 463 "../libcore/ListModel.vala"
		_tmp16_ = self->priv->file_treerow_map;
#line 463 "../libcore/ListModel.vala"
		_tmp17_ = files_file_get_uri (file);
#line 463 "../libcore/ListModel.vala"
		_tmp18_ = _tmp17_;
#line 463 "../libcore/ListModel.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp16_, _tmp18_, NULL);
#line 464 "../libcore/ListModel.vala"
		result = TRUE;
#line 464 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (dummy_iter);
#line 464 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (file_iter);
#line 464 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (child_iter);
#line 464 "../libcore/ListModel.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 464 "../libcore/ListModel.vala"
		return result;
#line 2305 "ListModel.c"
	}
#line 467 "../libcore/ListModel.vala"
	result = FALSE;
#line 467 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (dummy_iter);
#line 467 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (file_iter);
#line 467 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (child_iter);
#line 467 "../libcore/ListModel.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 467 "../libcore/ListModel.vala"
	return result;
#line 2319 "ListModel.c"
}

void
files_list_model_clear (FilesListModel* self)
{
	GeeTreeMap* _tmp0_;
#line 470 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 471 "../libcore/ListModel.vala"
	_tmp0_ = self->priv->file_treerow_map;
#line 471 "../libcore/ListModel.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 472 "../libcore/ListModel.vala"
	gtk_tree_store_clear (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_store_get_type (), GtkTreeStore));
#line 2334 "ListModel.c"
}

static gint
files_list_model_file_entry_compare_func (FilesListModel* self,
                                          GtkTreeIter* a,
                                          GtkTreeIter* b)
{
	FilesFile* file_a = NULL;
	FilesFile* file_b = NULL;
	GtkTreeIter _tmp0_;
	FilesFile* _tmp1_ = NULL;
	GtkTreeIter _tmp2_;
	FilesFile* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	FilesFile* _tmp7_;
	gint result;
#line 475 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 475 "../libcore/ListModel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 475 "../libcore/ListModel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 476 "../libcore/ListModel.vala"
	file_a = NULL;
#line 477 "../libcore/ListModel.vala"
	file_b = NULL;
#line 478 "../libcore/ListModel.vala"
	_tmp0_ = *a;
#line 478 "../libcore/ListModel.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp1_, -1);
#line 478 "../libcore/ListModel.vala"
	_g_object_unref0 (file_a);
#line 478 "../libcore/ListModel.vala"
	file_a = _tmp1_;
#line 479 "../libcore/ListModel.vala"
	_tmp2_ = *b;
#line 479 "../libcore/ListModel.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp3_, -1);
#line 479 "../libcore/ListModel.vala"
	_g_object_unref0 (file_b);
#line 479 "../libcore/ListModel.vala"
	file_b = _tmp3_;
#line 481 "../libcore/ListModel.vala"
	_tmp7_ = file_a;
#line 481 "../libcore/ListModel.vala"
	if (_tmp7_ != NULL) {
#line 2383 "ListModel.c"
		FilesFile* _tmp8_;
#line 481 "../libcore/ListModel.vala"
		_tmp8_ = file_b;
#line 481 "../libcore/ListModel.vala"
		_tmp6_ = _tmp8_ != NULL;
#line 2389 "ListModel.c"
	} else {
#line 481 "../libcore/ListModel.vala"
		_tmp6_ = FALSE;
#line 2393 "ListModel.c"
	}
#line 481 "../libcore/ListModel.vala"
	if (_tmp6_) {
#line 2397 "ListModel.c"
		FilesFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 482 "../libcore/ListModel.vala"
		_tmp9_ = file_a;
#line 482 "../libcore/ListModel.vala"
		_tmp10_ = files_file_get_location (_tmp9_);
#line 482 "../libcore/ListModel.vala"
		_tmp11_ = _tmp10_;
#line 482 "../libcore/ListModel.vala"
		_tmp5_ = _tmp11_ != NULL;
#line 2409 "ListModel.c"
	} else {
#line 481 "../libcore/ListModel.vala"
		_tmp5_ = FALSE;
#line 2413 "ListModel.c"
	}
#line 481 "../libcore/ListModel.vala"
	if (_tmp5_) {
#line 2417 "ListModel.c"
		FilesFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
#line 482 "../libcore/ListModel.vala"
		_tmp12_ = file_b;
#line 482 "../libcore/ListModel.vala"
		_tmp13_ = files_file_get_location (_tmp12_);
#line 482 "../libcore/ListModel.vala"
		_tmp14_ = _tmp13_;
#line 482 "../libcore/ListModel.vala"
		_tmp4_ = _tmp14_ != NULL;
#line 2429 "ListModel.c"
	} else {
#line 481 "../libcore/ListModel.vala"
		_tmp4_ = FALSE;
#line 2433 "ListModel.c"
	}
#line 481 "../libcore/ListModel.vala"
	if (_tmp4_) {
#line 2437 "ListModel.c"
		gint sort_column_id = 0;
		GtkSortType order = 0;
		gint _tmp15_ = 0;
		GtkSortType _tmp16_ = 0;
		gboolean _tmp17_;
		FilesFile* _tmp18_;
		FilesFile* _tmp19_;
#line 485 "../libcore/ListModel.vala"
		_tmp17_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) self, &_tmp15_, &_tmp16_);
#line 485 "../libcore/ListModel.vala"
		sort_column_id = _tmp15_;
#line 485 "../libcore/ListModel.vala"
		order = _tmp16_;
#line 485 "../libcore/ListModel.vala"
		if (!_tmp17_) {
#line 486 "../libcore/ListModel.vala"
			sort_column_id = (gint) FILES_LIST_MODEL_COLUMN_ID_FILENAME;
#line 487 "../libcore/ListModel.vala"
			order = GTK_SORT_ASCENDING;
#line 2457 "ListModel.c"
		}
#line 490 "../libcore/ListModel.vala"
		_tmp18_ = file_a;
#line 490 "../libcore/ListModel.vala"
		_tmp19_ = file_b;
#line 490 "../libcore/ListModel.vala"
		result = files_file_compare_for_sort (_tmp18_, _tmp19_, sort_column_id, self->priv->sort_directories_first, order == GTK_SORT_DESCENDING);
#line 490 "../libcore/ListModel.vala"
		_g_object_unref0 (file_b);
#line 490 "../libcore/ListModel.vala"
		_g_object_unref0 (file_a);
#line 490 "../libcore/ListModel.vala"
		return result;
#line 2471 "ListModel.c"
	} else {
		gboolean _tmp20_ = FALSE;
		FilesFile* _tmp21_;
#line 491 "../libcore/ListModel.vala"
		_tmp21_ = file_a;
#line 491 "../libcore/ListModel.vala"
		if (_tmp21_ == NULL) {
#line 491 "../libcore/ListModel.vala"
			_tmp20_ = TRUE;
#line 2481 "ListModel.c"
		} else {
			FilesFile* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
#line 491 "../libcore/ListModel.vala"
			_tmp22_ = file_a;
#line 491 "../libcore/ListModel.vala"
			_tmp23_ = files_file_get_location (_tmp22_);
#line 491 "../libcore/ListModel.vala"
			_tmp24_ = _tmp23_;
#line 491 "../libcore/ListModel.vala"
			_tmp20_ = _tmp24_ == NULL;
#line 2494 "ListModel.c"
		}
#line 491 "../libcore/ListModel.vala"
		if (_tmp20_) {
#line 492 "../libcore/ListModel.vala"
			result = -1;
#line 492 "../libcore/ListModel.vala"
			_g_object_unref0 (file_b);
#line 492 "../libcore/ListModel.vala"
			_g_object_unref0 (file_a);
#line 492 "../libcore/ListModel.vala"
			return result;
#line 2506 "ListModel.c"
		} else {
#line 494 "../libcore/ListModel.vala"
			result = 1;
#line 494 "../libcore/ListModel.vala"
			_g_object_unref0 (file_b);
#line 494 "../libcore/ListModel.vala"
			_g_object_unref0 (file_a);
#line 494 "../libcore/ListModel.vala"
			return result;
#line 2516 "ListModel.c"
		}
	}
}

FilesListModel*
files_list_model_construct (GType object_type)
{
	FilesListModel * self = NULL;
#line 19 "../libcore/ListModel.vala"
	self = (FilesListModel*) g_object_new (object_type, NULL);
#line 19 "../libcore/ListModel.vala"
	return self;
#line 2529 "ListModel.c"
}

FilesListModel*
files_list_model_new (void)
{
#line 19 "../libcore/ListModel.vala"
	return files_list_model_construct (FILES_TYPE_LIST_MODEL);
#line 2537 "ListModel.c"
}

gboolean
files_list_model_get_show_hidden_files (FilesListModel* self)
{
	gboolean result;
#line 62 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../libcore/ListModel.vala"
	result = self->priv->_show_hidden_files;
#line 62 "../libcore/ListModel.vala"
	return result;
#line 2550 "ListModel.c"
}

void
files_list_model_set_show_hidden_files (FilesListModel* self,
                                        gboolean value)
{
	gboolean old_value;
#line 62 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 62 "../libcore/ListModel.vala"
	old_value = files_list_model_get_show_hidden_files (self);
#line 62 "../libcore/ListModel.vala"
	if (old_value != value) {
#line 62 "../libcore/ListModel.vala"
		self->priv->_show_hidden_files = value;
#line 62 "../libcore/ListModel.vala"
		g_object_notify_by_pspec ((GObject *) self, files_list_model_properties[FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY]);
#line 2568 "ListModel.c"
	}
}

gint
files_list_model_get_icon_size (FilesListModel* self)
{
	gint result;
#line 70 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../libcore/ListModel.vala"
	result = self->priv->_icon_size;
#line 70 "../libcore/ListModel.vala"
	return result;
#line 2582 "ListModel.c"
}

void
files_list_model_set_icon_size (FilesListModel* self,
                                gint value)
{
	gint old_value;
#line 70 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 70 "../libcore/ListModel.vala"
	old_value = files_list_model_get_icon_size (self);
#line 70 "../libcore/ListModel.vala"
	if (old_value != value) {
#line 70 "../libcore/ListModel.vala"
		self->priv->_icon_size = value;
#line 70 "../libcore/ListModel.vala"
		g_object_notify_by_pspec ((GObject *) self, files_list_model_properties[FILES_LIST_MODEL_ICON_SIZE_PROPERTY]);
#line 2600 "ListModel.c"
	}
}

gboolean
files_list_model_get_has_child (FilesListModel* self)
{
	gboolean result;
#line 71 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../libcore/ListModel.vala"
	result = self->priv->_has_child;
#line 71 "../libcore/ListModel.vala"
	return result;
#line 2614 "ListModel.c"
}

void
files_list_model_set_has_child (FilesListModel* self,
                                gboolean value)
{
	gboolean old_value;
#line 71 "../libcore/ListModel.vala"
	g_return_if_fail (self != NULL);
#line 71 "../libcore/ListModel.vala"
	old_value = files_list_model_get_has_child (self);
#line 71 "../libcore/ListModel.vala"
	if (old_value != value) {
#line 71 "../libcore/ListModel.vala"
		self->priv->_has_child = value;
#line 71 "../libcore/ListModel.vala"
		g_object_notify_by_pspec ((GObject *) self, files_list_model_properties[FILES_LIST_MODEL_HAS_CHILD_PROPERTY]);
#line 2632 "ListModel.c"
	}
}

gboolean
files_list_model_get_sort_pending (FilesListModel* self)
{
	gboolean result;
#line 275 "../libcore/ListModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "../libcore/ListModel.vala"
	result = self->priv->resort_timeout_id > ((guint) 0);
#line 276 "../libcore/ListModel.vala"
	return result;
#line 2646 "ListModel.c"
}

static GtkTreeRowReference*
_vala_GtkTreeRowReference_copy (GtkTreeRowReference* self)
{
#line 78 "../libcore/ListModel.vala"
	return g_boxed_copy (gtk_tree_row_reference_get_type (), self);
#line 2654 "ListModel.c"
}

static GObject *
files_list_model_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesListModel * self;
	GeeTreeMap* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
#line 77 "../libcore/ListModel.vala"
	parent_class = G_OBJECT_CLASS (files_list_model_parent_class);
#line 77 "../libcore/ListModel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 77 "../libcore/ListModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_LIST_MODEL, FilesListModel);
#line 78 "../libcore/ListModel.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_tree_row_reference_get_type (), (GBoxedCopyFunc) _vala_GtkTreeRowReference_copy, (GDestroyNotify) _vala_GtkTreeRowReference_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 78 "../libcore/ListModel.vala"
	_g_object_unref0 (self->priv->file_treerow_map);
#line 78 "../libcore/ListModel.vala"
	self->priv->file_treerow_map = _tmp0_;
#line 80 "../libcore/ListModel.vala"
	_tmp1_ = g_new0 (GType, 8);
#line 80 "../libcore/ListModel.vala"
	_tmp1_[0] = FILES_TYPE_FILE;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[1] = G_TYPE_STRING;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[2] = gdk_pixbuf_get_type ();
#line 80 "../libcore/ListModel.vala"
	_tmp1_[3] = G_TYPE_STRING;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[4] = G_TYPE_STRING;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[5] = G_TYPE_STRING;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[6] = G_TYPE_STRING;
#line 80 "../libcore/ListModel.vala"
	_tmp1_[7] = G_TYPE_BOOLEAN;
#line 80 "../libcore/ListModel.vala"
	_tmp2_ = _tmp1_;
#line 80 "../libcore/ListModel.vala"
	_tmp2__length1 = 8;
#line 80 "../libcore/ListModel.vala"
	gtk_tree_store_set_column_types ((GtkTreeStore*) self, (gint) 8, _tmp2_);
#line 80 "../libcore/ListModel.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 91 "../libcore/ListModel.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) FILES_LIST_MODEL_COLUMN_ID_FILENAME, GTK_SORT_ASCENDING);
#line 95 "../libcore/ListModel.vala"
	files_list_model_set_sorting_off (self);
#line 77 "../libcore/ListModel.vala"
	return obj;
#line 2713 "ListModel.c"
}

static void
files_list_model_class_init (FilesListModelClass * klass,
                             gpointer klass_data)
{
#line 19 "../libcore/ListModel.vala"
	files_list_model_parent_class = g_type_class_peek_parent (klass);
#line 19 "../libcore/ListModel.vala"
	g_type_class_adjust_private_offset (klass, &FilesListModel_private_offset);
#line 19 "../libcore/ListModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_list_model_get_property;
#line 19 "../libcore/ListModel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_list_model_set_property;
#line 19 "../libcore/ListModel.vala"
	G_OBJECT_CLASS (klass)->constructor = files_list_model_constructor;
#line 19 "../libcore/ListModel.vala"
	G_OBJECT_CLASS (klass)->finalize = files_list_model_finalize;
#line 19 "../libcore/ListModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY, files_list_model_properties[FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY] = g_param_spec_boolean ("show-hidden-files", "show-hidden-files", "show-hidden-files", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/ListModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_LIST_MODEL_ICON_SIZE_PROPERTY, files_list_model_properties[FILES_LIST_MODEL_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 32, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/ListModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_LIST_MODEL_HAS_CHILD_PROPERTY, files_list_model_properties[FILES_LIST_MODEL_HAS_CHILD_PROPERTY] = g_param_spec_boolean ("has-child", "has-child", "has-child", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/ListModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_LIST_MODEL_SORT_PENDING_PROPERTY, files_list_model_properties[FILES_LIST_MODEL_SORT_PENDING_PROPERTY] = g_param_spec_boolean ("sort-pending", "sort-pending", "sort-pending", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../libcore/ListModel.vala"
	files_list_model_signals[FILES_LIST_MODEL_SUBDIRECTORY_UNLOADED_SIGNAL] = g_signal_new ("subdirectory-unloaded", FILES_TYPE_LIST_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, FILES_TYPE_DIRECTORY);
#line 2742 "ListModel.c"
}

static void
files_list_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                gpointer iface_data)
{
#line 19 "../libcore/ListModel.vala"
	files_list_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../libcore/ListModel.vala"
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) files_list_model_real_get_value;
#line 2753 "ListModel.c"
}

static void
files_list_model_instance_init (FilesListModel * self,
                                gpointer klass)
{
#line 19 "../libcore/ListModel.vala"
	self->priv = files_list_model_get_instance_private (self);
#line 62 "../libcore/ListModel.vala"
	self->priv->_show_hidden_files = FALSE;
#line 70 "../libcore/ListModel.vala"
	self->priv->_icon_size = 32;
#line 71 "../libcore/ListModel.vala"
	self->priv->_has_child = FALSE;
#line 73 "../libcore/ListModel.vala"
	self->priv->sort_directories_first = TRUE;
#line 272 "../libcore/ListModel.vala"
	self->priv->resort_timeout_id = (guint) 0;
#line 273 "../libcore/ListModel.vala"
	self->priv->delay_resort = TRUE;
#line 2774 "ListModel.c"
}

static void
files_list_model_finalize (GObject * obj)
{
	FilesListModel * self;
#line 19 "../libcore/ListModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_LIST_MODEL, FilesListModel);
#line 75 "../libcore/ListModel.vala"
	_g_object_unref0 (self->priv->file_treerow_map);
#line 19 "../libcore/ListModel.vala"
	G_OBJECT_CLASS (files_list_model_parent_class)->finalize (obj);
#line 2787 "ListModel.c"
}

 G_GNUC_NO_INLINE static GType
files_list_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesListModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_list_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesListModel), 0, (GInstanceInitFunc) files_list_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) files_list_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType files_list_model_type_id;
	files_list_model_type_id = g_type_register_static (gtk_tree_store_get_type (), "FilesListModel", &g_define_type_info, 0);
	g_type_add_interface_static (files_list_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	FilesListModel_private_offset = g_type_add_instance_private (files_list_model_type_id, sizeof (FilesListModelPrivate));
	return files_list_model_type_id;
}

GType
files_list_model_get_type (void)
{
	static volatile gsize files_list_model_type_id__once = 0;
	if (g_once_init_enter (&files_list_model_type_id__once)) {
		GType files_list_model_type_id;
		files_list_model_type_id = files_list_model_get_type_once ();
		g_once_init_leave (&files_list_model_type_id__once, files_list_model_type_id);
	}
	return files_list_model_type_id__once;
}

static void
_vala_files_list_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	FilesListModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_LIST_MODEL, FilesListModel);
#line 19 "../libcore/ListModel.vala"
	switch (property_id) {
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		g_value_set_boolean (value, files_list_model_get_show_hidden_files (self));
#line 19 "../libcore/ListModel.vala"
		break;
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_ICON_SIZE_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		g_value_set_int (value, files_list_model_get_icon_size (self));
#line 19 "../libcore/ListModel.vala"
		break;
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_HAS_CHILD_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		g_value_set_boolean (value, files_list_model_get_has_child (self));
#line 19 "../libcore/ListModel.vala"
		break;
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_SORT_PENDING_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		g_value_set_boolean (value, files_list_model_get_sort_pending (self));
#line 19 "../libcore/ListModel.vala"
		break;
#line 2848 "ListModel.c"
		default:
#line 19 "../libcore/ListModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../libcore/ListModel.vala"
		break;
#line 2854 "ListModel.c"
	}
}

static void
_vala_files_list_model_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	FilesListModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_LIST_MODEL, FilesListModel);
#line 19 "../libcore/ListModel.vala"
	switch (property_id) {
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_SHOW_HIDDEN_FILES_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		files_list_model_set_show_hidden_files (self, g_value_get_boolean (value));
#line 19 "../libcore/ListModel.vala"
		break;
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_ICON_SIZE_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		files_list_model_set_icon_size (self, g_value_get_int (value));
#line 19 "../libcore/ListModel.vala"
		break;
#line 19 "../libcore/ListModel.vala"
		case FILES_LIST_MODEL_HAS_CHILD_PROPERTY:
#line 19 "../libcore/ListModel.vala"
		files_list_model_set_has_child (self, g_value_get_boolean (value));
#line 19 "../libcore/ListModel.vala"
		break;
#line 2886 "ListModel.c"
		default:
#line 19 "../libcore/ListModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../libcore/ListModel.vala"
		break;
#line 2892 "ListModel.c"
	}
}

