/* Portal.c generated by valac 0.56.17, the Vala compiler
 * generated from Portal.vala, do not modify */

/*-
 * Copyright (c) 2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "pantheon-files-send-by-email.h"
#include <gio/gunixfdlist.h>

#define PORTAL_DBUS_DESKTOP_PATH "/org/freedesktop/portal/desktop"
#define PORTAL_DBUS_DESKTOP_NAME "org.freedesktop.portal.Desktop"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define PORTAL_TYPE_EMAIL (portal_email_get_type ())
#define PORTAL_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PORTAL_TYPE_EMAIL, PortalEmail))
#define PORTAL_IS_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PORTAL_TYPE_EMAIL))
#define PORTAL_EMAIL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PORTAL_TYPE_EMAIL, PortalEmailIface))

typedef struct _PortalEmail PortalEmail;
typedef struct _PortalEmailIface PortalEmailIface;

#define PORTAL_TYPE_EMAIL_PROXY (portal_email_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef GDBusProxy PortalEmailProxy;
typedef GDBusProxyClass PortalEmailProxyClass;

struct _PortalEmailIface {
	GTypeInterface parent_iface;
	guint (*get_version) (PortalEmail* self);
};

struct _Block4Data {
	int _ref_count_;
	PortalEmail* self;
	GVariantBuilder* options_builder;
};

VALA_EXTERN PortalEmail* portal_email;
PortalEmail* portal_email = NULL;

VALA_EXTERN GType portal_email_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType portal_email_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint portal_email_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN PortalEmail* portal_email_get (GError** error);
VALA_EXTERN char* portal_email_compose_email (PortalEmail* self,
                                  const gchar* window_handle,
                                  GHashTable* options,
                                  GUnixFDList* attachments,
                                  GError** error);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda4_ (Block4Data* _data4_,
                 const gchar* key,
                 GVariant* val);
static void ___lambda4__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
VALA_EXTERN guint portal_email_get_version (PortalEmail* self);
static GType portal_email_get_type_once (void);
static void portal_email_proxy_g_signal (GDBusProxy* proxy,
                                  const gchar* sender_name,
                                  const gchar* signal_name,
                                  GVariant* parameters);
static guint portal_email_dbus_proxy_get_version (PortalEmail* self);
static void portal_email_proxy_portal_email_interface_init (PortalEmailIface* iface);
static void portal_email_dbus_interface_method_call (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* method_name,
                                              GVariant* parameters,
                                              GDBusMethodInvocation* invocation,
                                              gpointer user_data);
static GVariant* portal_email_dbus_interface_get_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GError** error,
                                                    gpointer user_data);
static GVariant* _dbus_portal_email_get_version (PortalEmail* self);
static gboolean portal_email_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data);
static void _portal_email_unregister_object (gpointer user_data);

static const GDBusMethodInfo * const _portal_email_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _portal_email_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _portal_email_dbus_property_info_version = {-1, "version", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _portal_email_dbus_property_info[] = {&_portal_email_dbus_property_info_version, NULL};
static const GDBusInterfaceInfo _portal_email_dbus_interface_info = {-1, "org.freedesktop.portal.Email", (GDBusMethodInfo **) (&_portal_email_dbus_method_info), (GDBusSignalInfo **) (&_portal_email_dbus_signal_info), (GDBusPropertyInfo **) (&_portal_email_dbus_property_info), NULL};
static const GDBusInterfaceVTable _portal_email_dbus_interface_vtable = {portal_email_dbus_interface_method_call, portal_email_dbus_interface_get_property, portal_email_dbus_interface_set_property};

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 153 "Portal.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 157 "Portal.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 163 "Portal.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 167 "Portal.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 171 "Portal.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 179 "Portal.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 207 "Portal.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 216 "Portal.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 230 "Portal.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 239 "Portal.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 253 "Portal.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 262 "Portal.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 271 "Portal.c"
}

gchar*
portal_generate_token (void)
{
	GApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp0_ = g_application_get_default ();
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp1_ = g_application_get_application_id (_tmp0_);
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp2_ = _tmp1_;
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp3_ = string_replace (_tmp2_, ".", "_");
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp4_ = _tmp3_;
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp5_ = g_strdup_printf ("%s_%i", _tmp4_, (gint) g_random_int_range ((gint32) 0, G_MAXINT32));
#line 24 "../plugins/send-by-email/Portal.vala"
	_tmp6_ = _tmp5_;
#line 24 "../plugins/send-by-email/Portal.vala"
	_g_free0 (_tmp4_);
#line 24 "../plugins/send-by-email/Portal.vala"
	result = _tmp6_;
#line 24 "../plugins/send-by-email/Portal.vala"
	return result;
#line 305 "Portal.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../plugins/send-by-email/Portal.vala"
	return self ? g_object_ref (self) : NULL;
#line 313 "Portal.c"
}

PortalEmail*
portal_email_get (GError** error)
{
	PortalEmail* _tmp0_;
	PortalEmail* _tmp8_;
	PortalEmail* _tmp9_;
	GError* _inner_error0_ = NULL;
	PortalEmail* result;
#line 36 "../plugins/send-by-email/Portal.vala"
	_tmp0_ = portal_email;
#line 36 "../plugins/send-by-email/Portal.vala"
	if (_tmp0_ == NULL) {
#line 328 "Portal.c"
		GDBusConnection* connection = NULL;
		GApplication* _tmp1_;
		GDBusConnection* _tmp2_;
		GDBusConnection* _tmp3_;
		PortalEmail* _tmp4_ = NULL;
		GDBusConnection* _tmp5_;
		PortalEmail* _tmp6_;
		PortalEmail* _tmp7_;
#line 37 "../plugins/send-by-email/Portal.vala"
		_tmp1_ = g_application_get_default ();
#line 37 "../plugins/send-by-email/Portal.vala"
		_tmp2_ = g_application_get_dbus_connection (_tmp1_);
#line 37 "../plugins/send-by-email/Portal.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 37 "../plugins/send-by-email/Portal.vala"
		connection = _tmp3_;
#line 38 "../plugins/send-by-email/Portal.vala"
		_tmp5_ = connection;
#line 38 "../plugins/send-by-email/Portal.vala"
		_tmp6_ = (PortalEmail*) g_initable_new (PORTAL_TYPE_EMAIL_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", PORTAL_DBUS_DESKTOP_NAME, "g-connection", _tmp5_, "g-object-path", PORTAL_DBUS_DESKTOP_PATH, "g-interface-name", "org.freedesktop.portal.Email", NULL);
#line 38 "../plugins/send-by-email/Portal.vala"
		_tmp4_ = (PortalEmail*) _tmp6_;
#line 38 "../plugins/send-by-email/Portal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../plugins/send-by-email/Portal.vala"
			if ((_inner_error0_->domain == G_IO_ERROR) || (_inner_error0_->domain == G_DBUS_ERROR)) {
#line 38 "../plugins/send-by-email/Portal.vala"
				g_propagate_error (error, _inner_error0_);
#line 38 "../plugins/send-by-email/Portal.vala"
				_g_object_unref0 (connection);
#line 38 "../plugins/send-by-email/Portal.vala"
				return NULL;
#line 361 "Portal.c"
			} else {
#line 38 "../plugins/send-by-email/Portal.vala"
				_g_object_unref0 (connection);
#line 38 "../plugins/send-by-email/Portal.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../plugins/send-by-email/Portal.vala"
				g_clear_error (&_inner_error0_);
#line 38 "../plugins/send-by-email/Portal.vala"
				return NULL;
#line 371 "Portal.c"
			}
		}
#line 38 "../plugins/send-by-email/Portal.vala"
		_tmp7_ = _tmp4_;
#line 38 "../plugins/send-by-email/Portal.vala"
		_tmp4_ = NULL;
#line 38 "../plugins/send-by-email/Portal.vala"
		_g_object_unref0 (portal_email);
#line 38 "../plugins/send-by-email/Portal.vala"
		portal_email = _tmp7_;
#line 36 "../plugins/send-by-email/Portal.vala"
		_g_object_unref0 (_tmp4_);
#line 36 "../plugins/send-by-email/Portal.vala"
		_g_object_unref0 (connection);
#line 386 "Portal.c"
	}
#line 41 "../plugins/send-by-email/Portal.vala"
	_tmp8_ = portal_email;
#line 41 "../plugins/send-by-email/Portal.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 41 "../plugins/send-by-email/Portal.vala"
	result = _tmp9_;
#line 41 "../plugins/send-by-email/Portal.vala"
	return result;
#line 396 "Portal.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 45 "../plugins/send-by-email/Portal.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 45 "../plugins/send-by-email/Portal.vala"
	return _data4_;
#line 406 "Portal.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 45 "../plugins/send-by-email/Portal.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 416 "Portal.c"
		PortalEmail* self;
#line 45 "../plugins/send-by-email/Portal.vala"
		self = _data4_->self;
#line 45 "../plugins/send-by-email/Portal.vala"
		_g_variant_builder_unref0 (_data4_->options_builder);
#line 45 "../plugins/send-by-email/Portal.vala"
		_g_object_unref0 (self);
#line 45 "../plugins/send-by-email/Portal.vala"
		g_slice_free (Block4Data, _data4_);
#line 426 "Portal.c"
	}
}

static void
__lambda4_ (Block4Data* _data4_,
            const gchar* key,
            GVariant* val)
{
	PortalEmail* self;
#line 47 "../plugins/send-by-email/Portal.vala"
	self = _data4_->self;
#line 47 "../plugins/send-by-email/Portal.vala"
	g_return_if_fail (key != NULL);
#line 47 "../plugins/send-by-email/Portal.vala"
	g_return_if_fail (val != NULL);
#line 48 "../plugins/send-by-email/Portal.vala"
	g_variant_builder_add (_data4_->options_builder, "{sv}", key, val, NULL);
#line 444 "Portal.c"
}

static void
___lambda4__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
#line 47 "../plugins/send-by-email/Portal.vala"
	__lambda4_ (self, (const gchar*) key, (GVariant*) value);
#line 454 "Portal.c"
}

char*
portal_email_compose_email (PortalEmail* self,
                            const gchar* window_handle,
                            GHashTable* options,
                            GUnixFDList* attachments,
                            GError** error)
{
	Block4Data* _data4_;
	const GVariantType* _tmp0_;
	GVariantBuilder* _tmp1_;
	GVariant* response = NULL;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	const gchar* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	GError* _inner_error0_ = NULL;
	char* result;
#line 45 "../plugins/send-by-email/Portal.vala"
	g_return_val_if_fail (window_handle != NULL, NULL);
#line 45 "../plugins/send-by-email/Portal.vala"
	g_return_val_if_fail (options != NULL, NULL);
#line 45 "../plugins/send-by-email/Portal.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 45 "../plugins/send-by-email/Portal.vala"
	_data4_->_ref_count_ = 1;
#line 45 "../plugins/send-by-email/Portal.vala"
	_data4_->self = g_object_ref (self);
#line 46 "../plugins/send-by-email/Portal.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 46 "../plugins/send-by-email/Portal.vala"
	_tmp1_ = g_variant_builder_new (_tmp0_);
#line 46 "../plugins/send-by-email/Portal.vala"
	_data4_->options_builder = _tmp1_;
#line 47 "../plugins/send-by-email/Portal.vala"
	g_hash_table_foreach (options, ___lambda4__gh_func, _data4_);
#line 51 "../plugins/send-by-email/Portal.vala"
	_tmp2_ = g_variant_new ("(sa{sv})", window_handle, _data4_->options_builder, NULL);
#line 51 "../plugins/send-by-email/Portal.vala"
	g_variant_ref_sink (_tmp2_);
#line 51 "../plugins/send-by-email/Portal.vala"
	_tmp3_ = _tmp2_;
#line 51 "../plugins/send-by-email/Portal.vala"
	_tmp4_ = g_dbus_proxy_call_with_unix_fd_list_sync ((GDBusProxy*) self, "ComposeEmail", _tmp3_, G_DBUS_CALL_FLAGS_NONE, -1, attachments, NULL, NULL, &_inner_error0_);
#line 51 "../plugins/send-by-email/Portal.vala"
	_tmp5_ = _tmp4_;
#line 51 "../plugins/send-by-email/Portal.vala"
	_g_variant_unref0 (_tmp3_);
#line 51 "../plugins/send-by-email/Portal.vala"
	response = _tmp5_;
#line 51 "../plugins/send-by-email/Portal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../plugins/send-by-email/Portal.vala"
		g_propagate_error (error, _inner_error0_);
#line 51 "../plugins/send-by-email/Portal.vala"
		block4_data_unref (_data4_);
#line 51 "../plugins/send-by-email/Portal.vala"
		_data4_ = NULL;
#line 51 "../plugins/send-by-email/Portal.vala"
		return NULL;
#line 521 "Portal.c"
	}
#line 59 "../plugins/send-by-email/Portal.vala"
	_tmp6_ = g_variant_get_child_value (response, (gsize) 0);
#line 59 "../plugins/send-by-email/Portal.vala"
	_tmp7_ = _tmp6_;
#line 59 "../plugins/send-by-email/Portal.vala"
	_tmp8_ = g_variant_get_string (_tmp7_, NULL);
#line 59 "../plugins/send-by-email/Portal.vala"
	_tmp9_ = g_strdup ((const char*) _tmp8_);
#line 59 "../plugins/send-by-email/Portal.vala"
	_tmp10_ = _tmp9_;
#line 59 "../plugins/send-by-email/Portal.vala"
	_g_variant_unref0 (_tmp7_);
#line 59 "../plugins/send-by-email/Portal.vala"
	result = _tmp10_;
#line 59 "../plugins/send-by-email/Portal.vala"
	_g_variant_unref0 (response);
#line 59 "../plugins/send-by-email/Portal.vala"
	block4_data_unref (_data4_);
#line 59 "../plugins/send-by-email/Portal.vala"
	_data4_ = NULL;
#line 59 "../plugins/send-by-email/Portal.vala"
	return result;
#line 545 "Portal.c"
}

guint
portal_email_get_version (PortalEmail* self)
{
	PortalEmailIface* _iface_;
#line 33 "../plugins/send-by-email/Portal.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../plugins/send-by-email/Portal.vala"
	_iface_ = PORTAL_EMAIL_GET_INTERFACE (self);
#line 33 "../plugins/send-by-email/Portal.vala"
	if (_iface_->get_version) {
#line 33 "../plugins/send-by-email/Portal.vala"
		return _iface_->get_version (self);
#line 560 "Portal.c"
	}
#line 33 "../plugins/send-by-email/Portal.vala"
	return 0U;
#line 564 "Portal.c"
}

static void
portal_email_default_init (PortalEmailIface * iface,
                           gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
portal_email_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PortalEmailIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) portal_email_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType portal_email_type_id;
	portal_email_type_id = g_type_register_static (G_TYPE_INTERFACE, "PortalEmail", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (portal_email_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (portal_email_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) portal_email_proxy_get_type);
	g_type_set_qdata (portal_email_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.portal.Email");
	g_type_set_qdata (portal_email_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_portal_email_dbus_interface_info));
	g_type_set_qdata (portal_email_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) portal_email_register_object);
	return portal_email_type_id;
}

GType
portal_email_get_type (void)
{
	static volatile gsize portal_email_type_id__once = 0;
	if (g_once_init_enter (&portal_email_type_id__once)) {
		GType portal_email_type_id;
		portal_email_type_id = portal_email_get_type_once ();
		g_once_init_leave (&portal_email_type_id__once, portal_email_type_id);
	}
	return portal_email_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (PortalEmailProxy, portal_email_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (PORTAL_TYPE_EMAIL, portal_email_proxy_portal_email_interface_init) )
static void
portal_email_proxy_class_init (PortalEmailProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = portal_email_proxy_g_signal;
}

static void
portal_email_proxy_g_signal (GDBusProxy* proxy,
                             const gchar* sender_name,
                             const gchar* signal_name,
                             GVariant* parameters)
{
}

static void
portal_email_proxy_init (PortalEmailProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_portal_email_dbus_interface_info));
}

static guint
portal_email_dbus_proxy_get_version (PortalEmail* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "version");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.portal.Email"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("version"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp0_ = 0U;
			return _tmp0_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
portal_email_proxy_portal_email_interface_init (PortalEmailIface* iface)
{
	iface->get_version = portal_email_dbus_proxy_get_version;
}

static void
portal_email_dbus_interface_method_call (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* method_name,
                                         GVariant* parameters,
                                         GDBusMethodInvocation* invocation,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_portal_email_get_version (PortalEmail* self)
{
	guint result;
	GVariant* _reply;
	result = portal_email_get_version (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
portal_email_dbus_interface_get_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "version") == 0) {
		return _dbus_portal_email_get_version (object);
	}
	return NULL;
}

static gboolean
portal_email_dbus_interface_set_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GVariant* value,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
portal_email_register_object (gpointer object,
                              GDBusConnection* connection,
                              const gchar* path,
                              GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_portal_email_dbus_interface_info), &_portal_email_dbus_interface_vtable, data, _portal_email_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_portal_email_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

