/* File.c generated by valac 0.56.17, the Vala compiler
 * generated from File.vala, do not modify */

/* Copyright (c) 2018-20 elementary LLC (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "pantheon-files-core.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <gio/gdesktopappinfo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FILES_FILE_0_PROPERTY,
	FILES_FILE_LOCATION_PROPERTY,
	FILES_FILE_DIRECTORY_PROPERTY,
	FILES_FILE_BASENAME_PROPERTY,
	FILES_FILE_URI_PROPERTY,
	FILES_FILE_COLOR_PROPERTY,
	FILES_FILE_IS_HIDDEN_PROPERTY,
	FILES_FILE_THUMBNAIL_PATH_PROPERTY,
	FILES_FILE_EXISTS_PROPERTY,
	FILES_FILE_NUM_PROPERTIES
};
static GParamSpec* files_file_properties[FILES_FILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	FILES_FILE_CHANGED_SIGNAL,
	FILES_FILE_ICON_CHANGED_SIGNAL,
	FILES_FILE_DESTROY_SIGNAL,
	FILES_FILE_NUM_SIGNALS
};
static guint files_file_signals[FILES_FILE_NUM_SIGNALS] = {0};

struct _FilesFilePrivate {
	GFile* _location;
	GFile* _directory;
	gchar* _basename;
	gchar* _uri;
	gint _color;
	gboolean pix_is_final;
	gboolean _is_hidden;
	gchar* _thumbnail_path;
	gboolean _exists;
};

static gint FilesFile_private_offset;
static gpointer files_file_parent_class = NULL;
static GHashTable* files_file_file_cache;
static GRecMutex __lock_files_file_files_file_file_cache = {0};
static GHashTable* files_file_file_cache = NULL;

static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static guint _g_file_hash_ghash_func (gconstpointer key);
static gboolean _g_file_equal_gequal_func (gconstpointer a,
                                    gconstpointer b);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static guint files_file_get_number_of_uri_parts (FilesFile* self);
static gboolean files_file_is_location_uri_default (FilesFile* self);
static FilesIconInfo* files_file_get_icon (FilesFile* self,
                                    gint requested_size,
                                    gint scale,
                                    FilesFileIconFlags flags);
static void files_file_clear_info (FilesFile* self);
static void files_file_target_location_update (FilesFile* self);
static void files_file_update_formated_type (FilesFile* self);
static GFileInfo* files_file_query_info (FilesFile* self);
static void files_file_ensure_item_count (FilesFile* self,
                                   gboolean recount);
static GObject * files_file_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _files_file___lambda9_ (FilesFile* self);
static void __files_file___lambda9__files_file_icon_changed (FilesFile* _sender,
                                                      gpointer self);
static void files_file_finalize (GObject * obj);
static GType files_file_get_type_once (void);
static void _vala_files_file_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_files_file_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
files_file_get_instance_private (FilesFile* self)
{
	return G_STRUCT_MEMBER_P (self, FilesFile_private_offset);
}

 G_GNUC_NO_INLINE static GType
files_file_icon_flags_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_FILE_ICON_FLAGS_NONE, "FILES_FILE_ICON_FLAGS_NONE", "none"}, {FILES_FILE_ICON_FLAGS_USE_THUMBNAILS, "FILES_FILE_ICON_FLAGS_USE_THUMBNAILS", "use-thumbnails"}, {0, NULL, NULL}};
	GType files_file_icon_flags_type_id;
	files_file_icon_flags_type_id = g_enum_register_static ("FilesFileIconFlags", values);
	return files_file_icon_flags_type_id;
}

GType
files_file_icon_flags_get_type (void)
{
	static volatile gsize files_file_icon_flags_type_id__once = 0;
	if (g_once_init_enter (&files_file_icon_flags_type_id__once)) {
		GType files_file_icon_flags_type_id;
		files_file_icon_flags_type_id = files_file_icon_flags_get_type_once ();
		g_once_init_leave (&files_file_icon_flags_type_id__once, files_file_icon_flags_type_id);
	}
	return files_file_icon_flags_type_id__once;
}

 G_GNUC_NO_INLINE static GType
files_file_thumb_state_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_FILE_THUMB_STATE_UNKNOWN, "FILES_FILE_THUMB_STATE_UNKNOWN", "unknown"}, {FILES_FILE_THUMB_STATE_NONE, "FILES_FILE_THUMB_STATE_NONE", "none"}, {FILES_FILE_THUMB_STATE_READY, "FILES_FILE_THUMB_STATE_READY", "ready"}, {FILES_FILE_THUMB_STATE_LOADING, "FILES_FILE_THUMB_STATE_LOADING", "loading"}, {0, NULL, NULL}};
	GType files_file_thumb_state_type_id;
	files_file_thumb_state_type_id = g_enum_register_static ("FilesFileThumbState", values);
	return files_file_thumb_state_type_id;
}

GType
files_file_thumb_state_get_type (void)
{
	static volatile gsize files_file_thumb_state_type_id__once = 0;
	if (g_once_init_enter (&files_file_thumb_state_type_id__once)) {
		GType files_file_thumb_state_type_id;
		files_file_thumb_state_type_id = files_file_thumb_state_get_type_once ();
		g_once_init_leave (&files_file_thumb_state_type_id__once, files_file_thumb_state_type_id);
	}
	return files_file_thumb_state_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 53 "../libcore/File.vala"
	var = (g_free (var), NULL);
#line 186 "File.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 53 "../libcore/File.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 194 "File.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 150 "../libcore/File.vala"
	return self ? g_object_ref (self) : NULL;
#line 202 "File.c"
}

FilesFile*
files_file_get (GFile* location)
{
	GFile* parent = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	FilesFile* file = NULL;
	FilesFile* _tmp8_;
	FilesFile* _tmp9_;
	GError* _inner_error0_ = NULL;
	FilesFile* result;
#line 134 "../libcore/File.vala"
	g_return_val_if_fail (location != NULL, NULL);
#line 135 "../libcore/File.vala"
	_tmp0_ = g_file_get_parent (location);
#line 135 "../libcore/File.vala"
	parent = _tmp0_;
#line 136 "../libcore/File.vala"
	_tmp1_ = parent;
#line 136 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 226 "File.c"
		FilesDirectory* dir = NULL;
		GFile* _tmp2_;
		FilesDirectory* _tmp3_;
		FilesDirectory* _tmp4_;
#line 137 "../libcore/File.vala"
		_tmp2_ = parent;
#line 137 "../libcore/File.vala"
		_tmp3_ = files_directory_cache_lookup (_tmp2_);
#line 137 "../libcore/File.vala"
		dir = _tmp3_;
#line 138 "../libcore/File.vala"
		_tmp4_ = dir;
#line 138 "../libcore/File.vala"
		if (_tmp4_ != NULL) {
#line 241 "File.c"
			FilesFile* file = NULL;
			FilesDirectory* _tmp5_;
			FilesFile* _tmp6_;
			FilesFile* _tmp7_;
#line 139 "../libcore/File.vala"
			_tmp5_ = dir;
#line 139 "../libcore/File.vala"
			_tmp6_ = files_directory_file_hash_lookup_location (_tmp5_, location);
#line 139 "../libcore/File.vala"
			file = _tmp6_;
#line 140 "../libcore/File.vala"
			_tmp7_ = file;
#line 140 "../libcore/File.vala"
			if (_tmp7_ != NULL) {
#line 141 "../libcore/File.vala"
				result = file;
#line 141 "../libcore/File.vala"
				_g_object_unref0 (dir);
#line 141 "../libcore/File.vala"
				_g_object_unref0 (parent);
#line 141 "../libcore/File.vala"
				return result;
#line 264 "File.c"
			}
#line 138 "../libcore/File.vala"
			_g_object_unref0 (file);
#line 268 "File.c"
		}
#line 136 "../libcore/File.vala"
		_g_object_unref0 (dir);
#line 272 "File.c"
	}
#line 146 "../libcore/File.vala"
	_tmp8_ = files_file_cache_lookup (location);
#line 146 "../libcore/File.vala"
	file = _tmp8_;
#line 147 "../libcore/File.vala"
	_tmp9_ = file;
#line 147 "../libcore/File.vala"
	if (_tmp9_ == NULL) {
#line 282 "File.c"
		GFile* _tmp10_;
		FilesFile* _tmp11_;
#line 148 "../libcore/File.vala"
		_tmp10_ = parent;
#line 148 "../libcore/File.vala"
		_tmp11_ = files_file_new (location, _tmp10_);
#line 148 "../libcore/File.vala"
		_g_object_unref0 (file);
#line 148 "../libcore/File.vala"
		file = _tmp11_;
#line 293 "File.c"
		{
			GHashTable* _tmp12_;
#line 149 "../libcore/File.vala"
			_tmp12_ = files_file_file_cache;
#line 149 "../libcore/File.vala"
			g_rec_mutex_lock (&__lock_files_file_files_file_file_cache);
#line 300 "File.c"
			{
				GHashTable* _tmp13_;
				GFile* _tmp14_;
				FilesFile* _tmp15_;
				FilesFile* _tmp16_;
#line 150 "../libcore/File.vala"
				_tmp13_ = files_file_file_cache;
#line 150 "../libcore/File.vala"
				_tmp14_ = _g_object_ref0 (location);
#line 150 "../libcore/File.vala"
				_tmp15_ = file;
#line 150 "../libcore/File.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 150 "../libcore/File.vala"
				g_hash_table_insert (_tmp13_, _tmp14_, _tmp16_);
#line 316 "File.c"
			}
			__finally0:
			{
				GHashTable* _tmp17_;
#line 149 "../libcore/File.vala"
				_tmp17_ = files_file_file_cache;
#line 149 "../libcore/File.vala"
				g_rec_mutex_unlock (&__lock_files_file_files_file_file_cache);
#line 325 "File.c"
			}
#line 149 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../libcore/File.vala"
				_g_object_unref0 (file);
#line 149 "../libcore/File.vala"
				_g_object_unref0 (parent);
#line 149 "../libcore/File.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../libcore/File.vala"
				g_clear_error (&_inner_error0_);
#line 149 "../libcore/File.vala"
				return NULL;
#line 339 "File.c"
			}
		}
	}
#line 154 "../libcore/File.vala"
	result = file;
#line 154 "../libcore/File.vala"
	_g_object_unref0 (parent);
#line 154 "../libcore/File.vala"
	return result;
#line 349 "File.c"
}

FilesFile*
files_file_get_by_uri (const gchar* uri)
{
	gchar* scheme = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* location = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	FilesFile* _tmp6_;
	FilesFile* result;
#line 157 "../libcore/File.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 158 "../libcore/File.vala"
	_tmp0_ = g_uri_parse_scheme (uri);
#line 158 "../libcore/File.vala"
	scheme = _tmp0_;
#line 159 "../libcore/File.vala"
	_tmp1_ = scheme;
#line 159 "../libcore/File.vala"
	if (_tmp1_ == NULL) {
#line 374 "File.c"
		FilesFile* _tmp2_;
#line 160 "../libcore/File.vala"
		_tmp2_ = files_file_get_by_commandline_arg (uri);
#line 160 "../libcore/File.vala"
		result = _tmp2_;
#line 160 "../libcore/File.vala"
		_g_free0 (scheme);
#line 160 "../libcore/File.vala"
		return result;
#line 384 "File.c"
	}
#line 163 "../libcore/File.vala"
	_tmp3_ = g_file_new_for_uri (uri);
#line 163 "../libcore/File.vala"
	location = _tmp3_;
#line 164 "../libcore/File.vala"
	_tmp4_ = location;
#line 164 "../libcore/File.vala"
	if (_tmp4_ == NULL) {
#line 165 "../libcore/File.vala"
		result = NULL;
#line 165 "../libcore/File.vala"
		_g_object_unref0 (location);
#line 165 "../libcore/File.vala"
		_g_free0 (scheme);
#line 165 "../libcore/File.vala"
		return result;
#line 402 "File.c"
	}
#line 168 "../libcore/File.vala"
	_tmp5_ = location;
#line 168 "../libcore/File.vala"
	_tmp6_ = files_file_get (_tmp5_);
#line 168 "../libcore/File.vala"
	result = _tmp6_;
#line 168 "../libcore/File.vala"
	_g_object_unref0 (location);
#line 168 "../libcore/File.vala"
	_g_free0 (scheme);
#line 168 "../libcore/File.vala"
	return result;
#line 416 "File.c"
}

FilesFile*
files_file_get_by_commandline_arg (const gchar* arg)
{
	GFile* location = NULL;
	GFile* _tmp0_;
	FilesFile* _tmp1_;
	FilesFile* result;
#line 171 "../libcore/File.vala"
	g_return_val_if_fail (arg != NULL, NULL);
#line 172 "../libcore/File.vala"
	_tmp0_ = g_file_new_for_commandline_arg (arg);
#line 172 "../libcore/File.vala"
	location = _tmp0_;
#line 173 "../libcore/File.vala"
	_tmp1_ = files_file_get (location);
#line 173 "../libcore/File.vala"
	result = _tmp1_;
#line 173 "../libcore/File.vala"
	_g_object_unref0 (location);
#line 173 "../libcore/File.vala"
	return result;
#line 440 "File.c"
}

static guint
_g_file_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = g_file_hash (key);
#line 179 "../libcore/File.vala"
	return result;
#line 450 "File.c"
}

static gboolean
_g_file_equal_gequal_func (gconstpointer a,
                           gconstpointer b)
{
	gboolean result;
	result = g_file_equal (a, (GFile*) b);
#line 179 "../libcore/File.vala"
	return result;
#line 461 "File.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 179 "../libcore/File.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 469 "File.c"
}

FilesFile*
files_file_cache_lookup (GFile* file)
{
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	FilesFile* _tmp6_;
	GError* _inner_error0_ = NULL;
	FilesFile* result;
#line 176 "../libcore/File.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 482 "File.c"
	{
		GHashTable* _tmp0_;
#line 177 "../libcore/File.vala"
		_tmp0_ = files_file_file_cache;
#line 177 "../libcore/File.vala"
		g_rec_mutex_lock (&__lock_files_file_files_file_file_cache);
#line 489 "File.c"
		{
			GHashTable* _tmp1_;
#line 178 "../libcore/File.vala"
			_tmp1_ = files_file_file_cache;
#line 178 "../libcore/File.vala"
			if (_tmp1_ == NULL) {
#line 496 "File.c"
				GHashTable* _tmp2_;
#line 179 "../libcore/File.vala"
				_tmp2_ = g_hash_table_new_full (_g_file_hash_ghash_func, _g_file_equal_gequal_func, _g_object_unref0_, _g_object_unref0_);
#line 179 "../libcore/File.vala"
				_g_hash_table_unref0 (files_file_file_cache);
#line 179 "../libcore/File.vala"
				files_file_file_cache = _tmp2_;
#line 504 "File.c"
			}
		}
		__finally0:
		{
			GHashTable* _tmp3_;
#line 177 "../libcore/File.vala"
			_tmp3_ = files_file_file_cache;
#line 177 "../libcore/File.vala"
			g_rec_mutex_unlock (&__lock_files_file_files_file_file_cache);
#line 514 "File.c"
		}
#line 177 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 177 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 177 "../libcore/File.vala"
			return NULL;
#line 524 "File.c"
		}
	}
#line 183 "../libcore/File.vala"
	_tmp4_ = files_file_file_cache;
#line 183 "../libcore/File.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, file);
#line 183 "../libcore/File.vala"
	_tmp6_ = _g_object_ref0 ((FilesFile*) _tmp5_);
#line 183 "../libcore/File.vala"
	result = _tmp6_;
#line 183 "../libcore/File.vala"
	return result;
#line 537 "File.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 195 "../libcore/File.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 545 "File.c"
}

GMount*
files_file_get_mount_at (GFile* location)
{
	GVolumeMonitor* volume_monitor = NULL;
	GVolumeMonitor* _tmp0_;
	GVolumeMonitor* _tmp1_;
	GList* _tmp2_;
	GMount* result;
#line 186 "../libcore/File.vala"
	g_return_val_if_fail (location != NULL, NULL);
#line 187 "../libcore/File.vala"
	_tmp0_ = g_volume_monitor_get ();
#line 187 "../libcore/File.vala"
	volume_monitor = _tmp0_;
#line 188 "../libcore/File.vala"
	_tmp1_ = volume_monitor;
#line 188 "../libcore/File.vala"
	_tmp2_ = g_volume_monitor_get_mounts (_tmp1_);
#line 566 "File.c"
	{
		GList* mount_collection = NULL;
		GList* mount_it = NULL;
#line 188 "../libcore/File.vala"
		mount_collection = _tmp2_;
#line 188 "../libcore/File.vala"
		for (mount_it = mount_collection; mount_it != NULL; mount_it = mount_it->next) {
#line 574 "File.c"
			GMount* mount = NULL;
#line 188 "../libcore/File.vala"
			mount = (GMount*) mount_it->data;
#line 578 "File.c"
			{
				GMount* _tmp3_;
				GFile* root = NULL;
				GMount* _tmp4_;
				GFile* _tmp5_;
				GFile* _tmp6_;
#line 189 "../libcore/File.vala"
				_tmp3_ = mount;
#line 189 "../libcore/File.vala"
				if (g_mount_is_shadowed (_tmp3_)) {
#line 190 "../libcore/File.vala"
					continue;
#line 591 "File.c"
				}
#line 193 "../libcore/File.vala"
				_tmp4_ = mount;
#line 193 "../libcore/File.vala"
				_tmp5_ = g_mount_get_root (_tmp4_);
#line 193 "../libcore/File.vala"
				root = _tmp5_;
#line 194 "../libcore/File.vala"
				_tmp6_ = root;
#line 194 "../libcore/File.vala"
				if (g_file_equal (_tmp6_, location)) {
#line 603 "File.c"
					GMount* _tmp7_;
					GMount* _tmp8_;
#line 195 "../libcore/File.vala"
					_tmp7_ = mount;
#line 195 "../libcore/File.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 195 "../libcore/File.vala"
					result = _tmp8_;
#line 195 "../libcore/File.vala"
					_g_object_unref0 (root);
#line 195 "../libcore/File.vala"
					(mount_collection == NULL) ? NULL : (mount_collection = (_g_list_free__g_object_unref0_ (mount_collection), NULL));
#line 195 "../libcore/File.vala"
					_g_object_unref0 (volume_monitor);
#line 195 "../libcore/File.vala"
					return result;
#line 620 "File.c"
				}
#line 188 "../libcore/File.vala"
				_g_object_unref0 (root);
#line 624 "File.c"
			}
		}
#line 188 "../libcore/File.vala"
		(mount_collection == NULL) ? NULL : (mount_collection = (_g_list_free__g_object_unref0_ (mount_collection), NULL));
#line 629 "File.c"
	}
#line 199 "../libcore/File.vala"
	result = NULL;
#line 199 "../libcore/File.vala"
	_g_object_unref0 (volume_monitor);
#line 199 "../libcore/File.vala"
	return result;
#line 637 "File.c"
}

FilesFile*
files_file_construct (GType object_type,
                      GFile* location,
                      GFile* dir)
{
	FilesFile * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 202 "../libcore/File.vala"
	g_return_val_if_fail (location != NULL, NULL);
#line 203 "../libcore/File.vala"
	_tmp0_ = g_file_get_uri (location);
#line 203 "../libcore/File.vala"
	_tmp1_ = _tmp0_;
#line 203 "../libcore/File.vala"
	_tmp2_ = g_file_get_basename (location);
#line 203 "../libcore/File.vala"
	_tmp3_ = _tmp2_;
#line 203 "../libcore/File.vala"
	self = (FilesFile*) g_object_new (object_type, "location", location, "uri", _tmp1_, "basename", _tmp3_, "directory", dir, NULL);
#line 203 "../libcore/File.vala"
	_g_free0 (_tmp3_);
#line 203 "../libcore/File.vala"
	_g_free0 (_tmp1_);
#line 202 "../libcore/File.vala"
	return self;
#line 668 "File.c"
}

FilesFile*
files_file_new (GFile* location,
                GFile* dir)
{
#line 202 "../libcore/File.vala"
	return files_file_construct (FILES_TYPE_FILE, location, dir);
#line 677 "File.c"
}

void
files_file_remove_from_caches (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	GHashTable* _tmp1_;
#line 230 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 232 "../libcore/File.vala"
	_tmp1_ = files_file_file_cache;
#line 232 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 691 "File.c"
		GHashTable* _tmp2_;
		GFile* _tmp3_;
#line 232 "../libcore/File.vala"
		_tmp2_ = files_file_file_cache;
#line 232 "../libcore/File.vala"
		_tmp3_ = self->priv->_location;
#line 232 "../libcore/File.vala"
		_tmp0_ = g_hash_table_remove (_tmp2_, _tmp3_);
#line 700 "File.c"
	} else {
#line 232 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 704 "File.c"
	}
#line 232 "../libcore/File.vala"
	if (_tmp0_) {
#line 708 "File.c"
		const gchar* _tmp4_;
#line 233 "../libcore/File.vala"
		_tmp4_ = self->priv->_uri;
#line 233 "../libcore/File.vala"
		g_debug ("File.vala:233: remove from file_cache %s", _tmp4_);
#line 714 "File.c"
	}
#line 236 "../libcore/File.vala"
	self->is_gone = TRUE;
#line 718 "File.c"
}

void
files_file_set_expanded (FilesFile* self,
                         gboolean expanded)
{
#line 239 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 240 "../libcore/File.vala"
	g_return_if_fail (self->is_directory);
#line 241 "../libcore/File.vala"
	self->is_expanded = expanded;
#line 731 "File.c"
}

gboolean
files_file_is_folder (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	FilesFile* _tmp7_;
	gboolean result;
#line 244 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 246 "../libcore/File.vala"
	if (self->is_directory) {
#line 246 "../libcore/File.vala"
		_tmp0_ = !files_file_is_root_network_folder (self);
#line 750 "File.c"
	} else {
#line 246 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 754 "File.c"
	}
#line 246 "../libcore/File.vala"
	if (_tmp0_) {
#line 247 "../libcore/File.vala"
		result = TRUE;
#line 247 "../libcore/File.vala"
		return result;
#line 762 "File.c"
	}
#line 250 "../libcore/File.vala"
	if (files_file_is_smb_share (self)) {
#line 251 "../libcore/File.vala"
		result = TRUE;
#line 251 "../libcore/File.vala"
		return result;
#line 770 "File.c"
	}
#line 254 "../libcore/File.vala"
	if (self->file_type == G_FILE_TYPE_MOUNTABLE) {
#line 774 "File.c"
		GFileInfo* _tmp3_;
#line 255 "../libcore/File.vala"
		_tmp3_ = self->info;
#line 255 "../libcore/File.vala"
		_tmp2_ = _tmp3_ != NULL;
#line 780 "File.c"
	} else {
#line 254 "../libcore/File.vala"
		_tmp2_ = FALSE;
#line 784 "File.c"
	}
#line 254 "../libcore/File.vala"
	if (_tmp2_) {
#line 788 "File.c"
		GFileInfo* _tmp4_;
#line 255 "../libcore/File.vala"
		_tmp4_ = self->info;
#line 255 "../libcore/File.vala"
		_tmp1_ = g_file_info_get_attribute_boolean (_tmp4_, G_FILE_ATTRIBUTE_MOUNTABLE_CAN_MOUNT);
#line 794 "File.c"
	} else {
#line 254 "../libcore/File.vala"
		_tmp1_ = FALSE;
#line 798 "File.c"
	}
#line 254 "../libcore/File.vala"
	if (_tmp1_) {
#line 257 "../libcore/File.vala"
		result = TRUE;
#line 257 "../libcore/File.vala"
		return result;
#line 806 "File.c"
	}
#line 260 "../libcore/File.vala"
	_tmp7_ = self->target_gof;
#line 260 "../libcore/File.vala"
	if (_tmp7_ != NULL) {
#line 812 "File.c"
		FilesFile* _tmp8_;
#line 260 "../libcore/File.vala"
		_tmp8_ = self->target_gof;
#line 260 "../libcore/File.vala"
		_tmp6_ = _tmp8_->is_directory;
#line 818 "File.c"
	} else {
#line 260 "../libcore/File.vala"
		_tmp6_ = FALSE;
#line 822 "File.c"
	}
#line 260 "../libcore/File.vala"
	if (_tmp6_) {
#line 826 "File.c"
		FilesFile* _tmp9_;
#line 260 "../libcore/File.vala"
		_tmp9_ = self->target_gof;
#line 260 "../libcore/File.vala"
		_tmp5_ = files_file_is_network_uri_scheme (_tmp9_);
#line 832 "File.c"
	} else {
#line 260 "../libcore/File.vala"
		_tmp5_ = FALSE;
#line 836 "File.c"
	}
#line 260 "../libcore/File.vala"
	if (_tmp5_) {
#line 261 "../libcore/File.vala"
		result = TRUE;
#line 261 "../libcore/File.vala"
		return result;
#line 844 "File.c"
	}
#line 264 "../libcore/File.vala"
	result = FALSE;
#line 264 "../libcore/File.vala"
	return result;
#line 850 "File.c"
}

gboolean
files_file_is_symlink (FilesFile* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gboolean result;
#line 267 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 268 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 269 "../libcore/File.vala"
		result = FALSE;
#line 269 "../libcore/File.vala"
		return result;
#line 869 "File.c"
	}
#line 272 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 272 "../libcore/File.vala"
	result = g_file_info_get_attribute_boolean (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK);
#line 272 "../libcore/File.vala"
	return result;
#line 877 "File.c"
}

gboolean
files_file_is_desktop_file (FilesFile* self)
{
	GFileInfo* _tmp0_;
	gboolean is_desktop_file = FALSE;
	const gchar* content_type = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 275 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 276 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 277 "../libcore/File.vala"
		result = FALSE;
#line 277 "../libcore/File.vala"
		return result;
#line 900 "File.c"
	}
#line 280 "../libcore/File.vala"
	is_desktop_file = FALSE;
#line 281 "../libcore/File.vala"
	_tmp1_ = files_file_get_ftype (self);
#line 281 "../libcore/File.vala"
	content_type = _tmp1_;
#line 282 "../libcore/File.vala"
	_tmp2_ = content_type;
#line 282 "../libcore/File.vala"
	if (_tmp2_ != NULL) {
#line 912 "File.c"
		const gchar* _tmp3_;
#line 283 "../libcore/File.vala"
		_tmp3_ = content_type;
#line 283 "../libcore/File.vala"
		is_desktop_file = g_content_type_is_mime_type (_tmp3_, "application/x-desktop");
#line 918 "File.c"
	}
#line 286 "../libcore/File.vala"
	if (is_desktop_file) {
#line 922 "File.c"
		const gchar* _tmp5_;
#line 286 "../libcore/File.vala"
		_tmp5_ = self->priv->_basename;
#line 286 "../libcore/File.vala"
		_tmp4_ = !g_str_has_suffix (_tmp5_, ".directory");
#line 928 "File.c"
	} else {
#line 286 "../libcore/File.vala"
		_tmp4_ = FALSE;
#line 932 "File.c"
	}
#line 286 "../libcore/File.vala"
	result = _tmp4_;
#line 286 "../libcore/File.vala"
	return result;
#line 938 "File.c"
}

gboolean
files_file_is_image (FilesFile* self)
{
	GFileInfo* _tmp0_;
	gboolean is_image = FALSE;
	const gchar* content_type = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 289 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 290 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 290 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 291 "../libcore/File.vala"
		result = FALSE;
#line 291 "../libcore/File.vala"
		return result;
#line 960 "File.c"
	}
#line 294 "../libcore/File.vala"
	is_image = FALSE;
#line 295 "../libcore/File.vala"
	_tmp1_ = files_file_get_ftype (self);
#line 295 "../libcore/File.vala"
	content_type = _tmp1_;
#line 296 "../libcore/File.vala"
	_tmp2_ = content_type;
#line 296 "../libcore/File.vala"
	if (_tmp2_ != NULL) {
#line 972 "File.c"
		const gchar* _tmp3_;
#line 297 "../libcore/File.vala"
		_tmp3_ = content_type;
#line 297 "../libcore/File.vala"
		is_image = g_content_type_is_mime_type (_tmp3_, "image/*");
#line 978 "File.c"
	}
#line 300 "../libcore/File.vala"
	result = is_image;
#line 300 "../libcore/File.vala"
	return result;
#line 984 "File.c"
}

gboolean
files_file_is_trashed (FilesFile* self)
{
	GFile* _tmp0_;
	gboolean result;
#line 303 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 304 "../libcore/File.vala"
	_tmp0_ = files_file_get_target_location (self);
#line 304 "../libcore/File.vala"
	result = files_file_utils_location_is_in_trash (_tmp0_);
#line 304 "../libcore/File.vala"
	return result;
#line 1000 "File.c"
}

gboolean
files_file_is_readable (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	FilesFile* _tmp1_;
	gboolean result;
#line 307 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 308 "../libcore/File.vala"
	_tmp1_ = self->target_gof;
#line 308 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 1015 "File.c"
		GFile* _tmp2_;
		FilesFile* _tmp3_;
		GFile* _tmp4_;
#line 308 "../libcore/File.vala"
		_tmp2_ = self->priv->_location;
#line 308 "../libcore/File.vala"
		_tmp3_ = self->target_gof;
#line 308 "../libcore/File.vala"
		_tmp4_ = _tmp3_->priv->_location;
#line 308 "../libcore/File.vala"
		_tmp0_ = !g_file_equal (_tmp2_, _tmp4_);
#line 1027 "File.c"
	} else {
#line 308 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 1031 "File.c"
	}
#line 308 "../libcore/File.vala"
	if (_tmp0_) {
#line 1035 "File.c"
		FilesFile* _tmp5_;
#line 309 "../libcore/File.vala"
		_tmp5_ = self->target_gof;
#line 309 "../libcore/File.vala"
		result = files_file_is_readable (_tmp5_);
#line 309 "../libcore/File.vala"
		return result;
#line 1043 "File.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GFileInfo* _tmp7_;
#line 310 "../libcore/File.vala"
		_tmp7_ = self->info;
#line 310 "../libcore/File.vala"
		if (_tmp7_ != NULL) {
#line 1051 "File.c"
			GFileInfo* _tmp8_;
#line 310 "../libcore/File.vala"
			_tmp8_ = self->info;
#line 310 "../libcore/File.vala"
			_tmp6_ = g_file_info_has_attribute (_tmp8_, G_FILE_ATTRIBUTE_ACCESS_CAN_READ);
#line 1057 "File.c"
		} else {
#line 310 "../libcore/File.vala"
			_tmp6_ = FALSE;
#line 1061 "File.c"
		}
#line 310 "../libcore/File.vala"
		if (_tmp6_) {
#line 1065 "File.c"
			GFileInfo* _tmp9_;
#line 311 "../libcore/File.vala"
			_tmp9_ = self->info;
#line 311 "../libcore/File.vala"
			result = g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_ACCESS_CAN_READ);
#line 311 "../libcore/File.vala"
			return result;
#line 1073 "File.c"
		} else {
#line 312 "../libcore/File.vala"
			if (self->has_permissions) {
#line 1077 "File.c"
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
#line 313 "../libcore/File.vala"
				if ((self->permissions & S_IROTH) != ((guint32) 0)) {
#line 313 "../libcore/File.vala"
					_tmp11_ = TRUE;
#line 1084 "File.c"
				} else {
					gboolean _tmp12_ = FALSE;
#line 314 "../libcore/File.vala"
					if ((self->permissions & S_IRUSR) != ((guint32) 0)) {
#line 1089 "File.c"
						gboolean _tmp13_ = FALSE;
#line 314 "../libcore/File.vala"
						if (self->uid < ((guint32) 0)) {
#line 314 "../libcore/File.vala"
							_tmp13_ = TRUE;
#line 1095 "File.c"
						} else {
#line 314 "../libcore/File.vala"
							_tmp13_ = ((uid_t) self->uid) == geteuid ();
#line 1099 "File.c"
						}
#line 314 "../libcore/File.vala"
						_tmp12_ = _tmp13_;
#line 1103 "File.c"
					} else {
#line 314 "../libcore/File.vala"
						_tmp12_ = FALSE;
#line 1107 "File.c"
					}
#line 314 "../libcore/File.vala"
					_tmp11_ = _tmp12_;
#line 1111 "File.c"
				}
#line 313 "../libcore/File.vala"
				if (_tmp11_) {
#line 313 "../libcore/File.vala"
					_tmp10_ = TRUE;
#line 1117 "File.c"
				} else {
					gboolean _tmp14_ = FALSE;
#line 315 "../libcore/File.vala"
					if ((self->permissions & S_IRGRP) != ((guint32) 0)) {
#line 1122 "File.c"
						const gchar* _tmp15_;
#line 315 "../libcore/File.vala"
						_tmp15_ = self->group;
#line 315 "../libcore/File.vala"
						_tmp14_ = pf_user_utils_user_in_group (_tmp15_);
#line 1128 "File.c"
					} else {
#line 315 "../libcore/File.vala"
						_tmp14_ = FALSE;
#line 1132 "File.c"
					}
#line 315 "../libcore/File.vala"
					_tmp10_ = _tmp14_;
#line 1136 "File.c"
				}
#line 313 "../libcore/File.vala"
				result = _tmp10_;
#line 313 "../libcore/File.vala"
				return result;
#line 1142 "File.c"
			} else {
#line 317 "../libcore/File.vala"
				result = TRUE;
#line 317 "../libcore/File.vala"
				return result;
#line 1148 "File.c"
			}
		}
	}
}

gboolean
files_file_is_writable (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	FilesFile* _tmp1_;
	gboolean _tmp6_ = FALSE;
	GFileInfo* _tmp7_;
	gboolean result;
#line 321 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 322 "../libcore/File.vala"
	_tmp1_ = self->target_gof;
#line 322 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 1168 "File.c"
		GFile* _tmp2_;
		FilesFile* _tmp3_;
		GFile* _tmp4_;
#line 322 "../libcore/File.vala"
		_tmp2_ = self->priv->_location;
#line 322 "../libcore/File.vala"
		_tmp3_ = self->target_gof;
#line 322 "../libcore/File.vala"
		_tmp4_ = _tmp3_->priv->_location;
#line 322 "../libcore/File.vala"
		_tmp0_ = !g_file_equal (_tmp2_, _tmp4_);
#line 1180 "File.c"
	} else {
#line 322 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 1184 "File.c"
	}
#line 322 "../libcore/File.vala"
	if (_tmp0_) {
#line 1188 "File.c"
		FilesFile* _tmp5_;
#line 323 "../libcore/File.vala"
		_tmp5_ = self->target_gof;
#line 323 "../libcore/File.vala"
		result = files_file_is_writable (_tmp5_);
#line 323 "../libcore/File.vala"
		return result;
#line 1196 "File.c"
	}
#line 326 "../libcore/File.vala"
	_tmp7_ = self->info;
#line 326 "../libcore/File.vala"
	if (_tmp7_ != NULL) {
#line 1202 "File.c"
		GFileInfo* _tmp8_;
#line 326 "../libcore/File.vala"
		_tmp8_ = self->info;
#line 326 "../libcore/File.vala"
		_tmp6_ = g_file_info_has_attribute (_tmp8_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 1208 "File.c"
	} else {
#line 326 "../libcore/File.vala"
		_tmp6_ = FALSE;
#line 1212 "File.c"
	}
#line 326 "../libcore/File.vala"
	if (_tmp6_) {
#line 1216 "File.c"
		GFileInfo* _tmp9_;
#line 327 "../libcore/File.vala"
		_tmp9_ = self->info;
#line 327 "../libcore/File.vala"
		result = g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 327 "../libcore/File.vala"
		return result;
#line 1224 "File.c"
	}
#line 330 "../libcore/File.vala"
	if (self->has_permissions) {
#line 1228 "File.c"
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
#line 331 "../libcore/File.vala"
		if ((self->permissions & S_IWOTH) > ((guint32) 0)) {
#line 331 "../libcore/File.vala"
			_tmp11_ = TRUE;
#line 1235 "File.c"
		} else {
			gboolean _tmp12_ = FALSE;
#line 332 "../libcore/File.vala"
			if ((self->permissions & S_IWUSR) > ((guint32) 0)) {
#line 1240 "File.c"
				gboolean _tmp13_ = FALSE;
#line 332 "../libcore/File.vala"
				if (self->uid < ((guint32) 0)) {
#line 332 "../libcore/File.vala"
					_tmp13_ = TRUE;
#line 1246 "File.c"
				} else {
#line 332 "../libcore/File.vala"
					_tmp13_ = ((uid_t) self->uid) == geteuid ();
#line 1250 "File.c"
				}
#line 332 "../libcore/File.vala"
				_tmp12_ = _tmp13_;
#line 1254 "File.c"
			} else {
#line 332 "../libcore/File.vala"
				_tmp12_ = FALSE;
#line 1258 "File.c"
			}
#line 332 "../libcore/File.vala"
			_tmp11_ = _tmp12_;
#line 1262 "File.c"
		}
#line 331 "../libcore/File.vala"
		if (_tmp11_) {
#line 331 "../libcore/File.vala"
			_tmp10_ = TRUE;
#line 1268 "File.c"
		} else {
			gboolean _tmp14_ = FALSE;
#line 333 "../libcore/File.vala"
			if ((self->permissions & S_IWGRP) > ((guint32) 0)) {
#line 1273 "File.c"
				const gchar* _tmp15_;
#line 333 "../libcore/File.vala"
				_tmp15_ = self->group;
#line 333 "../libcore/File.vala"
				_tmp14_ = pf_user_utils_user_in_group (_tmp15_);
#line 1279 "File.c"
			} else {
#line 333 "../libcore/File.vala"
				_tmp14_ = FALSE;
#line 1283 "File.c"
			}
#line 333 "../libcore/File.vala"
			_tmp10_ = _tmp14_;
#line 1287 "File.c"
		}
#line 331 "../libcore/File.vala"
		result = _tmp10_;
#line 331 "../libcore/File.vala"
		return result;
#line 1293 "File.c"
	} else {
#line 336 "../libcore/File.vala"
		result = TRUE;
#line 336 "../libcore/File.vala"
		return result;
#line 1299 "File.c"
	}
}

gboolean
files_file_is_executable (FilesFile* self)
{
	FilesFile* _tmp0_;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp3_;
	gboolean result;
#line 340 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 341 "../libcore/File.vala"
	_tmp0_ = self->target_gof;
#line 341 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 1316 "File.c"
		FilesFile* _tmp1_;
#line 342 "../libcore/File.vala"
		_tmp1_ = self->target_gof;
#line 342 "../libcore/File.vala"
		result = files_file_is_executable (_tmp1_);
#line 342 "../libcore/File.vala"
		return result;
#line 1324 "File.c"
	}
#line 345 "../libcore/File.vala"
	_tmp2_ = self->info;
#line 345 "../libcore/File.vala"
	if (_tmp2_ == NULL) {
#line 346 "../libcore/File.vala"
		result = FALSE;
#line 346 "../libcore/File.vala"
		return result;
#line 1334 "File.c"
	}
#line 349 "../libcore/File.vala"
	_tmp3_ = self->info;
#line 349 "../libcore/File.vala"
	if (g_file_info_get_attribute_boolean (_tmp3_, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE)) {
#line 1340 "File.c"
		const gchar* content_type = NULL;
		const gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
#line 350 "../libcore/File.vala"
		_tmp4_ = files_file_get_ftype (self);
#line 350 "../libcore/File.vala"
		content_type = _tmp4_;
#line 351 "../libcore/File.vala"
		_tmp6_ = content_type;
#line 351 "../libcore/File.vala"
		if (_tmp6_ != NULL) {
#line 1353 "File.c"
			const gchar* _tmp7_;
#line 351 "../libcore/File.vala"
			_tmp7_ = content_type;
#line 351 "../libcore/File.vala"
			_tmp5_ = g_content_type_is_a (_tmp7_, "application/x-executable");
#line 1359 "File.c"
		} else {
#line 351 "../libcore/File.vala"
			_tmp5_ = FALSE;
#line 1363 "File.c"
		}
#line 351 "../libcore/File.vala"
		if (_tmp5_) {
#line 352 "../libcore/File.vala"
			result = TRUE;
#line 352 "../libcore/File.vala"
			return result;
#line 1371 "File.c"
		}
	}
#line 356 "../libcore/File.vala"
	result = FALSE;
#line 356 "../libcore/File.vala"
	return result;
#line 1378 "File.c"
}

gboolean
files_file_is_mountable (FilesFile* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gboolean result;
#line 359 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 360 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 360 "../libcore/File.vala"
	g_return_val_if_fail (_tmp0_ != NULL, FALSE);
#line 361 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 361 "../libcore/File.vala"
	result = g_file_info_get_file_type (_tmp1_) == G_FILE_TYPE_MOUNTABLE;
#line 361 "../libcore/File.vala"
	return result;
#line 1399 "File.c"
}

gboolean
files_file_is_smb_share (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 365 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 366 "../libcore/File.vala"
	if (files_file_is_smb_uri_scheme (self)) {
#line 366 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 1413 "File.c"
	} else {
#line 366 "../libcore/File.vala"
		_tmp0_ = files_file_is_network_uri_scheme (self);
#line 1417 "File.c"
	}
#line 366 "../libcore/File.vala"
	if (_tmp0_) {
#line 367 "../libcore/File.vala"
		result = files_file_get_number_of_uri_parts (self) == ((guint) 3);
#line 367 "../libcore/File.vala"
		return result;
#line 1425 "File.c"
	}
#line 370 "../libcore/File.vala"
	result = FALSE;
#line 370 "../libcore/File.vala"
	return result;
#line 1431 "File.c"
}

gboolean
files_file_is_smb_server (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 373 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 374 "../libcore/File.vala"
	if (files_file_is_smb_uri_scheme (self)) {
#line 374 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 1445 "File.c"
	} else {
#line 374 "../libcore/File.vala"
		_tmp0_ = files_file_is_network_uri_scheme (self);
#line 1449 "File.c"
	}
#line 374 "../libcore/File.vala"
	if (_tmp0_) {
#line 375 "../libcore/File.vala"
		result = files_file_get_number_of_uri_parts (self) == ((guint) 2);
#line 375 "../libcore/File.vala"
		return result;
#line 1457 "File.c"
	}
#line 378 "../libcore/File.vala"
	result = FALSE;
#line 378 "../libcore/File.vala"
	return result;
#line 1463 "File.c"
}

const gchar*
files_file_get_display_name (FilesFile* self)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* result;
#line 381 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 382 "../libcore/File.vala"
	_tmp1_ = self->custom_display_name;
#line 382 "../libcore/File.vala"
	_tmp0_ = _tmp1_;
#line 382 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 1480 "File.c"
		const gchar* _tmp2_;
#line 382 "../libcore/File.vala"
		_tmp2_ = self->priv->_basename;
#line 382 "../libcore/File.vala"
		_tmp0_ = _tmp2_;
#line 1486 "File.c"
	}
#line 382 "../libcore/File.vala"
	result = _tmp0_;
#line 382 "../libcore/File.vala"
	return result;
#line 1492 "File.c"
}

GFile*
files_file_get_target_location (FilesFile* self)
{
	GFile* _tmp0_;
	GFile* _tmp2_;
	GFile* result;
#line 385 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 386 "../libcore/File.vala"
	_tmp0_ = self->target_location;
#line 386 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 1507 "File.c"
		GFile* _tmp1_;
#line 387 "../libcore/File.vala"
		_tmp1_ = self->target_location;
#line 387 "../libcore/File.vala"
		result = _tmp1_;
#line 387 "../libcore/File.vala"
		return result;
#line 1515 "File.c"
	}
#line 390 "../libcore/File.vala"
	_tmp2_ = self->priv->_location;
#line 390 "../libcore/File.vala"
	result = _tmp2_;
#line 390 "../libcore/File.vala"
	return result;
#line 1523 "File.c"
}

const gchar*
files_file_get_symlink_target (FilesFile* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	const gchar* result;
#line 393 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 394 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 394 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 395 "../libcore/File.vala"
		result = NULL;
#line 395 "../libcore/File.vala"
		return result;
#line 1543 "File.c"
	}
#line 398 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 398 "../libcore/File.vala"
	_tmp2_ = g_file_info_get_attribute_byte_string (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 398 "../libcore/File.vala"
	result = _tmp2_;
#line 398 "../libcore/File.vala"
	return result;
#line 1553 "File.c"
}

const gchar*
files_file_get_ftype (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp2_;
	const gchar* ftype = NULL;
	GFileInfo* _tmp5_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	const gchar* _tmp12_;
	const gchar* result;
#line 401 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 402 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 402 "../libcore/File.vala"
	if (_tmp1_ == NULL) {
#line 402 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 1576 "File.c"
	} else {
#line 402 "../libcore/File.vala"
		_tmp0_ = files_file_is_location_uri_default (self);
#line 1580 "File.c"
	}
#line 402 "../libcore/File.vala"
	if (_tmp0_) {
#line 403 "../libcore/File.vala"
		result = NULL;
#line 403 "../libcore/File.vala"
		return result;
#line 1588 "File.c"
	}
#line 406 "../libcore/File.vala"
	if (self->is_directory) {
#line 407 "../libcore/File.vala"
		result = "inode/directory";
#line 407 "../libcore/File.vala"
		return result;
#line 1596 "File.c"
	}
#line 410 "../libcore/File.vala"
	_tmp2_ = self->info;
#line 410 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp2_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE)) {
#line 1602 "File.c"
		GFileInfo* _tmp3_;
		const gchar* _tmp4_;
#line 411 "../libcore/File.vala"
		_tmp3_ = self->info;
#line 411 "../libcore/File.vala"
		_tmp4_ = g_file_info_get_attribute_string (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE);
#line 411 "../libcore/File.vala"
		result = _tmp4_;
#line 411 "../libcore/File.vala"
		return result;
#line 1613 "File.c"
	}
#line 414 "../libcore/File.vala"
	ftype = NULL;
#line 415 "../libcore/File.vala"
	_tmp5_ = self->info;
#line 415 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp5_, G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE)) {
#line 1621 "File.c"
		GFileInfo* _tmp6_;
		const gchar* _tmp7_;
#line 416 "../libcore/File.vala"
		_tmp6_ = self->info;
#line 416 "../libcore/File.vala"
		_tmp7_ = g_file_info_get_attribute_string (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE);
#line 416 "../libcore/File.vala"
		ftype = _tmp7_;
#line 1630 "File.c"
	}
#line 420 "../libcore/File.vala"
	_tmp9_ = ftype;
#line 420 "../libcore/File.vala"
	if (g_strcmp0 (_tmp9_, "application/octet-stream") == 0) {
#line 1636 "File.c"
		const gchar* _tmp10_;
#line 420 "../libcore/File.vala"
		_tmp10_ = self->tagstype;
#line 420 "../libcore/File.vala"
		_tmp8_ = _tmp10_ != NULL;
#line 1642 "File.c"
	} else {
#line 420 "../libcore/File.vala"
		_tmp8_ = FALSE;
#line 1646 "File.c"
	}
#line 420 "../libcore/File.vala"
	if (_tmp8_) {
#line 1650 "File.c"
		const gchar* _tmp11_;
#line 421 "../libcore/File.vala"
		_tmp11_ = self->tagstype;
#line 421 "../libcore/File.vala"
		result = _tmp11_;
#line 421 "../libcore/File.vala"
		return result;
#line 1658 "File.c"
	}
#line 424 "../libcore/File.vala"
	_tmp12_ = ftype;
#line 424 "../libcore/File.vala"
	result = _tmp12_;
#line 424 "../libcore/File.vala"
	return result;
#line 1666 "File.c"
}

gchar*
files_file_get_formated_time (FilesFile* self,
                              const gchar* attr)
{
	GFileInfo* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 427 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 427 "../libcore/File.vala"
	g_return_val_if_fail (attr != NULL, NULL);
#line 428 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 428 "../libcore/File.vala"
	_tmp1_ = files_file_utils_get_formatted_time_attribute_from_info (_tmp0_, attr);
#line 428 "../libcore/File.vala"
	result = _tmp1_;
#line 428 "../libcore/File.vala"
	return result;
#line 1688 "File.c"
}

GdkPixbuf*
files_file_get_icon_pixbuf (FilesFile* self,
                            gint _size,
                            gint scale,
                            FilesFileIconFlags flags)
{
	FilesIconInfo* _tmp0_;
	FilesIconInfo* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* result;
#line 432 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 433 "../libcore/File.vala"
	_tmp0_ = files_file_get_icon (self, CLAMP (_size, 16, 512), scale, flags);
#line 433 "../libcore/File.vala"
	_tmp1_ = _tmp0_;
#line 433 "../libcore/File.vala"
	_tmp2_ = files_icon_info_get_pixbuf_nodefault (_tmp1_);
#line 433 "../libcore/File.vala"
	_tmp3_ = _tmp2_;
#line 433 "../libcore/File.vala"
	_g_object_unref0 (_tmp1_);
#line 433 "../libcore/File.vala"
	result = _tmp3_;
#line 433 "../libcore/File.vala"
	return result;
#line 1718 "File.c"
}

void
files_file_get_folder_icon_from_uri_or_path (FilesFile* self)
{
	GIcon* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	GIcon* _tmp12_;
	GIcon* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 440 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 441 "../libcore/File.vala"
	_tmp0_ = self->icon;
#line 441 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 442 "../libcore/File.vala"
		return;
#line 1740 "File.c"
	}
#line 445 "../libcore/File.vala"
	_tmp2_ = self->priv->_is_hidden;
#line 445 "../libcore/File.vala"
	if (!_tmp2_) {
#line 1746 "File.c"
		const gchar* _tmp3_;
#line 445 "../libcore/File.vala"
		_tmp3_ = self->priv->_uri;
#line 445 "../libcore/File.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1752 "File.c"
	} else {
#line 445 "../libcore/File.vala"
		_tmp1_ = FALSE;
#line 1756 "File.c"
	}
#line 445 "../libcore/File.vala"
	if (_tmp1_) {
#line 1760 "File.c"
		{
			gchar* path = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			GIcon* _tmp7_;
#line 447 "../libcore/File.vala"
			_tmp4_ = self->priv->_uri;
#line 447 "../libcore/File.vala"
			_tmp5_ = g_filename_from_uri (_tmp4_, NULL, &_inner_error0_);
#line 447 "../libcore/File.vala"
			path = _tmp5_;
#line 447 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1775 "File.c"
				goto __catch0_g_error;
			}
#line 448 "../libcore/File.vala"
			_tmp6_ = path;
#line 448 "../libcore/File.vala"
			_tmp7_ = files_file_get_icon_user_special_dirs (self, _tmp6_);
#line 448 "../libcore/File.vala"
			_g_object_unref0 (self->icon);
#line 448 "../libcore/File.vala"
			self->icon = _tmp7_;
#line 446 "../libcore/File.vala"
			_g_free0 (path);
#line 1788 "File.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 446 "../libcore/File.vala"
			e = _inner_error0_;
#line 446 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 450 "../libcore/File.vala"
			_tmp8_ = e;
#line 450 "../libcore/File.vala"
			_tmp9_ = _tmp8_->message;
#line 450 "../libcore/File.vala"
			g_debug ("File.vala:450: %s", _tmp9_);
#line 446 "../libcore/File.vala"
			_g_error_free0 (e);
#line 1808 "File.c"
		}
		__finally0:
#line 446 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 446 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 446 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 446 "../libcore/File.vala"
			return;
#line 1819 "File.c"
		}
	}
#line 454 "../libcore/File.vala"
	_tmp12_ = self->icon;
#line 454 "../libcore/File.vala"
	if (_tmp12_ == NULL) {
#line 1826 "File.c"
		GFile* _tmp13_;
#line 454 "../libcore/File.vala"
		_tmp13_ = self->priv->_location;
#line 454 "../libcore/File.vala"
		_tmp11_ = !g_file_is_native (_tmp13_);
#line 1832 "File.c"
	} else {
#line 454 "../libcore/File.vala"
		_tmp11_ = FALSE;
#line 1836 "File.c"
	}
#line 454 "../libcore/File.vala"
	if (_tmp11_) {
#line 454 "../libcore/File.vala"
		_tmp10_ = files_file_is_remote_uri_scheme (self);
#line 1842 "File.c"
	} else {
#line 454 "../libcore/File.vala"
		_tmp10_ = FALSE;
#line 1846 "File.c"
	}
#line 454 "../libcore/File.vala"
	if (_tmp10_) {
#line 1850 "File.c"
		GThemedIcon* _tmp14_;
#line 455 "../libcore/File.vala"
		_tmp14_ = (GThemedIcon*) g_themed_icon_new ("folder-remote");
#line 455 "../libcore/File.vala"
		_g_object_unref0 (self->icon);
#line 455 "../libcore/File.vala"
		self->icon = (GIcon*) _tmp14_;
#line 1858 "File.c"
	}
#line 458 "../libcore/File.vala"
	_tmp15_ = self->icon;
#line 458 "../libcore/File.vala"
	if (_tmp15_ == NULL) {
#line 1864 "File.c"
		GThemedIcon* _tmp16_;
#line 459 "../libcore/File.vala"
		_tmp16_ = (GThemedIcon*) g_themed_icon_new ("folder");
#line 459 "../libcore/File.vala"
		_g_object_unref0 (self->icon);
#line 459 "../libcore/File.vala"
		self->icon = (GIcon*) _tmp16_;
#line 1872 "File.c"
	}
}

static FilesIconInfo*
files_file_get_icon (FilesFile* self,
                     gint requested_size,
                     gint scale,
                     FilesFileIconFlags flags)
{
	FilesIconInfo* iconinfo = NULL;
	gboolean use_thumbnails = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean awaiting_thumbnail = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean thumbnail_ready = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp9_ = FALSE;
	FilesIconInfo* _tmp10_;
	gboolean _tmp14_ = FALSE;
	FilesIconInfo* _tmp15_;
	FilesIconInfo* _tmp32_;
	FilesIconInfo* result;
#line 466 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 467 "../libcore/File.vala"
	self->priv->pix_is_final = TRUE;
#line 468 "../libcore/File.vala"
	iconinfo = NULL;
#line 469 "../libcore/File.vala"
	use_thumbnails = (flags & FILES_FILE_ICON_FLAGS_USE_THUMBNAILS) == FILES_FILE_ICON_FLAGS_USE_THUMBNAILS;
#line 470 "../libcore/File.vala"
	if (use_thumbnails) {
#line 1905 "File.c"
		gboolean _tmp1_ = FALSE;
#line 471 "../libcore/File.vala"
		if (self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_LOADING)) {
#line 471 "../libcore/File.vala"
			_tmp1_ = TRUE;
#line 1911 "File.c"
		} else {
#line 471 "../libcore/File.vala"
			_tmp1_ = self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_UNKNOWN);
#line 1915 "File.c"
		}
#line 471 "../libcore/File.vala"
		_tmp0_ = _tmp1_;
#line 1919 "File.c"
	} else {
#line 470 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 1923 "File.c"
	}
#line 470 "../libcore/File.vala"
	awaiting_thumbnail = _tmp0_;
#line 473 "../libcore/File.vala"
	if (use_thumbnails) {
#line 473 "../libcore/File.vala"
		_tmp2_ = self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_READY);
#line 1931 "File.c"
	} else {
#line 473 "../libcore/File.vala"
		_tmp2_ = FALSE;
#line 1935 "File.c"
	}
#line 473 "../libcore/File.vala"
	thumbnail_ready = _tmp2_;
#line 476 "../libcore/File.vala"
	_tmp3_ = self->custom_icon_name;
#line 476 "../libcore/File.vala"
	if (_tmp3_ != NULL) {
#line 1943 "File.c"
		const gchar* _tmp4_;
#line 477 "../libcore/File.vala"
		_tmp4_ = self->custom_icon_name;
#line 477 "../libcore/File.vala"
		if (g_path_is_absolute (_tmp4_)) {
#line 1949 "File.c"
			const gchar* _tmp5_;
			FilesIconInfo* _tmp6_;
#line 478 "../libcore/File.vala"
			_tmp5_ = self->custom_icon_name;
#line 478 "../libcore/File.vala"
			_tmp6_ = files_icon_info_lookup_from_path (_tmp5_, requested_size, scale, FALSE);
#line 478 "../libcore/File.vala"
			_g_object_unref0 (iconinfo);
#line 478 "../libcore/File.vala"
			iconinfo = _tmp6_;
#line 1960 "File.c"
		} else {
			const gchar* _tmp7_;
			FilesIconInfo* _tmp8_;
#line 480 "../libcore/File.vala"
			_tmp7_ = self->custom_icon_name;
#line 480 "../libcore/File.vala"
			_tmp8_ = files_icon_info_lookup_from_name (_tmp7_, requested_size, scale);
#line 480 "../libcore/File.vala"
			_g_object_unref0 (iconinfo);
#line 480 "../libcore/File.vala"
			iconinfo = _tmp8_;
#line 1972 "File.c"
		}
	}
#line 484 "../libcore/File.vala"
	_tmp10_ = iconinfo;
#line 484 "../libcore/File.vala"
	if (_tmp10_ == NULL) {
#line 484 "../libcore/File.vala"
		_tmp9_ = thumbnail_ready;
#line 1981 "File.c"
	} else {
#line 484 "../libcore/File.vala"
		_tmp9_ = FALSE;
#line 1985 "File.c"
	}
#line 484 "../libcore/File.vala"
	if (_tmp9_) {
#line 1989 "File.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		FilesIconInfo* _tmp13_;
#line 485 "../libcore/File.vala"
		_tmp11_ = files_file_get_thumbnail_path (self);
#line 485 "../libcore/File.vala"
		_tmp12_ = _tmp11_;
#line 485 "../libcore/File.vala"
		_tmp13_ = files_icon_info_lookup_from_path (_tmp12_, requested_size, scale, self->is_remote);
#line 485 "../libcore/File.vala"
		_g_object_unref0 (iconinfo);
#line 485 "../libcore/File.vala"
		iconinfo = _tmp13_;
#line 2003 "File.c"
	}
#line 488 "../libcore/File.vala"
	_tmp15_ = iconinfo;
#line 488 "../libcore/File.vala"
	if (_tmp15_ == NULL) {
#line 488 "../libcore/File.vala"
		_tmp14_ = TRUE;
#line 2011 "File.c"
	} else {
		FilesIconInfo* _tmp16_;
		GdkPixbuf* _tmp17_;
		GdkPixbuf* _tmp18_;
#line 488 "../libcore/File.vala"
		_tmp16_ = iconinfo;
#line 488 "../libcore/File.vala"
		_tmp17_ = files_icon_info_get_pixbuf (_tmp16_);
#line 488 "../libcore/File.vala"
		_tmp18_ = _tmp17_;
#line 488 "../libcore/File.vala"
		_tmp14_ = _tmp18_ == NULL;
#line 2024 "File.c"
	}
#line 488 "../libcore/File.vala"
	if (_tmp14_) {
#line 2028 "File.c"
		GIcon* gicon = NULL;
		GIcon* _tmp22_;
#line 489 "../libcore/File.vala"
		gicon = NULL;
#line 490 "../libcore/File.vala"
		if (awaiting_thumbnail) {
#line 2035 "File.c"
			GThemedIcon* _tmp19_;
#line 491 "../libcore/File.vala"
			_tmp19_ = (GThemedIcon*) g_themed_icon_new ("image-loading");
#line 491 "../libcore/File.vala"
			_g_object_unref0 (gicon);
#line 491 "../libcore/File.vala"
			gicon = (GIcon*) _tmp19_;
#line 492 "../libcore/File.vala"
			self->priv->pix_is_final = FALSE;
#line 2045 "File.c"
		} else {
			GIcon* _tmp20_;
			GIcon* _tmp21_;
#line 494 "../libcore/File.vala"
			_tmp20_ = self->icon;
#line 494 "../libcore/File.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 494 "../libcore/File.vala"
			_g_object_unref0 (gicon);
#line 494 "../libcore/File.vala"
			gicon = _tmp21_;
#line 2057 "File.c"
		}
#line 497 "../libcore/File.vala"
		_tmp22_ = gicon;
#line 497 "../libcore/File.vala"
		if (_tmp22_ != NULL) {
#line 2063 "File.c"
			GIcon* _tmp23_;
			FilesIconInfo* _tmp24_;
			gboolean _tmp25_ = FALSE;
			FilesIconInfo* _tmp26_;
#line 498 "../libcore/File.vala"
			_tmp23_ = gicon;
#line 498 "../libcore/File.vala"
			_tmp24_ = files_icon_info_lookup (_tmp23_, requested_size, scale, self->is_remote);
#line 498 "../libcore/File.vala"
			_g_object_unref0 (iconinfo);
#line 498 "../libcore/File.vala"
			iconinfo = _tmp24_;
#line 499 "../libcore/File.vala"
			_tmp26_ = iconinfo;
#line 499 "../libcore/File.vala"
			if (_tmp26_ == NULL) {
#line 499 "../libcore/File.vala"
				_tmp25_ = TRUE;
#line 2082 "File.c"
			} else {
				FilesIconInfo* _tmp27_;
				GdkPixbuf* _tmp28_;
				GdkPixbuf* _tmp29_;
#line 499 "../libcore/File.vala"
				_tmp27_ = iconinfo;
#line 499 "../libcore/File.vala"
				_tmp28_ = files_icon_info_get_pixbuf (_tmp27_);
#line 499 "../libcore/File.vala"
				_tmp29_ = _tmp28_;
#line 499 "../libcore/File.vala"
				_tmp25_ = _tmp29_ == NULL;
#line 2095 "File.c"
			}
#line 499 "../libcore/File.vala"
			if (_tmp25_) {
#line 2099 "File.c"
				FilesIconInfo* _tmp30_;
#line 500 "../libcore/File.vala"
				_tmp30_ = files_icon_info_get_generic_icon (requested_size, scale);
#line 500 "../libcore/File.vala"
				_g_object_unref0 (iconinfo);
#line 500 "../libcore/File.vala"
				iconinfo = _tmp30_;
#line 2107 "File.c"
			}
		} else {
			FilesIconInfo* _tmp31_;
#line 503 "../libcore/File.vala"
			_tmp31_ = files_icon_info_get_generic_icon (requested_size, scale);
#line 503 "../libcore/File.vala"
			_g_object_unref0 (iconinfo);
#line 503 "../libcore/File.vala"
			iconinfo = _tmp31_;
#line 2117 "File.c"
		}
#line 488 "../libcore/File.vala"
		_g_object_unref0 (gicon);
#line 2121 "File.c"
	}
#line 507 "../libcore/File.vala"
	_tmp32_ = iconinfo;
#line 507 "../libcore/File.vala"
	g_assert_nonnull (_tmp32_);
#line 508 "../libcore/File.vala"
	result = iconinfo;
#line 508 "../libcore/File.vala"
	return result;
#line 2131 "File.c"
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 2179 "File.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 2185 "File.c"
}

void
files_file_update (FilesFile* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFileInfo* _tmp12_;
	const gchar* target_uri = NULL;
	GFileInfo* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gboolean _tmp70_ = FALSE;
	const gchar* _tmp71_;
	GFileInfo* _tmp95_;
	const gchar* _tmp106_;
	gchar* _tmp107_;
	GFileInfo* _tmp108_;
	GFileInfo* _tmp109_;
	GFileInfo* _tmp110_;
	const gchar* _tmp111_;
	gchar* _tmp112_;
	GFileInfo* _tmp113_;
	const gchar* _tmp114_;
	gchar* _tmp115_;
	GFileInfo* _tmp116_;
	GFileInfo* _tmp122_;
	GFileInfo* _tmp128_;
	GError* _inner_error0_ = NULL;
#line 511 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 512 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 512 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 513 "../libcore/File.vala"
		return;
#line 2226 "File.c"
	}
#line 517 "../libcore/File.vala"
	files_file_clear_info (self);
#line 518 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 518 "../libcore/File.vala"
	self->size = g_file_info_get_attribute_uint64 (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_SIZE);
#line 519 "../libcore/File.vala"
	_tmp2_ = self->info;
#line 519 "../libcore/File.vala"
	self->file_type = g_file_info_get_file_type (_tmp2_);
#line 520 "../libcore/File.vala"
	self->is_directory = self->file_type == G_FILE_TYPE_DIRECTORY;
#line 521 "../libcore/File.vala"
	_tmp3_ = self->info;
#line 521 "../libcore/File.vala"
	self->modified = g_file_info_get_attribute_uint64 (_tmp3_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 522 "../libcore/File.vala"
	_tmp4_ = self->info;
#line 522 "../libcore/File.vala"
	self->created = g_file_info_get_attribute_uint64 (_tmp4_, G_FILE_ATTRIBUTE_TIME_CREATED);
#line 525 "../libcore/File.vala"
	if (self->is_directory) {
#line 2250 "File.c"
		GFileInfo* _tmp5_;
		GFileInfo* _tmp8_;
#line 526 "../libcore/File.vala"
		_tmp5_ = self->info;
#line 526 "../libcore/File.vala"
		if (g_file_info_has_attribute (_tmp5_, "metadata::marlin-sort-column-id")) {
#line 2257 "File.c"
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
#line 527 "../libcore/File.vala"
			_tmp6_ = self->info;
#line 527 "../libcore/File.vala"
			_tmp7_ = g_file_info_get_attribute_string (_tmp6_, "metadata::marlin-sort-column-id");
#line 527 "../libcore/File.vala"
			self->sort_column_id = (gint) files_list_model_column_id_from_string (_tmp7_);
#line 2266 "File.c"
		}
#line 532 "../libcore/File.vala"
		_tmp8_ = self->info;
#line 532 "../libcore/File.vala"
		if (g_file_info_has_attribute (_tmp8_, "metadata::marlin-sort-reversed")) {
#line 2272 "File.c"
			GtkSortType _tmp9_ = 0;
			GFileInfo* _tmp10_;
			const gchar* _tmp11_;
#line 533 "../libcore/File.vala"
			_tmp10_ = self->info;
#line 533 "../libcore/File.vala"
			_tmp11_ = g_file_info_get_attribute_string (_tmp10_, "metadata::marlin-sort-reversed");
#line 533 "../libcore/File.vala"
			if (g_strcmp0 (_tmp11_, "true") == 0) {
#line 534 "../libcore/File.vala"
				_tmp9_ = GTK_SORT_DESCENDING;
#line 2284 "File.c"
			} else {
#line 534 "../libcore/File.vala"
				_tmp9_ = GTK_SORT_ASCENDING;
#line 2288 "File.c"
			}
#line 533 "../libcore/File.vala"
			self->sort_order = _tmp9_;
#line 2292 "File.c"
		}
	}
#line 538 "../libcore/File.vala"
	_tmp12_ = self->info;
#line 538 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp12_, G_FILE_ATTRIBUTE_STANDARD_ICON)) {
#line 2299 "File.c"
		GFileInfo* _tmp13_;
		GObject* _tmp14_;
		GIcon* _tmp15_;
#line 539 "../libcore/File.vala"
		_tmp13_ = self->info;
#line 539 "../libcore/File.vala"
		_tmp14_ = g_file_info_get_attribute_object (_tmp13_, G_FILE_ATTRIBUTE_STANDARD_ICON);
#line 539 "../libcore/File.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, g_icon_get_type ()) ? ((GIcon*) _tmp14_) : NULL);
#line 539 "../libcore/File.vala"
		_g_object_unref0 (self->icon);
#line 539 "../libcore/File.vala"
		self->icon = _tmp15_;
#line 2313 "File.c"
	}
#line 542 "../libcore/File.vala"
	_tmp16_ = self->info;
#line 542 "../libcore/File.vala"
	_tmp17_ = g_file_info_get_attribute_string (_tmp16_, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 542 "../libcore/File.vala"
	target_uri = _tmp17_;
#line 543 "../libcore/File.vala"
	_tmp18_ = target_uri;
#line 543 "../libcore/File.vala"
	if (_tmp18_ != NULL) {
#line 2325 "File.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
#line 544 "../libcore/File.vala"
		_tmp19_ = target_uri;
#line 544 "../libcore/File.vala"
		_tmp20_ = g_uri_parse_scheme (_tmp19_);
#line 544 "../libcore/File.vala"
		_tmp21_ = _tmp20_;
#line 544 "../libcore/File.vala"
		_tmp22_ = g_strcmp0 (_tmp21_, "afp") == 0;
#line 544 "../libcore/File.vala"
		_g_free0 (_tmp21_);
#line 544 "../libcore/File.vala"
		if (_tmp22_) {
#line 2342 "File.c"
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			GFile* _tmp27_;
#line 545 "../libcore/File.vala"
			_tmp23_ = target_uri;
#line 545 "../libcore/File.vala"
			_tmp24_ = self->priv->_uri;
#line 545 "../libcore/File.vala"
			_tmp25_ = files_file_utils_get_afp_target_uri (_tmp23_, _tmp24_);
#line 545 "../libcore/File.vala"
			_tmp26_ = _tmp25_;
#line 545 "../libcore/File.vala"
			_tmp27_ = g_file_new_for_uri (_tmp26_);
#line 545 "../libcore/File.vala"
			_g_object_unref0 (self->target_location);
#line 545 "../libcore/File.vala"
			self->target_location = _tmp27_;
#line 545 "../libcore/File.vala"
			_g_free0 (_tmp26_);
#line 2364 "File.c"
		} else {
			const gchar* _tmp28_;
			GFile* _tmp29_;
#line 547 "../libcore/File.vala"
			_tmp28_ = target_uri;
#line 547 "../libcore/File.vala"
			_tmp29_ = g_file_new_for_uri (_tmp28_);
#line 547 "../libcore/File.vala"
			_g_object_unref0 (self->target_location);
#line 547 "../libcore/File.vala"
			self->target_location = _tmp29_;
#line 2376 "File.c"
		}
#line 550 "../libcore/File.vala"
		files_file_target_location_update (self);
#line 2380 "File.c"
		{
			GMount* _tmp30_ = NULL;
			GFile* _tmp31_;
			GMount* _tmp32_;
			GMount* _tmp33_;
			GMount* _tmp34_;
#line 553 "../libcore/File.vala"
			_tmp31_ = self->target_location;
#line 553 "../libcore/File.vala"
			_tmp32_ = g_file_find_enclosing_mount (_tmp31_, NULL, &_inner_error0_);
#line 553 "../libcore/File.vala"
			_tmp30_ = _tmp32_;
#line 553 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2395 "File.c"
				goto __catch0_g_error;
			}
#line 553 "../libcore/File.vala"
			_tmp33_ = _tmp30_;
#line 553 "../libcore/File.vala"
			_tmp30_ = NULL;
#line 553 "../libcore/File.vala"
			_g_object_unref0 (self->mount);
#line 553 "../libcore/File.vala"
			self->mount = _tmp33_;
#line 554 "../libcore/File.vala"
			_tmp34_ = self->mount;
#line 554 "../libcore/File.vala"
			self->is_mounted = _tmp34_ != NULL;
#line 552 "../libcore/File.vala"
			_g_object_unref0 (_tmp30_);
#line 2412 "File.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp35_;
			const gchar* _tmp36_;
#line 552 "../libcore/File.vala"
			e = _inner_error0_;
#line 552 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 556 "../libcore/File.vala"
			self->is_mounted = FALSE;
#line 557 "../libcore/File.vala"
			_tmp35_ = e;
#line 557 "../libcore/File.vala"
			_tmp36_ = _tmp35_->message;
#line 557 "../libcore/File.vala"
			g_debug ("File.vala:557: %s", _tmp36_);
#line 552 "../libcore/File.vala"
			_g_error_free0 (e);
#line 2434 "File.c"
		}
		__finally0:
#line 552 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 552 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 552 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 552 "../libcore/File.vala"
			return;
#line 2445 "File.c"
		}
	} else {
		{
			GMount* _tmp37_ = NULL;
			GFile* _tmp38_;
			GMount* _tmp39_;
			GMount* _tmp40_;
			GMount* _tmp41_;
#line 561 "../libcore/File.vala"
			_tmp38_ = self->priv->_location;
#line 561 "../libcore/File.vala"
			_tmp39_ = g_file_find_enclosing_mount (_tmp38_, NULL, &_inner_error0_);
#line 561 "../libcore/File.vala"
			_tmp37_ = _tmp39_;
#line 561 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2462 "File.c"
				goto __catch1_g_error;
			}
#line 561 "../libcore/File.vala"
			_tmp40_ = _tmp37_;
#line 561 "../libcore/File.vala"
			_tmp37_ = NULL;
#line 561 "../libcore/File.vala"
			_g_object_unref0 (self->mount);
#line 561 "../libcore/File.vala"
			self->mount = _tmp40_;
#line 562 "../libcore/File.vala"
			_tmp41_ = self->mount;
#line 562 "../libcore/File.vala"
			self->is_mounted = _tmp41_ != NULL;
#line 560 "../libcore/File.vala"
			_g_object_unref0 (_tmp37_);
#line 2479 "File.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 560 "../libcore/File.vala"
			e = _inner_error0_;
#line 560 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 564 "../libcore/File.vala"
			self->is_mounted = FALSE;
#line 565 "../libcore/File.vala"
			_tmp42_ = e;
#line 565 "../libcore/File.vala"
			_tmp43_ = _tmp42_->message;
#line 565 "../libcore/File.vala"
			g_debug ("File.vala:565: %s", _tmp43_);
#line 560 "../libcore/File.vala"
			_g_error_free0 (e);
#line 2501 "File.c"
		}
		__finally1:
#line 560 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 560 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 560 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 560 "../libcore/File.vala"
			return;
#line 2512 "File.c"
		}
	}
#line 571 "../libcore/File.vala"
	self->is_desktop = files_file_is_desktop_file (self);
#line 572 "../libcore/File.vala"
	if (self->is_desktop) {
#line 2519 "File.c"
		{
			GKeyFile* key_file = NULL;
			GFile* _tmp44_;
			GKeyFile* _tmp45_;
			gchar* _tmp46_ = NULL;
			GKeyFile* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			const gchar* _tmp50_;
#line 574 "../libcore/File.vala"
			_tmp44_ = self->priv->_location;
#line 574 "../libcore/File.vala"
			_tmp45_ = files_file_utils_key_file_from_file (_tmp44_, NULL, &_inner_error0_);
#line 574 "../libcore/File.vala"
			key_file = _tmp45_;
#line 574 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2537 "File.c"
				goto __catch2_g_error;
			}
#line 575 "../libcore/File.vala"
			_tmp47_ = key_file;
#line 575 "../libcore/File.vala"
			_tmp48_ = g_key_file_get_string (_tmp47_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, &_inner_error0_);
#line 575 "../libcore/File.vala"
			_tmp46_ = _tmp48_;
#line 575 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 575 "../libcore/File.vala"
				_g_key_file_unref0 (key_file);
#line 2550 "File.c"
				goto __catch2_g_error;
			}
#line 575 "../libcore/File.vala"
			_tmp49_ = _tmp46_;
#line 575 "../libcore/File.vala"
			_tmp46_ = NULL;
#line 575 "../libcore/File.vala"
			_g_free0 (self->custom_icon_name);
#line 575 "../libcore/File.vala"
			self->custom_icon_name = _tmp49_;
#line 577 "../libcore/File.vala"
			_tmp50_ = self->custom_icon_name;
#line 577 "../libcore/File.vala"
			if (!g_path_is_absolute (_tmp50_)) {
#line 2565 "File.c"
				const gchar* _tmp51_;
				gchar** _tmp52_;
				gchar** _tmp53_;
				gchar** _tmp54_;
				gint _tmp54__length1;
				const gchar* _tmp55_;
				gchar* _tmp56_;
#line 578 "../libcore/File.vala"
				_tmp51_ = self->custom_icon_name;
#line 578 "../libcore/File.vala"
				_tmp53_ = _tmp52_ = g_strsplit (_tmp51_, ".", 2);
#line 578 "../libcore/File.vala"
				_tmp54_ = _tmp53_;
#line 578 "../libcore/File.vala"
				_tmp54__length1 = _vala_array_length (_tmp52_);
#line 578 "../libcore/File.vala"
				_tmp55_ = _tmp54_[0];
#line 578 "../libcore/File.vala"
				_tmp56_ = g_strdup (_tmp55_);
#line 578 "../libcore/File.vala"
				_g_free0 (self->custom_icon_name);
#line 578 "../libcore/File.vala"
				self->custom_icon_name = _tmp56_;
#line 578 "../libcore/File.vala"
				_tmp54_ = (_vala_array_free (_tmp54_, _tmp54__length1, (GDestroyNotify) g_free), NULL);
#line 2591 "File.c"
			}
#line 573 "../libcore/File.vala"
			_g_free0 (_tmp46_);
#line 573 "../libcore/File.vala"
			_g_key_file_unref0 (key_file);
#line 2597 "File.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp57_;
			const gchar* _tmp58_;
#line 573 "../libcore/File.vala"
			e = _inner_error0_;
#line 573 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 581 "../libcore/File.vala"
			_tmp57_ = e;
#line 581 "../libcore/File.vala"
			_tmp58_ = _tmp57_->message;
#line 581 "../libcore/File.vala"
			g_debug ("File.vala:581: %s", _tmp58_);
#line 573 "../libcore/File.vala"
			_g_error_free0 (e);
#line 2617 "File.c"
		}
		__finally2:
#line 573 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 573 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 573 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 573 "../libcore/File.vala"
			return;
#line 2628 "File.c"
		}
		{
			GKeyFile* key_file = NULL;
			GFile* _tmp59_;
			GKeyFile* _tmp60_;
			gchar* type = NULL;
			GKeyFile* _tmp61_;
			gchar* _tmp62_;
			const gchar* _tmp63_;
#line 586 "../libcore/File.vala"
			_tmp59_ = self->priv->_location;
#line 586 "../libcore/File.vala"
			_tmp60_ = files_file_utils_key_file_from_file (_tmp59_, NULL, &_inner_error0_);
#line 586 "../libcore/File.vala"
			key_file = _tmp60_;
#line 586 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2646 "File.c"
				goto __catch3_g_error;
			}
#line 587 "../libcore/File.vala"
			_tmp61_ = key_file;
#line 587 "../libcore/File.vala"
			_tmp62_ = g_key_file_get_string (_tmp61_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, &_inner_error0_);
#line 587 "../libcore/File.vala"
			type = _tmp62_;
#line 587 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 587 "../libcore/File.vala"
				_g_key_file_unref0 (key_file);
#line 2659 "File.c"
				goto __catch3_g_error;
			}
#line 588 "../libcore/File.vala"
			_tmp63_ = type;
#line 588 "../libcore/File.vala"
			if (g_strcmp0 (_tmp63_, G_KEY_FILE_DESKTOP_TYPE_LINK) == 0) {
#line 2666 "File.c"
				gchar* url = NULL;
				GKeyFile* _tmp64_;
				gchar* _tmp65_;
				const gchar* _tmp66_;
				GFile* _tmp67_;
#line 589 "../libcore/File.vala"
				_tmp64_ = key_file;
#line 589 "../libcore/File.vala"
				_tmp65_ = g_key_file_get_string (_tmp64_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_URL, &_inner_error0_);
#line 589 "../libcore/File.vala"
				url = _tmp65_;
#line 589 "../libcore/File.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 589 "../libcore/File.vala"
					_g_free0 (type);
#line 589 "../libcore/File.vala"
					_g_key_file_unref0 (key_file);
#line 2684 "File.c"
					goto __catch3_g_error;
				}
#line 590 "../libcore/File.vala"
				_tmp66_ = url;
#line 590 "../libcore/File.vala"
				_tmp67_ = g_file_new_for_uri (_tmp66_);
#line 590 "../libcore/File.vala"
				_g_object_unref0 (self->target_location);
#line 590 "../libcore/File.vala"
				self->target_location = _tmp67_;
#line 591 "../libcore/File.vala"
				files_file_target_location_update (self);
#line 588 "../libcore/File.vala"
				_g_free0 (url);
#line 2699 "File.c"
			}
#line 585 "../libcore/File.vala"
			_g_free0 (type);
#line 585 "../libcore/File.vala"
			_g_key_file_unref0 (key_file);
#line 2705 "File.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp68_;
			const gchar* _tmp69_;
#line 585 "../libcore/File.vala"
			e = _inner_error0_;
#line 585 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 594 "../libcore/File.vala"
			_tmp68_ = e;
#line 594 "../libcore/File.vala"
			_tmp69_ = _tmp68_->message;
#line 594 "../libcore/File.vala"
			g_debug ("File.vala:594: %s", _tmp69_);
#line 585 "../libcore/File.vala"
			_g_error_free0 (e);
#line 2725 "File.c"
		}
		__finally3:
#line 585 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 585 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 585 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 585 "../libcore/File.vala"
			return;
#line 2736 "File.c"
		}
	}
#line 599 "../libcore/File.vala"
	_tmp71_ = self->custom_display_name;
#line 599 "../libcore/File.vala"
	if (_tmp71_ == NULL) {
#line 2743 "File.c"
		GFileInfo* _tmp72_;
#line 599 "../libcore/File.vala"
		_tmp72_ = self->info;
#line 599 "../libcore/File.vala"
		_tmp70_ = _tmp72_ != NULL;
#line 2749 "File.c"
	} else {
#line 599 "../libcore/File.vala"
		_tmp70_ = FALSE;
#line 2753 "File.c"
	}
#line 599 "../libcore/File.vala"
	if (_tmp70_) {
#line 2757 "File.c"
		const gchar* disp_name = NULL;
		GFileInfo* _tmp73_;
		const gchar* _tmp74_;
		gchar* _tmp75_ = NULL;
		GFile* _tmp76_;
		gchar* target_uri_scheme = NULL;
		gchar* _tmp79_;
		gboolean _tmp80_ = FALSE;
		gboolean _tmp81_ = FALSE;
		GFile* _tmp82_;
#line 600 "../libcore/File.vala"
		_tmp73_ = self->info;
#line 600 "../libcore/File.vala"
		_tmp74_ = g_file_info_get_display_name (_tmp73_);
#line 600 "../libcore/File.vala"
		disp_name = _tmp74_;
#line 601 "../libcore/File.vala"
		_tmp76_ = self->target_location;
#line 601 "../libcore/File.vala"
		if (_tmp76_ != NULL) {
#line 2778 "File.c"
			GFile* _tmp77_;
			gchar* _tmp78_;
#line 601 "../libcore/File.vala"
			_tmp77_ = self->target_location;
#line 601 "../libcore/File.vala"
			_tmp78_ = g_file_get_uri_scheme (_tmp77_);
#line 601 "../libcore/File.vala"
			_g_free0 (_tmp75_);
#line 601 "../libcore/File.vala"
			_tmp75_ = _tmp78_;
#line 2789 "File.c"
		} else {
#line 601 "../libcore/File.vala"
			_g_free0 (_tmp75_);
#line 601 "../libcore/File.vala"
			_tmp75_ = NULL;
#line 2795 "File.c"
		}
#line 601 "../libcore/File.vala"
		_tmp79_ = g_strdup (_tmp75_);
#line 601 "../libcore/File.vala"
		target_uri_scheme = _tmp79_;
#line 602 "../libcore/File.vala"
		_tmp82_ = self->priv->_directory;
#line 602 "../libcore/File.vala"
		if (_tmp82_ != NULL) {
#line 2805 "File.c"
			GFile* _tmp83_;
			gchar* _tmp84_;
			gchar* _tmp85_;
#line 602 "../libcore/File.vala"
			_tmp83_ = self->priv->_directory;
#line 602 "../libcore/File.vala"
			_tmp84_ = g_file_get_uri_scheme (_tmp83_);
#line 602 "../libcore/File.vala"
			_tmp85_ = _tmp84_;
#line 602 "../libcore/File.vala"
			_tmp81_ = g_strcmp0 (_tmp85_, "network") == 0;
#line 602 "../libcore/File.vala"
			_g_free0 (_tmp85_);
#line 2819 "File.c"
		} else {
#line 602 "../libcore/File.vala"
			_tmp81_ = FALSE;
#line 2823 "File.c"
		}
#line 602 "../libcore/File.vala"
		if (_tmp81_) {
#line 2827 "File.c"
			const gchar* _tmp86_;
#line 602 "../libcore/File.vala"
			_tmp86_ = target_uri_scheme;
#line 602 "../libcore/File.vala"
			_tmp80_ = g_strcmp0 (_tmp86_, "smb") != 0;
#line 2833 "File.c"
		} else {
#line 602 "../libcore/File.vala"
			_tmp80_ = FALSE;
#line 2837 "File.c"
		}
#line 602 "../libcore/File.vala"
		if (_tmp80_) {
#line 2841 "File.c"
			const gchar* _tmp87_;
			const gchar* _tmp88_;
			gint _tmp89_ = 0;
			gchar* _tmp90_;
			gchar* _tmp91_;
			gchar* _tmp92_;
#line 604 "../libcore/File.vala"
			_tmp87_ = disp_name;
#line 604 "../libcore/File.vala"
			_tmp88_ = target_uri_scheme;
#line 604 "../libcore/File.vala"
			_tmp90_ = string_to_utf8 (_tmp88_, &_tmp89_);
#line 604 "../libcore/File.vala"
			_tmp91_ = (gchar*) _tmp90_;
#line 604 "../libcore/File.vala"
			_tmp92_ = g_strdup_printf ("%s (%s)", _tmp87_, _tmp91_);
#line 604 "../libcore/File.vala"
			_g_free0 (self->custom_display_name);
#line 604 "../libcore/File.vala"
			self->custom_display_name = _tmp92_;
#line 604 "../libcore/File.vala"
			_g_free0 (_tmp91_);
#line 2864 "File.c"
		} else {
			const gchar* _tmp93_;
			gchar* _tmp94_;
#line 606 "../libcore/File.vala"
			_tmp93_ = disp_name;
#line 606 "../libcore/File.vala"
			_tmp94_ = g_strdup (_tmp93_);
#line 606 "../libcore/File.vala"
			_g_free0 (self->custom_display_name);
#line 606 "../libcore/File.vala"
			self->custom_display_name = _tmp94_;
#line 2876 "File.c"
		}
#line 599 "../libcore/File.vala"
		_g_free0 (target_uri_scheme);
#line 599 "../libcore/File.vala"
		_g_free0 (_tmp75_);
#line 2882 "File.c"
	}
#line 611 "../libcore/File.vala"
	files_file_ensure_size (self);
#line 613 "../libcore/File.vala"
	_tmp95_ = self->info;
#line 613 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp95_, G_FILE_ATTRIBUTE_TIME_MODIFIED)) {
#line 2890 "File.c"
		gchar* _tmp96_;
#line 614 "../libcore/File.vala"
		_tmp96_ = files_file_get_formated_time (self, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 614 "../libcore/File.vala"
		_g_free0 (self->formated_modified);
#line 614 "../libcore/File.vala"
		self->formated_modified = _tmp96_;
#line 2898 "File.c"
	} else {
		gchar* _tmp97_;
#line 616 "../libcore/File.vala"
		_tmp97_ = g_strdup (_ ("Inaccessible"));
#line 616 "../libcore/File.vala"
		_g_free0 (self->formated_modified);
#line 616 "../libcore/File.vala"
		self->formated_modified = _tmp97_;
#line 2907 "File.c"
	}
#line 620 "../libcore/File.vala"
	if (self->is_directory) {
#line 621 "../libcore/File.vala"
		files_file_get_folder_icon_from_uri_or_path (self);
#line 2913 "File.c"
	} else {
		GFileInfo* _tmp98_;
#line 622 "../libcore/File.vala"
		_tmp98_ = self->info;
#line 622 "../libcore/File.vala"
		if (g_file_info_get_file_type (_tmp98_) == G_FILE_TYPE_MOUNTABLE) {
#line 2920 "File.c"
			GThemedIcon* _tmp99_;
#line 623 "../libcore/File.vala"
			_tmp99_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("folder-remote");
#line 623 "../libcore/File.vala"
			_g_object_unref0 (self->icon);
#line 623 "../libcore/File.vala"
			self->icon = (GIcon*) _tmp99_;
#line 2928 "File.c"
		} else {
			const gchar* ftype = NULL;
			const gchar* _tmp100_;
			gboolean _tmp101_ = FALSE;
			const gchar* _tmp102_;
#line 625 "../libcore/File.vala"
			_tmp100_ = files_file_get_ftype (self);
#line 625 "../libcore/File.vala"
			ftype = _tmp100_;
#line 626 "../libcore/File.vala"
			_tmp102_ = ftype;
#line 626 "../libcore/File.vala"
			if (_tmp102_ != NULL) {
#line 2942 "File.c"
				GIcon* _tmp103_;
#line 626 "../libcore/File.vala"
				_tmp103_ = self->icon;
#line 626 "../libcore/File.vala"
				_tmp101_ = _tmp103_ == NULL;
#line 2948 "File.c"
			} else {
#line 626 "../libcore/File.vala"
				_tmp101_ = FALSE;
#line 2952 "File.c"
			}
#line 626 "../libcore/File.vala"
			if (_tmp101_) {
#line 2956 "File.c"
				const gchar* _tmp104_;
				GIcon* _tmp105_;
#line 627 "../libcore/File.vala"
				_tmp104_ = ftype;
#line 627 "../libcore/File.vala"
				_tmp105_ = g_content_type_get_icon (_tmp104_);
#line 627 "../libcore/File.vala"
				_g_object_unref0 (self->icon);
#line 627 "../libcore/File.vala"
				self->icon = _tmp105_;
#line 2967 "File.c"
			}
		}
	}
#line 631 "../libcore/File.vala"
	_tmp106_ = files_file_get_display_name (self);
#line 631 "../libcore/File.vala"
	_tmp107_ = g_utf8_collate_key_for_filename (_tmp106_, (gssize) -1);
#line 631 "../libcore/File.vala"
	_g_free0 (self->utf8_collation_key);
#line 631 "../libcore/File.vala"
	self->utf8_collation_key = _tmp107_;
#line 634 "../libcore/File.vala"
	self->thumbstate = (guint) FILES_FILE_THUMB_STATE_UNKNOWN;
#line 636 "../libcore/File.vala"
	files_file_update_formated_type (self);
#line 639 "../libcore/File.vala"
	_tmp108_ = self->info;
#line 639 "../libcore/File.vala"
	self->has_permissions = g_file_info_has_attribute (_tmp108_, G_FILE_ATTRIBUTE_UNIX_MODE);
#line 640 "../libcore/File.vala"
	_tmp109_ = self->info;
#line 640 "../libcore/File.vala"
	self->permissions = g_file_info_get_attribute_uint32 (_tmp109_, G_FILE_ATTRIBUTE_UNIX_MODE);
#line 641 "../libcore/File.vala"
	_tmp110_ = self->info;
#line 641 "../libcore/File.vala"
	_tmp111_ = g_file_info_get_attribute_string (_tmp110_, G_FILE_ATTRIBUTE_OWNER_USER);
#line 641 "../libcore/File.vala"
	_tmp112_ = g_strdup (_tmp111_);
#line 641 "../libcore/File.vala"
	_g_free0 (self->owner);
#line 641 "../libcore/File.vala"
	self->owner = _tmp112_;
#line 642 "../libcore/File.vala"
	_tmp113_ = self->info;
#line 642 "../libcore/File.vala"
	_tmp114_ = g_file_info_get_attribute_string (_tmp113_, G_FILE_ATTRIBUTE_OWNER_GROUP);
#line 642 "../libcore/File.vala"
	_tmp115_ = g_strdup (_tmp114_);
#line 642 "../libcore/File.vala"
	_g_free0 (self->group);
#line 642 "../libcore/File.vala"
	self->group = _tmp115_;
#line 643 "../libcore/File.vala"
	_tmp116_ = self->info;
#line 643 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp116_, G_FILE_ATTRIBUTE_UNIX_UID)) {
#line 3015 "File.c"
		GFileInfo* _tmp117_;
		const gchar* _tmp118_;
#line 644 "../libcore/File.vala"
		_tmp117_ = self->info;
#line 644 "../libcore/File.vala"
		self->uid = g_file_info_get_attribute_uint32 (_tmp117_, G_FILE_ATTRIBUTE_UNIX_UID);
#line 645 "../libcore/File.vala"
		_tmp118_ = self->owner;
#line 645 "../libcore/File.vala"
		if (_tmp118_ == NULL) {
#line 3026 "File.c"
			gchar* _tmp119_;
#line 646 "../libcore/File.vala"
			_tmp119_ = g_strdup_printf ("%u", self->uid);
#line 646 "../libcore/File.vala"
			_g_free0 (self->owner);
#line 646 "../libcore/File.vala"
			self->owner = _tmp119_;
#line 3034 "File.c"
		}
	} else {
		const gchar* _tmp120_;
#line 648 "../libcore/File.vala"
		_tmp120_ = self->owner;
#line 648 "../libcore/File.vala"
		if (_tmp120_ != NULL) {
#line 3042 "File.c"
			const gchar* _tmp121_;
#line 649 "../libcore/File.vala"
			_tmp121_ = self->owner;
#line 649 "../libcore/File.vala"
			self->uid = (guint32) atoi (_tmp121_);
#line 3048 "File.c"
		} else {
#line 651 "../libcore/File.vala"
			_g_free0 (self->owner);
#line 651 "../libcore/File.vala"
			self->owner = NULL;
#line 3054 "File.c"
		}
	}
#line 654 "../libcore/File.vala"
	_tmp122_ = self->info;
#line 654 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp122_, G_FILE_ATTRIBUTE_UNIX_GID)) {
#line 3061 "File.c"
		GFileInfo* _tmp123_;
		const gchar* _tmp124_;
#line 655 "../libcore/File.vala"
		_tmp123_ = self->info;
#line 655 "../libcore/File.vala"
		self->gid = g_file_info_get_attribute_uint32 (_tmp123_, G_FILE_ATTRIBUTE_UNIX_GID);
#line 656 "../libcore/File.vala"
		_tmp124_ = self->group;
#line 656 "../libcore/File.vala"
		if (_tmp124_ == NULL) {
#line 3072 "File.c"
			gchar* _tmp125_;
#line 657 "../libcore/File.vala"
			_tmp125_ = g_strdup_printf ("%u", self->gid);
#line 657 "../libcore/File.vala"
			_g_free0 (self->group);
#line 657 "../libcore/File.vala"
			self->group = _tmp125_;
#line 3080 "File.c"
		}
	} else {
		const gchar* _tmp126_;
#line 659 "../libcore/File.vala"
		_tmp126_ = self->group;
#line 659 "../libcore/File.vala"
		if (_tmp126_ != NULL) {
#line 3088 "File.c"
			const gchar* _tmp127_;
#line 660 "../libcore/File.vala"
			_tmp127_ = self->group;
#line 660 "../libcore/File.vala"
			self->gid = (guint32) atoi (_tmp127_);
#line 3094 "File.c"
		} else {
#line 662 "../libcore/File.vala"
			_g_free0 (self->group);
#line 662 "../libcore/File.vala"
			self->group = NULL;
#line 3100 "File.c"
		}
	}
#line 665 "../libcore/File.vala"
	_tmp128_ = self->info;
#line 665 "../libcore/File.vala"
	if (g_file_info_has_attribute (_tmp128_, G_FILE_ATTRIBUTE_MOUNTABLE_CAN_UNMOUNT)) {
#line 3107 "File.c"
		GFileInfo* _tmp129_;
#line 666 "../libcore/File.vala"
		_tmp129_ = self->info;
#line 666 "../libcore/File.vala"
		self->can_unmount = g_file_info_get_attribute_boolean (_tmp129_, G_FILE_ATTRIBUTE_MOUNTABLE_CAN_UNMOUNT);
#line 3113 "File.c"
	}
#line 669 "../libcore/File.vala"
	files_file_update_emblem (self);
#line 3117 "File.c"
}

void
files_file_update_type (FilesFile* self)
{
	const gchar* ftype = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp4_ = FALSE;
#line 672 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 673 "../libcore/File.vala"
	files_file_update_formated_type (self);
#line 675 "../libcore/File.vala"
	_tmp0_ = files_file_get_ftype (self);
#line 675 "../libcore/File.vala"
	ftype = _tmp0_;
#line 676 "../libcore/File.vala"
	_tmp1_ = ftype;
#line 676 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 3139 "File.c"
		const gchar* _tmp2_;
		GIcon* _tmp3_;
#line 677 "../libcore/File.vala"
		_tmp2_ = ftype;
#line 677 "../libcore/File.vala"
		_tmp3_ = g_content_type_get_icon (_tmp2_);
#line 677 "../libcore/File.vala"
		_g_object_unref0 (self->icon);
#line 677 "../libcore/File.vala"
		self->icon = _tmp3_;
#line 3150 "File.c"
	}
#line 680 "../libcore/File.vala"
	if (self->pix_size > 1) {
#line 680 "../libcore/File.vala"
		_tmp4_ = self->pix_scale > 0;
#line 3156 "File.c"
	} else {
#line 680 "../libcore/File.vala"
		_tmp4_ = FALSE;
#line 3160 "File.c"
	}
#line 680 "../libcore/File.vala"
	if (_tmp4_) {
#line 681 "../libcore/File.vala"
		files_file_update_icon (self, self->pix_size, self->pix_scale);
#line 682 "../libcore/File.vala"
		g_signal_emit (self, files_file_signals[FILES_FILE_ICON_CHANGED_SIGNAL], 0);
#line 3168 "File.c"
	}
}

void
files_file_update_icon (FilesFile* self,
                        gint _size,
                        gint _scale)
{
	gint requested_size = 0;
	gint requested_scale = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean same_size = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean valid_thumbnail = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GdkPixbuf* _tmp17_;
	FilesIconInfo* iconinfo = NULL;
	FilesIconInfo* _tmp18_;
	FilesIconInfo* _tmp19_;
	GdkPixbuf* _tmp20_;
#line 689 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 690 "../libcore/File.vala"
	requested_size = _size;
#line 691 "../libcore/File.vala"
	requested_scale = _scale;
#line 693 "../libcore/File.vala"
	if (_size < 16) {
#line 694 "../libcore/File.vala"
		requested_size = self->pix_size;
#line 3202 "File.c"
	}
#line 697 "../libcore/File.vala"
	if (_scale < 1) {
#line 698 "../libcore/File.vala"
		requested_scale = self->pix_scale;
#line 3208 "File.c"
	}
#line 701 "../libcore/File.vala"
	if (self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_UNKNOWN)) {
#line 3212 "File.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 701 "../libcore/File.vala"
		_tmp1_ = files_file_get_thumbnail_path (self);
#line 701 "../libcore/File.vala"
		_tmp2_ = _tmp1_;
#line 701 "../libcore/File.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 3221 "File.c"
	} else {
#line 701 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 3225 "File.c"
	}
#line 701 "../libcore/File.vala"
	if (_tmp0_) {
#line 3229 "File.c"
		const gchar* _tmp3_;
		gchar* md5_hash = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* base_name = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 702 "../libcore/File.vala"
		_tmp3_ = self->priv->_uri;
#line 702 "../libcore/File.vala"
		g_debug ("File.vala:702: Making own thumbnail path for %s - no attribute", _tmp3_);
#line 704 "../libcore/File.vala"
		_tmp4_ = self->priv->_uri;
#line 704 "../libcore/File.vala"
		_tmp5_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp4_, (gsize) -1);
#line 704 "../libcore/File.vala"
		md5_hash = _tmp5_;
#line 705 "../libcore/File.vala"
		_tmp6_ = md5_hash;
#line 705 "../libcore/File.vala"
		_tmp7_ = g_strdup_printf ("%s.png", _tmp6_);
#line 705 "../libcore/File.vala"
		base_name = _tmp7_;
#line 711 "../libcore/File.vala"
		_tmp8_ = g_get_user_cache_dir ();
#line 711 "../libcore/File.vala"
		_tmp9_ = base_name;
#line 711 "../libcore/File.vala"
		_tmp10_ = g_build_filename (_tmp8_, "thumbnails", "large", _tmp9_, NULL);
#line 711 "../libcore/File.vala"
		_tmp11_ = _tmp10_;
#line 711 "../libcore/File.vala"
		files_file_set_thumbnail_path (self, _tmp11_);
#line 711 "../libcore/File.vala"
		_g_free0 (_tmp11_);
#line 701 "../libcore/File.vala"
		_g_free0 (base_name);
#line 701 "../libcore/File.vala"
		_g_free0 (md5_hash);
#line 3273 "File.c"
	}
#line 719 "../libcore/File.vala"
	if (self->pix_size == requested_size) {
#line 719 "../libcore/File.vala"
		_tmp12_ = self->pix_scale == requested_scale;
#line 3279 "File.c"
	} else {
#line 719 "../libcore/File.vala"
		_tmp12_ = FALSE;
#line 3283 "File.c"
	}
#line 719 "../libcore/File.vala"
	same_size = _tmp12_;
#line 720 "../libcore/File.vala"
	if (self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_NONE)) {
#line 720 "../libcore/File.vala"
		_tmp14_ = TRUE;
#line 3291 "File.c"
	} else {
#line 721 "../libcore/File.vala"
		_tmp14_ = self->thumbstate == ((guint) FILES_FILE_THUMB_STATE_READY);
#line 3295 "File.c"
	}
#line 720 "../libcore/File.vala"
	if (_tmp14_) {
#line 722 "../libcore/File.vala"
		_tmp13_ = self->priv->pix_is_final;
#line 3301 "File.c"
	} else {
#line 720 "../libcore/File.vala"
		_tmp13_ = FALSE;
#line 3305 "File.c"
	}
#line 720 "../libcore/File.vala"
	valid_thumbnail = _tmp13_;
#line 724 "../libcore/File.vala"
	_tmp17_ = self->pix;
#line 724 "../libcore/File.vala"
	if (_tmp17_ != NULL) {
#line 724 "../libcore/File.vala"
		_tmp16_ = same_size;
#line 3315 "File.c"
	} else {
#line 724 "../libcore/File.vala"
		_tmp16_ = FALSE;
#line 3319 "File.c"
	}
#line 724 "../libcore/File.vala"
	if (_tmp16_) {
#line 724 "../libcore/File.vala"
		_tmp15_ = valid_thumbnail;
#line 3325 "File.c"
	} else {
#line 724 "../libcore/File.vala"
		_tmp15_ = FALSE;
#line 3329 "File.c"
	}
#line 724 "../libcore/File.vala"
	if (_tmp15_) {
#line 725 "../libcore/File.vala"
		return;
#line 3335 "File.c"
	}
#line 728 "../libcore/File.vala"
	_tmp18_ = files_file_get_icon (self, requested_size, requested_scale, FILES_FILE_ICON_FLAGS_USE_THUMBNAILS);
#line 728 "../libcore/File.vala"
	iconinfo = _tmp18_;
#line 729 "../libcore/File.vala"
	_tmp19_ = iconinfo;
#line 729 "../libcore/File.vala"
	_tmp20_ = files_icon_info_get_pixbuf_nodefault (_tmp19_);
#line 729 "../libcore/File.vala"
	_g_object_unref0 (self->pix);
#line 729 "../libcore/File.vala"
	self->pix = _tmp20_;
#line 730 "../libcore/File.vala"
	self->pix_size = requested_size;
#line 731 "../libcore/File.vala"
	self->pix_scale = requested_scale;
#line 689 "../libcore/File.vala"
	_g_object_unref0 (iconinfo);
#line 3355 "File.c"
}

void
files_file_update_desktop_file (FilesFile* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 734 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 735 "../libcore/File.vala"
	_tmp0_ = files_file_get_display_name (self);
#line 735 "../libcore/File.vala"
	_tmp1_ = g_utf8_collate_key_for_filename (_tmp0_, (gssize) -1);
#line 735 "../libcore/File.vala"
	_g_free0 (self->utf8_collation_key);
#line 735 "../libcore/File.vala"
	self->utf8_collation_key = _tmp1_;
#line 736 "../libcore/File.vala"
	files_file_update_formated_type (self);
#line 737 "../libcore/File.vala"
	files_file_ensure_size (self);
#line 738 "../libcore/File.vala"
	g_signal_emit (self, files_file_signals[FILES_FILE_ICON_CHANGED_SIGNAL], 0);
#line 3379 "File.c"
}

void
files_file_query_update (FilesFile* self)
{
	GFileInfo* _info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
#line 742 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 743 "../libcore/File.vala"
	_tmp0_ = files_file_query_info (self);
#line 743 "../libcore/File.vala"
	_info = _tmp0_;
#line 744 "../libcore/File.vala"
	_tmp1_ = _info;
#line 744 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 3398 "File.c"
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 745 "../libcore/File.vala"
		_tmp2_ = _info;
#line 745 "../libcore/File.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 745 "../libcore/File.vala"
		_g_object_unref0 (self->info);
#line 745 "../libcore/File.vala"
		self->info = _tmp3_;
#line 746 "../libcore/File.vala"
		files_file_update (self);
#line 3411 "File.c"
	}
#line 742 "../libcore/File.vala"
	_g_object_unref0 (_info);
#line 3415 "File.c"
}

gboolean
files_file_ensure_query_info (FilesFile* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gboolean result;
#line 751 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 752 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 752 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 753 "../libcore/File.vala"
		files_file_query_update (self);
#line 3432 "File.c"
	}
#line 756 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 756 "../libcore/File.vala"
	result = _tmp1_ != NULL;
#line 756 "../libcore/File.vala"
	return result;
#line 3440 "File.c"
}

static guint
uint_parse (const gchar* str,
            guint _base)
{
	guint result;
#line 213 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0U);
#line 214 "glib-2.0.vapi"
	result = (guint) strtoul (str, NULL, (gint) _base);
#line 214 "glib-2.0.vapi"
	return result;
#line 3454 "File.c"
}

gboolean
files_file_can_set_owner (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 759 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 761 "../libcore/File.vala"
	if (self->uid == ((guint32) -1)) {
#line 761 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 3470 "File.c"
	} else {
		const gchar* _tmp3_;
#line 762 "../libcore/File.vala"
		_tmp3_ = self->owner;
#line 762 "../libcore/File.vala"
		_tmp2_ = _tmp3_ == NULL;
#line 3477 "File.c"
	}
#line 761 "../libcore/File.vala"
	if (_tmp2_) {
#line 761 "../libcore/File.vala"
		_tmp1_ = TRUE;
#line 3483 "File.c"
	} else {
		const gchar* _tmp4_;
#line 763 "../libcore/File.vala"
		_tmp4_ = self->owner;
#line 763 "../libcore/File.vala"
		_tmp1_ = self->uid == ((guint32) uint_parse (_tmp4_, (guint) 0));
#line 3490 "File.c"
	}
#line 761 "../libcore/File.vala"
	if (_tmp1_) {
#line 761 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 3496 "File.c"
	} else {
#line 764 "../libcore/File.vala"
		_tmp0_ = files_file_is_trashed (self);
#line 3500 "File.c"
	}
#line 761 "../libcore/File.vala"
	if (_tmp0_) {
#line 766 "../libcore/File.vala"
		result = FALSE;
#line 766 "../libcore/File.vala"
		return result;
#line 3508 "File.c"
	}
#line 769 "../libcore/File.vala"
	result = geteuid () == ((uid_t) 0);
#line 769 "../libcore/File.vala"
	return result;
#line 3514 "File.c"
}

gboolean
files_file_can_set_group (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	uid_t user_id = {0};
	gboolean result;
#line 772 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 773 "../libcore/File.vala"
	if (self->gid == ((guint32) -1)) {
#line 773 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 3531 "File.c"
	} else {
		const gchar* _tmp3_;
#line 774 "../libcore/File.vala"
		_tmp3_ = self->group;
#line 774 "../libcore/File.vala"
		_tmp2_ = _tmp3_ == NULL;
#line 3538 "File.c"
	}
#line 773 "../libcore/File.vala"
	if (_tmp2_) {
#line 773 "../libcore/File.vala"
		_tmp1_ = TRUE;
#line 3544 "File.c"
	} else {
		const gchar* _tmp4_;
#line 775 "../libcore/File.vala"
		_tmp4_ = self->group;
#line 775 "../libcore/File.vala"
		_tmp1_ = self->gid == ((guint32) uint_parse (_tmp4_, (guint) 0));
#line 3551 "File.c"
	}
#line 773 "../libcore/File.vala"
	if (_tmp1_) {
#line 773 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 3557 "File.c"
	} else {
#line 776 "../libcore/File.vala"
		_tmp0_ = files_file_is_trashed (self);
#line 3561 "File.c"
	}
#line 773 "../libcore/File.vala"
	if (_tmp0_) {
#line 778 "../libcore/File.vala"
		result = FALSE;
#line 778 "../libcore/File.vala"
		return result;
#line 3569 "File.c"
	}
#line 781 "../libcore/File.vala"
	user_id = geteuid ();
#line 783 "../libcore/File.vala"
	if (user_id == ((uid_t) self->uid)) {
#line 784 "../libcore/File.vala"
		result = TRUE;
#line 784 "../libcore/File.vala"
		return result;
#line 3579 "File.c"
	}
#line 788 "../libcore/File.vala"
	if (user_id == ((uid_t) 0)) {
#line 789 "../libcore/File.vala"
		result = TRUE;
#line 789 "../libcore/File.vala"
		return result;
#line 3587 "File.c"
	}
#line 791 "../libcore/File.vala"
	result = FALSE;
#line 791 "../libcore/File.vala"
	return result;
#line 3593 "File.c"
}

gboolean
files_file_can_set_permissions (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp5_;
	gboolean result;
#line 794 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../libcore/File.vala"
	if (self->uid == ((guint32) -1)) {
#line 795 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 3610 "File.c"
	} else {
		const gchar* _tmp3_;
#line 796 "../libcore/File.vala"
		_tmp3_ = self->owner;
#line 796 "../libcore/File.vala"
		_tmp2_ = _tmp3_ == NULL;
#line 3617 "File.c"
	}
#line 795 "../libcore/File.vala"
	if (_tmp2_) {
#line 795 "../libcore/File.vala"
		_tmp1_ = TRUE;
#line 3623 "File.c"
	} else {
		const gchar* _tmp4_;
#line 797 "../libcore/File.vala"
		_tmp4_ = self->owner;
#line 797 "../libcore/File.vala"
		_tmp1_ = self->uid == ((guint32) uint_parse (_tmp4_, (guint) 0));
#line 3630 "File.c"
	}
#line 795 "../libcore/File.vala"
	if (_tmp1_) {
#line 795 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 3636 "File.c"
	} else {
#line 798 "../libcore/File.vala"
		_tmp0_ = files_file_is_trashed (self);
#line 3640 "File.c"
	}
#line 795 "../libcore/File.vala"
	if (_tmp0_) {
#line 800 "../libcore/File.vala"
		result = FALSE;
#line 800 "../libcore/File.vala"
		return result;
#line 3648 "File.c"
	}
#line 803 "../libcore/File.vala"
	_tmp5_ = self->priv->_location;
#line 803 "../libcore/File.vala"
	if (g_file_is_native (_tmp5_)) {
#line 3654 "File.c"
		uid_t user_id = {0};
#line 805 "../libcore/File.vala"
		user_id = geteuid ();
#line 807 "../libcore/File.vala"
		if (user_id == ((uid_t) self->uid)) {
#line 808 "../libcore/File.vala"
			result = TRUE;
#line 808 "../libcore/File.vala"
			return result;
#line 3664 "File.c"
		}
#line 812 "../libcore/File.vala"
		if (user_id == ((uid_t) 0)) {
#line 813 "../libcore/File.vala"
			result = TRUE;
#line 813 "../libcore/File.vala"
			return result;
#line 3672 "File.c"
		}
#line 817 "../libcore/File.vala"
		result = FALSE;
#line 817 "../libcore/File.vala"
		return result;
#line 3678 "File.c"
	}
#line 822 "../libcore/File.vala"
	result = TRUE;
#line 822 "../libcore/File.vala"
	return result;
#line 3684 "File.c"
}

gboolean
files_file_can_unmount (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 825 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 826 "../libcore/File.vala"
	if (self->can_unmount) {
#line 826 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 3698 "File.c"
	} else {
		gboolean _tmp1_ = FALSE;
		GMount* _tmp2_;
#line 826 "../libcore/File.vala"
		_tmp2_ = self->mount;
#line 826 "../libcore/File.vala"
		if (_tmp2_ != NULL) {
#line 3706 "File.c"
			GMount* _tmp3_;
#line 826 "../libcore/File.vala"
			_tmp3_ = self->mount;
#line 826 "../libcore/File.vala"
			_tmp1_ = g_mount_can_unmount (_tmp3_);
#line 3712 "File.c"
		} else {
#line 826 "../libcore/File.vala"
			_tmp1_ = FALSE;
#line 3716 "File.c"
		}
#line 826 "../libcore/File.vala"
		_tmp0_ = _tmp1_;
#line 3720 "File.c"
	}
#line 826 "../libcore/File.vala"
	result = _tmp0_;
#line 826 "../libcore/File.vala"
	return result;
#line 3726 "File.c"
}

gchar*
files_file_get_permissions_as_string (FilesFile* self)
{
	gboolean is_link = FALSE;
	gboolean suid = FALSE;
	gboolean sgid = FALSE;
	gboolean sticky = FALSE;
	gchar _tmp0_ = '\0';
	gchar _tmp2_ = '\0';
	gchar _tmp3_ = '\0';
	gchar _tmp4_ = '\0';
	gchar _tmp7_ = '\0';
	gchar _tmp8_ = '\0';
	gchar _tmp9_ = '\0';
	gchar _tmp12_ = '\0';
	gchar _tmp13_ = '\0';
	gchar _tmp14_ = '\0';
	gchar* _tmp17_;
	gchar* result;
#line 829 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 830 "../libcore/File.vala"
	is_link = files_file_is_symlink (self);
#line 833 "../libcore/File.vala"
	suid = (self->permissions & S_ISUID) != ((guint32) 0);
#line 834 "../libcore/File.vala"
	sgid = (self->permissions & S_ISGID) != ((guint32) 0);
#line 835 "../libcore/File.vala"
	sticky = (self->permissions & S_ISVTX) != ((guint32) 0);
#line 838 "../libcore/File.vala"
	if (is_link) {
#line 838 "../libcore/File.vala"
		_tmp0_ = 'l';
#line 3762 "File.c"
	} else {
		gchar _tmp1_ = '\0';
#line 838 "../libcore/File.vala"
		if (self->is_directory) {
#line 838 "../libcore/File.vala"
			_tmp1_ = 'd';
#line 3769 "File.c"
		} else {
#line 838 "../libcore/File.vala"
			_tmp1_ = '-';
#line 3773 "File.c"
		}
#line 838 "../libcore/File.vala"
		_tmp0_ = _tmp1_;
#line 3777 "File.c"
	}
#line 839 "../libcore/File.vala"
	if ((self->permissions & S_IRUSR) != ((guint32) 0)) {
#line 839 "../libcore/File.vala"
		_tmp2_ = 'r';
#line 3783 "File.c"
	} else {
#line 839 "../libcore/File.vala"
		_tmp2_ = '-';
#line 3787 "File.c"
	}
#line 840 "../libcore/File.vala"
	if ((self->permissions & S_IWUSR) != ((guint32) 0)) {
#line 840 "../libcore/File.vala"
		_tmp3_ = 'w';
#line 3793 "File.c"
	} else {
#line 840 "../libcore/File.vala"
		_tmp3_ = '-';
#line 3797 "File.c"
	}
#line 841 "../libcore/File.vala"
	if ((self->permissions & S_IXUSR) != ((guint32) 0)) {
#line 3801 "File.c"
		gchar _tmp5_ = '\0';
#line 841 "../libcore/File.vala"
		if (suid) {
#line 841 "../libcore/File.vala"
			_tmp5_ = 's';
#line 3807 "File.c"
		} else {
#line 841 "../libcore/File.vala"
			_tmp5_ = 'x';
#line 3811 "File.c"
		}
#line 841 "../libcore/File.vala"
		_tmp4_ = _tmp5_;
#line 3815 "File.c"
	} else {
		gchar _tmp6_ = '\0';
#line 841 "../libcore/File.vala"
		if (suid) {
#line 841 "../libcore/File.vala"
			_tmp6_ = 'S';
#line 3822 "File.c"
		} else {
#line 841 "../libcore/File.vala"
			_tmp6_ = '-';
#line 3826 "File.c"
		}
#line 841 "../libcore/File.vala"
		_tmp4_ = _tmp6_;
#line 3830 "File.c"
	}
#line 842 "../libcore/File.vala"
	if ((self->permissions & S_IRGRP) != ((guint32) 0)) {
#line 842 "../libcore/File.vala"
		_tmp7_ = 'r';
#line 3836 "File.c"
	} else {
#line 842 "../libcore/File.vala"
		_tmp7_ = '-';
#line 3840 "File.c"
	}
#line 843 "../libcore/File.vala"
	if ((self->permissions & S_IWGRP) != ((guint32) 0)) {
#line 843 "../libcore/File.vala"
		_tmp8_ = 'w';
#line 3846 "File.c"
	} else {
#line 843 "../libcore/File.vala"
		_tmp8_ = '-';
#line 3850 "File.c"
	}
#line 844 "../libcore/File.vala"
	if ((self->permissions & S_IXGRP) != ((guint32) 0)) {
#line 3854 "File.c"
		gchar _tmp10_ = '\0';
#line 844 "../libcore/File.vala"
		if (sgid) {
#line 844 "../libcore/File.vala"
			_tmp10_ = 's';
#line 3860 "File.c"
		} else {
#line 844 "../libcore/File.vala"
			_tmp10_ = 'x';
#line 3864 "File.c"
		}
#line 844 "../libcore/File.vala"
		_tmp9_ = _tmp10_;
#line 3868 "File.c"
	} else {
		gchar _tmp11_ = '\0';
#line 844 "../libcore/File.vala"
		if (sgid) {
#line 844 "../libcore/File.vala"
			_tmp11_ = 'S';
#line 3875 "File.c"
		} else {
#line 844 "../libcore/File.vala"
			_tmp11_ = '-';
#line 3879 "File.c"
		}
#line 844 "../libcore/File.vala"
		_tmp9_ = _tmp11_;
#line 3883 "File.c"
	}
#line 845 "../libcore/File.vala"
	if ((self->permissions & S_IROTH) != ((guint32) 0)) {
#line 845 "../libcore/File.vala"
		_tmp12_ = 'r';
#line 3889 "File.c"
	} else {
#line 845 "../libcore/File.vala"
		_tmp12_ = '-';
#line 3893 "File.c"
	}
#line 846 "../libcore/File.vala"
	if ((self->permissions & S_IWOTH) != ((guint32) 0)) {
#line 846 "../libcore/File.vala"
		_tmp13_ = 'w';
#line 3899 "File.c"
	} else {
#line 846 "../libcore/File.vala"
		_tmp13_ = '-';
#line 3903 "File.c"
	}
#line 847 "../libcore/File.vala"
	if ((self->permissions & S_IXOTH) != ((guint32) 0)) {
#line 3907 "File.c"
		gchar _tmp15_ = '\0';
#line 847 "../libcore/File.vala"
		if (sticky) {
#line 847 "../libcore/File.vala"
			_tmp15_ = 't';
#line 3913 "File.c"
		} else {
#line 847 "../libcore/File.vala"
			_tmp15_ = 'x';
#line 3917 "File.c"
		}
#line 847 "../libcore/File.vala"
		_tmp14_ = _tmp15_;
#line 3921 "File.c"
	} else {
		gchar _tmp16_ = '\0';
#line 847 "../libcore/File.vala"
		if (sticky) {
#line 847 "../libcore/File.vala"
			_tmp16_ = 'T';
#line 3928 "File.c"
		} else {
#line 847 "../libcore/File.vala"
			_tmp16_ = '-';
#line 3932 "File.c"
		}
#line 847 "../libcore/File.vala"
		_tmp14_ = _tmp16_;
#line 3936 "File.c"
	}
#line 837 "../libcore/File.vala"
	_tmp17_ = g_strdup_printf ("%c%c%c%c%c%c%c%c%c%c", (gint) _tmp0_, (gint) _tmp2_, (gint) _tmp3_, (gint) _tmp4_, (gint) _tmp7_, (gint) _tmp8_, (gint) _tmp9_, (gint) _tmp12_, (gint) _tmp13_, (gint) _tmp14_);
#line 837 "../libcore/File.vala"
	result = _tmp17_;
#line 837 "../libcore/File.vala"
	return result;
#line 3944 "File.c"
}

GList*
files_file_get_settable_group_names (FilesFile* self)
{
	uid_t user_id = {0};
	GList* result;
#line 851 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 852 "../libcore/File.vala"
	if (!files_file_can_set_group (self)) {
#line 853 "../libcore/File.vala"
		result = NULL;
#line 853 "../libcore/File.vala"
		return result;
#line 3960 "File.c"
	}
#line 856 "../libcore/File.vala"
	user_id = geteuid ();
#line 857 "../libcore/File.vala"
	if (user_id == ((uid_t) 0)) {
#line 3966 "File.c"
		GList* _tmp0_;
#line 858 "../libcore/File.vala"
		_tmp0_ = pf_user_utils_get_all_group_names ();
#line 858 "../libcore/File.vala"
		result = _tmp0_;
#line 858 "../libcore/File.vala"
		return result;
#line 3974 "File.c"
	} else {
#line 859 "../libcore/File.vala"
		if (user_id == ((uid_t) self->uid)) {
#line 3978 "File.c"
			GList* _tmp1_;
#line 860 "../libcore/File.vala"
			_tmp1_ = pf_user_utils_get_group_names_for_user ();
#line 860 "../libcore/File.vala"
			result = _tmp1_;
#line 860 "../libcore/File.vala"
			return result;
#line 3986 "File.c"
		} else {
#line 862 "../libcore/File.vala"
			g_warning ("File.vala:862: unhandled case");
#line 3990 "File.c"
		}
	}
#line 865 "../libcore/File.vala"
	result = NULL;
#line 865 "../libcore/File.vala"
	return result;
#line 3997 "File.c"
}

gboolean
files_file_is_remote_uri_scheme (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 868 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 869 "../libcore/File.vala"
	if (files_file_is_root_network_folder (self)) {
#line 869 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 4011 "File.c"
	} else {
#line 869 "../libcore/File.vala"
		_tmp0_ = files_file_is_other_uri_scheme (self);
#line 4015 "File.c"
	}
#line 869 "../libcore/File.vala"
	result = _tmp0_;
#line 869 "../libcore/File.vala"
	return result;
#line 4021 "File.c"
}

gboolean
files_file_is_root_network_folder (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 872 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 873 "../libcore/File.vala"
	if (files_file_is_network_uri_scheme (self)) {
#line 873 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 4035 "File.c"
	} else {
#line 873 "../libcore/File.vala"
		_tmp0_ = files_file_is_smb_server (self);
#line 4039 "File.c"
	}
#line 873 "../libcore/File.vala"
	result = _tmp0_;
#line 873 "../libcore/File.vala"
	return result;
#line 4045 "File.c"
}

gboolean
files_file_is_network_uri_scheme (FilesFile* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 876 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 877 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 877 "../libcore/File.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_file_get_type ())) {
#line 878 "../libcore/File.vala"
		result = TRUE;
#line 878 "../libcore/File.vala"
		return result;
#line 4064 "File.c"
	}
#line 881 "../libcore/File.vala"
	_tmp1_ = self->priv->_location;
#line 881 "../libcore/File.vala"
	result = g_file_has_uri_scheme (_tmp1_, "network");
#line 881 "../libcore/File.vala"
	return result;
#line 4072 "File.c"
}

gboolean
files_file_is_smb_uri_scheme (FilesFile* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 884 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 885 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 885 "../libcore/File.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_file_get_type ())) {
#line 886 "../libcore/File.vala"
		result = TRUE;
#line 886 "../libcore/File.vala"
		return result;
#line 4091 "File.c"
	}
#line 889 "../libcore/File.vala"
	_tmp1_ = self->priv->_location;
#line 889 "../libcore/File.vala"
	result = g_file_has_uri_scheme (_tmp1_, "smb");
#line 889 "../libcore/File.vala"
	return result;
#line 4099 "File.c"
}

gboolean
files_file_is_recent_uri_scheme (FilesFile* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 892 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 893 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 893 "../libcore/File.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_file_get_type ())) {
#line 894 "../libcore/File.vala"
		result = TRUE;
#line 894 "../libcore/File.vala"
		return result;
#line 4118 "File.c"
	}
#line 897 "../libcore/File.vala"
	_tmp1_ = self->priv->_location;
#line 897 "../libcore/File.vala"
	result = g_file_has_uri_scheme (_tmp1_, "recent");
#line 897 "../libcore/File.vala"
	return result;
#line 4126 "File.c"
}

gboolean
files_file_is_other_uri_scheme (FilesFile* self)
{
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GFile* _tmp5_;
	gboolean result;
#line 900 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 901 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 901 "../libcore/File.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_file_get_type ())) {
#line 902 "../libcore/File.vala"
		result = TRUE;
#line 902 "../libcore/File.vala"
		return result;
#line 4149 "File.c"
	}
#line 905 "../libcore/File.vala"
	_tmp5_ = self->priv->_location;
#line 905 "../libcore/File.vala"
	if (g_file_has_uri_scheme (_tmp5_, "ftp")) {
#line 905 "../libcore/File.vala"
		_tmp4_ = TRUE;
#line 4157 "File.c"
	} else {
		GFile* _tmp6_;
#line 906 "../libcore/File.vala"
		_tmp6_ = self->priv->_location;
#line 906 "../libcore/File.vala"
		_tmp4_ = g_file_has_uri_scheme (_tmp6_, "sftp");
#line 4164 "File.c"
	}
#line 905 "../libcore/File.vala"
	if (_tmp4_) {
#line 905 "../libcore/File.vala"
		_tmp3_ = TRUE;
#line 4170 "File.c"
	} else {
		GFile* _tmp7_;
#line 907 "../libcore/File.vala"
		_tmp7_ = self->priv->_location;
#line 907 "../libcore/File.vala"
		_tmp3_ = g_file_has_uri_scheme (_tmp7_, "afp");
#line 4177 "File.c"
	}
#line 905 "../libcore/File.vala"
	if (_tmp3_) {
#line 905 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 4183 "File.c"
	} else {
		GFile* _tmp8_;
#line 908 "../libcore/File.vala"
		_tmp8_ = self->priv->_location;
#line 908 "../libcore/File.vala"
		_tmp2_ = g_file_has_uri_scheme (_tmp8_, "dav");
#line 4190 "File.c"
	}
#line 905 "../libcore/File.vala"
	if (_tmp2_) {
#line 905 "../libcore/File.vala"
		_tmp1_ = TRUE;
#line 4196 "File.c"
	} else {
		GFile* _tmp9_;
#line 909 "../libcore/File.vala"
		_tmp9_ = self->priv->_location;
#line 909 "../libcore/File.vala"
		_tmp1_ = g_file_has_uri_scheme (_tmp9_, "davs");
#line 4203 "File.c"
	}
#line 905 "../libcore/File.vala"
	result = _tmp1_;
#line 905 "../libcore/File.vala"
	return result;
#line 4209 "File.c"
}

gchar*
files_file_get_display_target_uri (FilesFile* self)
{
	gchar* targ_uri = NULL;
	GFileInfo* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 912 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 913 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 913 "../libcore/File.vala"
	_tmp1_ = g_file_info_get_attribute_as_string (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 913 "../libcore/File.vala"
	targ_uri = _tmp1_;
#line 914 "../libcore/File.vala"
	_tmp2_ = targ_uri;
#line 914 "../libcore/File.vala"
	if (_tmp2_ != NULL) {
#line 915 "../libcore/File.vala"
		result = targ_uri;
#line 915 "../libcore/File.vala"
		return result;
#line 4238 "File.c"
	}
#line 918 "../libcore/File.vala"
	_tmp3_ = self->priv->_uri;
#line 918 "../libcore/File.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 918 "../libcore/File.vala"
	result = _tmp4_;
#line 918 "../libcore/File.vala"
	_g_free0 (targ_uri);
#line 918 "../libcore/File.vala"
	return result;
#line 4250 "File.c"
}

GAppInfo*
files_file_get_default_handler (FilesFile* self)
{
	const gchar* content_type = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp8_;
	GError* _inner_error0_ = NULL;
	GAppInfo* result;
#line 921 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 922 "../libcore/File.vala"
	_tmp0_ = files_file_get_ftype (self);
#line 922 "../libcore/File.vala"
	content_type = _tmp0_;
#line 923 "../libcore/File.vala"
	_tmp1_ = content_type;
#line 923 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 4272 "File.c"
		const gchar* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GAppInfo* _tmp6_;
		GAppInfo* _tmp7_;
#line 924 "../libcore/File.vala"
		_tmp2_ = content_type;
#line 924 "../libcore/File.vala"
		_tmp3_ = self->priv->_location;
#line 924 "../libcore/File.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 924 "../libcore/File.vala"
		_tmp5_ = _tmp4_;
#line 924 "../libcore/File.vala"
		_tmp6_ = g_app_info_get_default_for_type (_tmp2_, _tmp5_ == NULL);
#line 924 "../libcore/File.vala"
		_tmp7_ = _tmp6_;
#line 924 "../libcore/File.vala"
		_g_free0 (_tmp5_);
#line 924 "../libcore/File.vala"
		result = _tmp7_;
#line 924 "../libcore/File.vala"
		return result;
#line 4297 "File.c"
	}
#line 927 "../libcore/File.vala"
	_tmp8_ = self->target_location;
#line 927 "../libcore/File.vala"
	if (_tmp8_ != NULL) {
#line 4303 "File.c"
		{
			GAppInfo* _tmp9_ = NULL;
			GFile* _tmp10_;
			GAppInfo* _tmp11_;
			GAppInfo* _tmp12_;
#line 929 "../libcore/File.vala"
			_tmp10_ = self->target_location;
#line 929 "../libcore/File.vala"
			_tmp11_ = g_file_query_default_handler (_tmp10_, NULL, &_inner_error0_);
#line 929 "../libcore/File.vala"
			_tmp9_ = _tmp11_;
#line 929 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4317 "File.c"
				goto __catch0_g_error;
			}
#line 929 "../libcore/File.vala"
			_tmp12_ = _tmp9_;
#line 929 "../libcore/File.vala"
			_tmp9_ = NULL;
#line 929 "../libcore/File.vala"
			result = _tmp12_;
#line 929 "../libcore/File.vala"
			_g_object_unref0 (_tmp9_);
#line 929 "../libcore/File.vala"
			return result;
#line 4330 "File.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 928 "../libcore/File.vala"
			e = _inner_error0_;
#line 928 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 931 "../libcore/File.vala"
			_tmp13_ = e;
#line 931 "../libcore/File.vala"
			_tmp14_ = _tmp13_->message;
#line 931 "../libcore/File.vala"
			g_critical ("File.vala:931: %s", _tmp14_);
#line 932 "../libcore/File.vala"
			result = NULL;
#line 932 "../libcore/File.vala"
			_g_error_free0 (e);
#line 932 "../libcore/File.vala"
			return result;
#line 4354 "File.c"
		}
		__finally0:
#line 928 "../libcore/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 928 "../libcore/File.vala"
		g_clear_error (&_inner_error0_);
#line 928 "../libcore/File.vala"
		return NULL;
#line 4363 "File.c"
	}
	{
		GAppInfo* _tmp15_ = NULL;
		GFile* _tmp16_;
		GAppInfo* _tmp17_;
		GAppInfo* _tmp18_;
#line 937 "../libcore/File.vala"
		_tmp16_ = self->priv->_location;
#line 937 "../libcore/File.vala"
		_tmp17_ = g_file_query_default_handler (_tmp16_, NULL, &_inner_error0_);
#line 937 "../libcore/File.vala"
		_tmp15_ = _tmp17_;
#line 937 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4378 "File.c"
			goto __catch1_g_error;
		}
#line 937 "../libcore/File.vala"
		_tmp18_ = _tmp15_;
#line 937 "../libcore/File.vala"
		_tmp15_ = NULL;
#line 937 "../libcore/File.vala"
		result = _tmp18_;
#line 937 "../libcore/File.vala"
		_g_object_unref0 (_tmp15_);
#line 937 "../libcore/File.vala"
		return result;
#line 4391 "File.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 936 "../libcore/File.vala"
		e = _inner_error0_;
#line 936 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 939 "../libcore/File.vala"
		_tmp19_ = e;
#line 939 "../libcore/File.vala"
		_tmp20_ = _tmp19_->message;
#line 939 "../libcore/File.vala"
		g_critical ("File.vala:939: %s", _tmp20_);
#line 940 "../libcore/File.vala"
		result = NULL;
#line 940 "../libcore/File.vala"
		_g_error_free0 (e);
#line 940 "../libcore/File.vala"
		return result;
#line 4415 "File.c"
	}
	__finally1:
#line 936 "../libcore/File.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 936 "../libcore/File.vala"
	g_clear_error (&_inner_error0_);
#line 936 "../libcore/File.vala"
	return NULL;
#line 4424 "File.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 959 "../libcore/File.vala"
	return self ? g_error_copy (self) : NULL;
#line 4432 "File.c"
}

gboolean
files_file_execute (FilesFile* self,
                    GList* files,
                    GError** error)
{
	GFile* _tmp0_;
	GAppInfo* app_info = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 944 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 945 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 945 "../libcore/File.vala"
	if (!g_file_is_native (_tmp0_)) {
#line 946 "../libcore/File.vala"
		result = FALSE;
#line 946 "../libcore/File.vala"
		return result;
#line 4454 "File.c"
	}
#line 949 "../libcore/File.vala"
	app_info = NULL;
#line 950 "../libcore/File.vala"
	if (files_file_is_desktop_file (self)) {
#line 4460 "File.c"
		{
			GKeyFile* key_file = NULL;
			GFile* _tmp1_;
			GKeyFile* _tmp2_;
			GKeyFile* _tmp3_;
			GDesktopAppInfo* _tmp4_;
			GAppInfo* _tmp5_;
#line 952 "../libcore/File.vala"
			_tmp1_ = self->priv->_location;
#line 952 "../libcore/File.vala"
			_tmp2_ = files_file_utils_key_file_from_file (_tmp1_, NULL, &_inner_error0_);
#line 952 "../libcore/File.vala"
			key_file = _tmp2_;
#line 952 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4476 "File.c"
				goto __catch0_g_error;
			}
#line 953 "../libcore/File.vala"
			_tmp3_ = key_file;
#line 953 "../libcore/File.vala"
			_tmp4_ = g_desktop_app_info_new_from_keyfile (_tmp3_);
#line 953 "../libcore/File.vala"
			_g_object_unref0 (app_info);
#line 953 "../libcore/File.vala"
			app_info = (GAppInfo*) _tmp4_;
#line 954 "../libcore/File.vala"
			_tmp5_ = app_info;
#line 954 "../libcore/File.vala"
			if (_tmp5_ == NULL) {
#line 4491 "File.c"
				GError* _tmp6_;
#line 955 "../libcore/File.vala"
				_tmp6_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_INVAL, _ ("Failed to parse the desktop file"));
#line 955 "../libcore/File.vala"
				_inner_error0_ = _tmp6_;
#line 955 "../libcore/File.vala"
				_g_key_file_unref0 (key_file);
#line 4499 "File.c"
				goto __catch0_g_error;
			}
#line 951 "../libcore/File.vala"
			_g_key_file_unref0 (key_file);
#line 4504 "File.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* prefixed_error = NULL;
			GError* _tmp7_;
			GError* _tmp8_;
			GError* _tmp9_ = NULL;
			GError* _tmp10_;
			GError* _tmp11_;
#line 951 "../libcore/File.vala"
			e = _inner_error0_;
#line 951 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 959 "../libcore/File.vala"
			_tmp7_ = e;
#line 959 "../libcore/File.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 959 "../libcore/File.vala"
			g_propagate_prefixed_error (&_tmp9_, _tmp8_, _ ("Failed to parse the desktop file: "), NULL);
#line 959 "../libcore/File.vala"
			_g_error_free0 (prefixed_error);
#line 959 "../libcore/File.vala"
			prefixed_error = _tmp9_;
#line 960 "../libcore/File.vala"
			_tmp10_ = prefixed_error;
#line 960 "../libcore/File.vala"
			_tmp11_ = _g_error_copy0 (_tmp10_);
#line 960 "../libcore/File.vala"
			_inner_error0_ = _tmp11_;
#line 960 "../libcore/File.vala"
			_g_error_free0 (prefixed_error);
#line 960 "../libcore/File.vala"
			_g_error_free0 (e);
#line 4540 "File.c"
			goto __finally0;
		}
		__finally0:
#line 951 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4546 "File.c"
			gboolean _tmp12_ = FALSE;
#line 951 "../libcore/File.vala"
			g_propagate_error (error, _inner_error0_);
#line 951 "../libcore/File.vala"
			_g_object_unref0 (app_info);
#line 951 "../libcore/File.vala"
			return _tmp12_;
#line 4554 "File.c"
		}
	} else {
		{
			gchar* path = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			GAppInfo* _tmp15_ = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GAppInfo* _tmp19_;
			GAppInfo* _tmp20_;
			GAppInfo* _tmp21_;
#line 964 "../libcore/File.vala"
			_tmp13_ = self->priv->_location;
#line 964 "../libcore/File.vala"
			_tmp14_ = g_file_get_path (_tmp13_);
#line 964 "../libcore/File.vala"
			path = _tmp14_;
#line 965 "../libcore/File.vala"
			_tmp16_ = path;
#line 965 "../libcore/File.vala"
			_tmp17_ = g_shell_quote (_tmp16_);
#line 965 "../libcore/File.vala"
			_tmp18_ = _tmp17_;
#line 965 "../libcore/File.vala"
			_tmp19_ = g_app_info_create_from_commandline (_tmp18_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 965 "../libcore/File.vala"
			_tmp20_ = _tmp19_;
#line 965 "../libcore/File.vala"
			_g_free0 (_tmp18_);
#line 965 "../libcore/File.vala"
			_tmp15_ = _tmp20_;
#line 965 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 965 "../libcore/File.vala"
				_g_free0 (path);
#line 4592 "File.c"
				goto __catch1_g_error;
			}
#line 965 "../libcore/File.vala"
			_tmp21_ = _tmp15_;
#line 965 "../libcore/File.vala"
			_tmp15_ = NULL;
#line 965 "../libcore/File.vala"
			_g_object_unref0 (app_info);
#line 965 "../libcore/File.vala"
			app_info = _tmp21_;
#line 963 "../libcore/File.vala"
			_g_object_unref0 (_tmp15_);
#line 963 "../libcore/File.vala"
			_g_free0 (path);
#line 4607 "File.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* prefixed_error = NULL;
			GError* _tmp22_;
			GError* _tmp23_;
			GError* _tmp24_ = NULL;
			GError* _tmp25_;
			GError* _tmp26_;
#line 963 "../libcore/File.vala"
			e = _inner_error0_;
#line 963 "../libcore/File.vala"
			_inner_error0_ = NULL;
#line 971 "../libcore/File.vala"
			_tmp22_ = e;
#line 971 "../libcore/File.vala"
			_tmp23_ = _g_error_copy0 (_tmp22_);
#line 971 "../libcore/File.vala"
			g_propagate_prefixed_error (&_tmp24_, _tmp23_, _ ("Failed to create command from file: "), NULL);
#line 971 "../libcore/File.vala"
			_g_error_free0 (prefixed_error);
#line 971 "../libcore/File.vala"
			prefixed_error = _tmp24_;
#line 972 "../libcore/File.vala"
			_tmp25_ = prefixed_error;
#line 972 "../libcore/File.vala"
			_tmp26_ = _g_error_copy0 (_tmp25_);
#line 972 "../libcore/File.vala"
			_inner_error0_ = _tmp26_;
#line 972 "../libcore/File.vala"
			_g_error_free0 (prefixed_error);
#line 972 "../libcore/File.vala"
			_g_error_free0 (e);
#line 4643 "File.c"
			goto __finally1;
		}
		__finally1:
#line 963 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4649 "File.c"
			gboolean _tmp27_ = FALSE;
#line 963 "../libcore/File.vala"
			g_propagate_error (error, _inner_error0_);
#line 963 "../libcore/File.vala"
			_g_object_unref0 (app_info);
#line 963 "../libcore/File.vala"
			return _tmp27_;
#line 4657 "File.c"
		}
	}
	{
		GAppInfo* _tmp28_;
#line 977 "../libcore/File.vala"
		_tmp28_ = app_info;
#line 977 "../libcore/File.vala"
		g_app_info_launch (_tmp28_, files, NULL, &_inner_error0_);
#line 977 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4668 "File.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* prefixed_error = NULL;
		GError* _tmp29_;
		GError* _tmp30_;
		GError* _tmp31_ = NULL;
		GError* _tmp32_;
		GError* _tmp33_;
#line 976 "../libcore/File.vala"
		e = _inner_error0_;
#line 976 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 980 "../libcore/File.vala"
		_tmp29_ = e;
#line 980 "../libcore/File.vala"
		_tmp30_ = _g_error_copy0 (_tmp29_);
#line 980 "../libcore/File.vala"
		g_propagate_prefixed_error (&_tmp31_, _tmp30_, _ ("Unable to Launch Desktop File: "), NULL);
#line 980 "../libcore/File.vala"
		_g_error_free0 (prefixed_error);
#line 980 "../libcore/File.vala"
		prefixed_error = _tmp31_;
#line 981 "../libcore/File.vala"
		_tmp32_ = prefixed_error;
#line 981 "../libcore/File.vala"
		_tmp33_ = _g_error_copy0 (_tmp32_);
#line 981 "../libcore/File.vala"
		_inner_error0_ = _tmp33_;
#line 981 "../libcore/File.vala"
		_g_error_free0 (prefixed_error);
#line 981 "../libcore/File.vala"
		_g_error_free0 (e);
#line 4706 "File.c"
		goto __finally2;
	}
	__finally2:
#line 976 "../libcore/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4712 "File.c"
		gboolean _tmp34_ = FALSE;
#line 976 "../libcore/File.vala"
		g_propagate_error (error, _inner_error0_);
#line 976 "../libcore/File.vala"
		_g_object_unref0 (app_info);
#line 976 "../libcore/File.vala"
		return _tmp34_;
#line 4720 "File.c"
	}
#line 984 "../libcore/File.vala"
	result = TRUE;
#line 984 "../libcore/File.vala"
	_g_object_unref0 (app_info);
#line 984 "../libcore/File.vala"
	return result;
#line 4728 "File.c"
}

gint
files_file_compare_for_sort (FilesFile* self,
                             FilesFile* other,
                             gint sort_type,
                             gboolean directories_first,
                             gboolean reversed)
{
	gint _result_ = 0;
	gint result;
#line 987 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 987 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 988 "../libcore/File.vala"
	if (other == self) {
#line 989 "../libcore/File.vala"
		result = 0;
#line 989 "../libcore/File.vala"
		return result;
#line 4750 "File.c"
	}
#line 992 "../libcore/File.vala"
	if (directories_first) {
#line 4754 "File.c"
		gboolean _tmp0_ = FALSE;
#line 995 "../libcore/File.vala"
		if (files_file_is_folder (self)) {
#line 995 "../libcore/File.vala"
			_tmp0_ = !files_file_is_folder (other);
#line 4760 "File.c"
		} else {
#line 995 "../libcore/File.vala"
			_tmp0_ = FALSE;
#line 4764 "File.c"
		}
#line 995 "../libcore/File.vala"
		if (_tmp0_) {
#line 4768 "File.c"
			gint _tmp1_ = 0;
#line 996 "../libcore/File.vala"
			if (reversed) {
#line 996 "../libcore/File.vala"
				_tmp1_ = 1;
#line 4774 "File.c"
			} else {
#line 996 "../libcore/File.vala"
				_tmp1_ = -1;
#line 4778 "File.c"
			}
#line 996 "../libcore/File.vala"
			result = _tmp1_;
#line 996 "../libcore/File.vala"
			return result;
#line 4784 "File.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 997 "../libcore/File.vala"
			if (files_file_is_folder (other)) {
#line 997 "../libcore/File.vala"
				_tmp2_ = !files_file_is_folder (self);
#line 4791 "File.c"
			} else {
#line 997 "../libcore/File.vala"
				_tmp2_ = FALSE;
#line 4795 "File.c"
			}
#line 997 "../libcore/File.vala"
			if (_tmp2_) {
#line 4799 "File.c"
				gint _tmp3_ = 0;
#line 998 "../libcore/File.vala"
				if (reversed) {
#line 998 "../libcore/File.vala"
					_tmp3_ = -1;
#line 4805 "File.c"
				} else {
#line 998 "../libcore/File.vala"
					_tmp3_ = 1;
#line 4809 "File.c"
				}
#line 998 "../libcore/File.vala"
				result = _tmp3_;
#line 998 "../libcore/File.vala"
				return result;
#line 4815 "File.c"
			}
		}
	}
#line 1003 "../libcore/File.vala"
	_result_ = 0;
#line 1004 "../libcore/File.vala"
	switch (sort_type) {
#line 1004 "../libcore/File.vala"
		case FILES_LIST_MODEL_COLUMN_ID_FILENAME:
#line 4825 "File.c"
		{
#line 1006 "../libcore/File.vala"
			_result_ = files_file_compare_by_display_name (self, other);
#line 1007 "../libcore/File.vala"
			break;
#line 4831 "File.c"
		}
#line 1004 "../libcore/File.vala"
		case FILES_LIST_MODEL_COLUMN_ID_SIZE:
#line 4835 "File.c"
		{
#line 1009 "../libcore/File.vala"
			_result_ = files_file_compare_by_size (self, other);
#line 1010 "../libcore/File.vala"
			if (_result_ == 0) {
#line 1011 "../libcore/File.vala"
				_result_ = files_file_compare_by_display_name (self, other);
#line 4843 "File.c"
			}
#line 1014 "../libcore/File.vala"
			break;
#line 4847 "File.c"
		}
#line 1004 "../libcore/File.vala"
		case FILES_LIST_MODEL_COLUMN_ID_TYPE:
#line 4851 "File.c"
		{
#line 1016 "../libcore/File.vala"
			_result_ = files_file_compare_by_type (self, other);
#line 1017 "../libcore/File.vala"
			if (_result_ == 0) {
#line 1018 "../libcore/File.vala"
				_result_ = files_file_compare_by_display_name (self, other);
#line 4859 "File.c"
			}
#line 1021 "../libcore/File.vala"
			break;
#line 4863 "File.c"
		}
#line 1004 "../libcore/File.vala"
		case FILES_LIST_MODEL_COLUMN_ID_MODIFIED:
#line 4867 "File.c"
		{
#line 1023 "../libcore/File.vala"
			_result_ = files_file_compare_files_by_time (self, other);
#line 1024 "../libcore/File.vala"
			if (_result_ == 0) {
#line 1025 "../libcore/File.vala"
				_result_ = files_file_compare_by_display_name (self, other);
#line 4875 "File.c"
			}
#line 1028 "../libcore/File.vala"
			break;
#line 4879 "File.c"
		}
		default:
		{
#line 1030 "../libcore/File.vala"
			g_assert_not_reached ();
#line 4885 "File.c"
		}
	}
#line 1033 "../libcore/File.vala"
	result = _result_;
#line 1033 "../libcore/File.vala"
	return result;
#line 4892 "File.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 4909 "File.c"
}

gint
files_file_compare_by_display_name (FilesFile* self,
                                    FilesFile* other)
{
#line 1038 "../libcore/File.vala"
	static const gchar SORT_LAST_CHAR1 = '.';
#line 1039 "../libcore/File.vala"
	static const gchar SORT_LAST_CHAR2 = '#';
#line 4920 "File.c"
	const gchar* name1 = NULL;
	const gchar* _tmp0_;
	const gchar* name2 = NULL;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean sort_last1 = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean sort_last2 = FALSE;
	gboolean _tmp8_ = FALSE;
	gint result;
#line 1036 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1036 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1041 "../libcore/File.vala"
	_tmp0_ = files_file_get_display_name (self);
#line 1041 "../libcore/File.vala"
	name1 = _tmp0_;
#line 1042 "../libcore/File.vala"
	_tmp1_ = files_file_get_display_name (other);
#line 1042 "../libcore/File.vala"
	name2 = _tmp1_;
#line 1044 "../libcore/File.vala"
	_tmp3_ = name1;
#line 1044 "../libcore/File.vala"
	if (string_get (_tmp3_, (glong) 0) == SORT_LAST_CHAR1) {
#line 1044 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 4951 "File.c"
	} else {
		const gchar* _tmp4_;
#line 1044 "../libcore/File.vala"
		_tmp4_ = name1;
#line 1044 "../libcore/File.vala"
		_tmp2_ = string_get (_tmp4_, (glong) 0) == SORT_LAST_CHAR2;
#line 4958 "File.c"
	}
#line 1044 "../libcore/File.vala"
	sort_last1 = _tmp2_;
#line 1045 "../libcore/File.vala"
	_tmp6_ = name2;
#line 1045 "../libcore/File.vala"
	if (string_get (_tmp6_, (glong) 0) == SORT_LAST_CHAR1) {
#line 1045 "../libcore/File.vala"
		_tmp5_ = TRUE;
#line 4968 "File.c"
	} else {
		const gchar* _tmp7_;
#line 1045 "../libcore/File.vala"
		_tmp7_ = name2;
#line 1045 "../libcore/File.vala"
		_tmp5_ = string_get (_tmp7_, (glong) 0) == SORT_LAST_CHAR2;
#line 4975 "File.c"
	}
#line 1045 "../libcore/File.vala"
	sort_last2 = _tmp5_;
#line 1048 "../libcore/File.vala"
	if (sort_last1) {
#line 1048 "../libcore/File.vala"
		_tmp8_ = !sort_last2;
#line 4983 "File.c"
	} else {
#line 1048 "../libcore/File.vala"
		_tmp8_ = FALSE;
#line 4987 "File.c"
	}
#line 1048 "../libcore/File.vala"
	if (_tmp8_) {
#line 1049 "../libcore/File.vala"
		result = 1;
#line 1049 "../libcore/File.vala"
		return result;
#line 4995 "File.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 1050 "../libcore/File.vala"
		if (!sort_last1) {
#line 1050 "../libcore/File.vala"
			_tmp9_ = sort_last2;
#line 5002 "File.c"
		} else {
#line 1050 "../libcore/File.vala"
			_tmp9_ = FALSE;
#line 5006 "File.c"
		}
#line 1050 "../libcore/File.vala"
		if (_tmp9_) {
#line 1051 "../libcore/File.vala"
			result = -1;
#line 1051 "../libcore/File.vala"
			return result;
#line 5014 "File.c"
		} else {
			GCompareFunc _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 1053 "../libcore/File.vala"
			_tmp10_ = ((GCompareFunc) g_strcmp0);
#line 1053 "../libcore/File.vala"
			_tmp11_ = self->utf8_collation_key;
#line 1053 "../libcore/File.vala"
			_tmp12_ = other->utf8_collation_key;
#line 1053 "../libcore/File.vala"
			result = _tmp10_ (_tmp11_, _tmp12_);
#line 1053 "../libcore/File.vala"
			return result;
#line 5029 "File.c"
		}
	}
}

void
files_file_update_emblem (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 1057 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1060 "../libcore/File.vala"
	if (files_file_is_other_uri_scheme (self)) {
#line 1060 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 5047 "File.c"
	} else {
#line 1060 "../libcore/File.vala"
		_tmp0_ = files_file_is_network_uri_scheme (self);
#line 5051 "File.c"
	}
#line 1060 "../libcore/File.vala"
	if (_tmp0_) {
#line 1061 "../libcore/File.vala"
		return;
#line 5057 "File.c"
	}
#line 1065 "../libcore/File.vala"
	if (files_file_is_smb_share (self)) {
#line 1066 "../libcore/File.vala"
		return;
#line 5063 "File.c"
	}
#line 1070 "../libcore/File.vala"
	_tmp1_ = self->emblems_list;
#line 1070 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 1071 "../libcore/File.vala"
		(self->emblems_list == NULL) ? NULL : (self->emblems_list = (_g_list_free__g_free0_ (self->emblems_list), NULL));
#line 1071 "../libcore/File.vala"
		self->emblems_list = NULL;
#line 1072 "../libcore/File.vala"
		self->n_emblems = (guint) 0;
#line 5075 "File.c"
	}
#line 1075 "../libcore/File.vala"
	if (files_file_is_symlink (self)) {
#line 1075 "../libcore/File.vala"
		_tmp2_ = TRUE;
#line 5081 "File.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 1075 "../libcore/File.vala"
		if (self->is_desktop) {
#line 5086 "File.c"
			FilesFile* _tmp4_;
#line 1075 "../libcore/File.vala"
			_tmp4_ = self->target_gof;
#line 1075 "../libcore/File.vala"
			_tmp3_ = _tmp4_ != NULL;
#line 5092 "File.c"
		} else {
#line 1075 "../libcore/File.vala"
			_tmp3_ = FALSE;
#line 5096 "File.c"
		}
#line 1075 "../libcore/File.vala"
		_tmp2_ = _tmp3_;
#line 5100 "File.c"
	}
#line 1075 "../libcore/File.vala"
	if (_tmp2_) {
#line 1076 "../libcore/File.vala"
		files_file_add_emblem (self, "emblem-symbolic-link");
#line 5106 "File.c"
	}
#line 1081 "../libcore/File.vala"
	if (!files_file_is_writable (self)) {
#line 1081 "../libcore/File.vala"
		_tmp5_ = !files_file_is_recent_uri_scheme (self);
#line 5112 "File.c"
	} else {
#line 1081 "../libcore/File.vala"
		_tmp5_ = FALSE;
#line 5116 "File.c"
	}
#line 1081 "../libcore/File.vala"
	if (_tmp5_) {
#line 1082 "../libcore/File.vala"
		if (files_file_is_readable (self)) {
#line 1083 "../libcore/File.vala"
			files_file_add_emblem (self, "emblem-readonly");
#line 5124 "File.c"
		} else {
#line 1085 "../libcore/File.vala"
			files_file_add_emblem (self, "emblem-unreadable");
#line 5128 "File.c"
		}
	}
}

void
files_file_add_emblem (FilesFile* self,
                       const gchar* emblem)
{
	GList* _tmp0_;
	gchar* _tmp3_;
	guint _tmp4_;
#line 1090 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1090 "../libcore/File.vala"
	g_return_if_fail (emblem != NULL);
#line 1091 "../libcore/File.vala"
	_tmp0_ = self->emblems_list;
#line 1091 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 5148 "File.c"
		GList* _tmp1_;
#line 1092 "../libcore/File.vala"
		_tmp1_ = self->emblems_list;
#line 5152 "File.c"
		{
			GList* emblem_item_collection = NULL;
			GList* emblem_item_it = NULL;
#line 1092 "../libcore/File.vala"
			emblem_item_collection = _tmp1_;
#line 1092 "../libcore/File.vala"
			for (emblem_item_it = emblem_item_collection; emblem_item_it != NULL; emblem_item_it = emblem_item_it->next) {
#line 5160 "File.c"
				const gchar* emblem_item = NULL;
#line 1092 "../libcore/File.vala"
				emblem_item = (const gchar*) emblem_item_it->data;
#line 5164 "File.c"
				{
					const gchar* _tmp2_;
#line 1093 "../libcore/File.vala"
					_tmp2_ = emblem_item;
#line 1093 "../libcore/File.vala"
					if (g_strcmp0 (_tmp2_, emblem) == 0) {
#line 1094 "../libcore/File.vala"
						return;
#line 5173 "File.c"
					}
				}
			}
		}
	} else {
#line 1098 "../libcore/File.vala"
		(self->emblems_list == NULL) ? NULL : (self->emblems_list = (_g_list_free__g_free0_ (self->emblems_list), NULL));
#line 1098 "../libcore/File.vala"
		self->emblems_list = NULL;
#line 5183 "File.c"
	}
#line 1101 "../libcore/File.vala"
	_tmp3_ = g_strdup (emblem);
#line 1101 "../libcore/File.vala"
	self->emblems_list = g_list_append (self->emblems_list, _tmp3_);
#line 1102 "../libcore/File.vala"
	_tmp4_ = self->n_emblems;
#line 1102 "../libcore/File.vala"
	self->n_emblems = _tmp4_ + 1;
#line 1103 "../libcore/File.vala"
	g_signal_emit (self, files_file_signals[FILES_FILE_ICON_CHANGED_SIGNAL], 0);
#line 5195 "File.c"
}

static void
files_file_target_location_update (FilesFile* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
#line 1106 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1107 "../libcore/File.vala"
	_tmp0_ = self->target_location;
#line 1107 "../libcore/File.vala"
	if (_tmp0_ == NULL) {
#line 1108 "../libcore/File.vala"
		return;
#line 5213 "File.c"
	}
#line 1111 "../libcore/File.vala"
	_tmp1_ = self->target_location;
#line 1111 "../libcore/File.vala"
	_tmp2_ = files_file_get (_tmp1_);
#line 1111 "../libcore/File.vala"
	_g_object_unref0 (self->target_gof);
#line 1111 "../libcore/File.vala"
	self->target_gof = _tmp2_;
#line 1112 "../libcore/File.vala"
	_tmp3_ = self->target_gof;
#line 1112 "../libcore/File.vala"
	files_file_query_update (_tmp3_);
#line 5227 "File.c"
}

static void
files_file_clear_info (FilesFile* self)
{
#line 1115 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1116 "../libcore/File.vala"
	_g_object_unref0 (self->target_location);
#line 1116 "../libcore/File.vala"
	self->target_location = NULL;
#line 1117 "../libcore/File.vala"
	_g_object_unref0 (self->mount);
#line 1117 "../libcore/File.vala"
	self->mount = NULL;
#line 1118 "../libcore/File.vala"
	_g_free0 (self->utf8_collation_key);
#line 1118 "../libcore/File.vala"
	self->utf8_collation_key = NULL;
#line 1119 "../libcore/File.vala"
	_g_free0 (self->formated_type);
#line 1119 "../libcore/File.vala"
	self->formated_type = NULL;
#line 1120 "../libcore/File.vala"
	_g_free0 (self->format_size);
#line 1120 "../libcore/File.vala"
	self->format_size = NULL;
#line 1121 "../libcore/File.vala"
	_g_free0 (self->formated_modified);
#line 1121 "../libcore/File.vala"
	self->formated_modified = NULL;
#line 1122 "../libcore/File.vala"
	_g_object_unref0 (self->icon);
#line 1122 "../libcore/File.vala"
	self->icon = NULL;
#line 1123 "../libcore/File.vala"
	_g_free0 (self->custom_display_name);
#line 1123 "../libcore/File.vala"
	self->custom_display_name = NULL;
#line 1124 "../libcore/File.vala"
	_g_free0 (self->custom_icon_name);
#line 1124 "../libcore/File.vala"
	self->custom_icon_name = NULL;
#line 1126 "../libcore/File.vala"
	self->uid = (guint32) -1;
#line 1127 "../libcore/File.vala"
	self->gid = (guint32) -1;
#line 1128 "../libcore/File.vala"
	self->has_permissions = FALSE;
#line 1129 "../libcore/File.vala"
	self->permissions = (guint32) 0;
#line 1130 "../libcore/File.vala"
	_g_free0 (self->owner);
#line 1130 "../libcore/File.vala"
	self->owner = NULL;
#line 1131 "../libcore/File.vala"
	_g_free0 (self->group);
#line 1131 "../libcore/File.vala"
	self->group = NULL;
#line 1132 "../libcore/File.vala"
	self->can_unmount = FALSE;
#line 5289 "File.c"
}

static GFileInfo*
files_file_query_info (FilesFile* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	GFileInfo* result;
#line 1135 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1136 "../libcore/File.vala"
	_tmp1_ = self->priv->_location;
#line 1136 "../libcore/File.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_file_get_type ())) {
#line 1136 "../libcore/File.vala"
		_tmp0_ = TRUE;
#line 5307 "File.c"
	} else {
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1136 "../libcore/File.vala"
		_tmp2_ = self->priv->_location;
#line 1136 "../libcore/File.vala"
		_tmp3_ = g_file_get_uri (_tmp2_);
#line 1136 "../libcore/File.vala"
		_tmp4_ = _tmp3_;
#line 1136 "../libcore/File.vala"
		_tmp0_ = g_str_has_prefix (_tmp4_, FILES_NETWORK_URI);
#line 1136 "../libcore/File.vala"
		_g_free0 (_tmp4_);
#line 5322 "File.c"
	}
#line 1136 "../libcore/File.vala"
	if (_tmp0_) {
#line 1137 "../libcore/File.vala"
		result = NULL;
#line 1137 "../libcore/File.vala"
		return result;
#line 5330 "File.c"
	}
#line 1140 "../libcore/File.vala"
	self->is_mounted = TRUE;
#line 1141 "../libcore/File.vala"
	self->is_connected = TRUE;
#line 5336 "File.c"
	{
		GFileInfo* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
#line 1143 "../libcore/File.vala"
		_tmp6_ = self->priv->_location;
#line 1143 "../libcore/File.vala"
		_tmp7_ = g_file_query_info (_tmp6_, "*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 1143 "../libcore/File.vala"
		_tmp5_ = _tmp7_;
#line 1143 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1143 "../libcore/File.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_MOUNTED)) {
#line 5352 "File.c"
				goto __catch0_g_io_error_not_mounted;
			}
#line 1143 "../libcore/File.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 5357 "File.c"
				goto __catch0_g_io_error_not_found;
			}
#line 1143 "../libcore/File.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY)) {
#line 5362 "File.c"
				goto __catch0_g_io_error_not_directory;
			}
#line 1143 "../libcore/File.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_TIMED_OUT)) {
#line 5367 "File.c"
				goto __catch0_g_io_error_timed_out;
			}
			goto __catch0_g_error;
		}
#line 1143 "../libcore/File.vala"
		_tmp8_ = _tmp5_;
#line 1143 "../libcore/File.vala"
		_tmp5_ = NULL;
#line 1143 "../libcore/File.vala"
		result = _tmp8_;
#line 1143 "../libcore/File.vala"
		_g_object_unref0 (_tmp5_);
#line 1143 "../libcore/File.vala"
		return result;
#line 5382 "File.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_mounted:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 1142 "../libcore/File.vala"
		e = _inner_error0_;
#line 1142 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 1145 "../libcore/File.vala"
		self->is_mounted = FALSE;
#line 1146 "../libcore/File.vala"
		_tmp9_ = e;
#line 1146 "../libcore/File.vala"
		_tmp10_ = _tmp9_->message;
#line 1146 "../libcore/File.vala"
		g_debug ("File.vala:1146: %s", _tmp10_);
#line 1142 "../libcore/File.vala"
		_g_error_free0 (e);
#line 5404 "File.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_found:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 1142 "../libcore/File.vala"
		e = _inner_error0_;
#line 1142 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 1148 "../libcore/File.vala"
		files_file_set_exists (self, FALSE);
#line 1149 "../libcore/File.vala"
		_tmp11_ = e;
#line 1149 "../libcore/File.vala"
		_tmp12_ = _tmp11_->message;
#line 1149 "../libcore/File.vala"
		g_debug ("File.vala:1149: %s", _tmp12_);
#line 1142 "../libcore/File.vala"
		_g_error_free0 (e);
#line 5426 "File.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_directory:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 1142 "../libcore/File.vala"
		e = _inner_error0_;
#line 1142 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 1151 "../libcore/File.vala"
		files_file_set_exists (self, FALSE);
#line 1152 "../libcore/File.vala"
		_tmp13_ = e;
#line 1152 "../libcore/File.vala"
		_tmp14_ = _tmp13_->message;
#line 1152 "../libcore/File.vala"
		g_debug ("File.vala:1152: %s", _tmp14_);
#line 1142 "../libcore/File.vala"
		_g_error_free0 (e);
#line 5448 "File.c"
	}
	goto __finally0;
	__catch0_g_io_error_timed_out:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 1142 "../libcore/File.vala"
		e = _inner_error0_;
#line 1142 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 1154 "../libcore/File.vala"
		self->is_connected = FALSE;
#line 1155 "../libcore/File.vala"
		_tmp15_ = e;
#line 1155 "../libcore/File.vala"
		_tmp16_ = _tmp15_->message;
#line 1155 "../libcore/File.vala"
		g_debug ("File.vala:1155: %s", _tmp16_);
#line 1142 "../libcore/File.vala"
		_g_error_free0 (e);
#line 5470 "File.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 1142 "../libcore/File.vala"
		e = _inner_error0_;
#line 1142 "../libcore/File.vala"
		_inner_error0_ = NULL;
#line 1157 "../libcore/File.vala"
		_tmp17_ = e;
#line 1157 "../libcore/File.vala"
		_tmp18_ = _tmp17_->message;
#line 1157 "../libcore/File.vala"
		g_debug ("File.vala:1157: %s", _tmp18_);
#line 1142 "../libcore/File.vala"
		_g_error_free0 (e);
#line 5490 "File.c"
	}
	__finally0:
#line 1142 "../libcore/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1142 "../libcore/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1142 "../libcore/File.vala"
		g_clear_error (&_inner_error0_);
#line 1142 "../libcore/File.vala"
		return NULL;
#line 5501 "File.c"
	}
#line 1160 "../libcore/File.vala"
	result = NULL;
#line 1160 "../libcore/File.vala"
	return result;
#line 5507 "File.c"
}

void
files_file_ensure_size (FilesFile* self)
{
#line 1163 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1164 "../libcore/File.vala"
	files_file_ensure_item_count (self, TRUE);
#line 1165 "../libcore/File.vala"
	if (self->count >= 0) {
#line 1166 "../libcore/File.vala"
		if (self->count < 0) {
#line 5521 "File.c"
			gchar* _tmp0_;
#line 1167 "../libcore/File.vala"
			_tmp0_ = g_strdup ("—");
#line 1167 "../libcore/File.vala"
			_g_free0 (self->format_size);
#line 1167 "../libcore/File.vala"
			self->format_size = _tmp0_;
#line 5529 "File.c"
		} else {
#line 1168 "../libcore/File.vala"
			if (self->count == 0) {
#line 5533 "File.c"
				gchar* _tmp1_;
#line 1169 "../libcore/File.vala"
				_tmp1_ = g_strdup (_ ("Empty"));
#line 1169 "../libcore/File.vala"
				_g_free0 (self->format_size);
#line 1169 "../libcore/File.vala"
				self->format_size = _tmp1_;
#line 5541 "File.c"
			} else {
				gchar* _tmp2_;
#line 1171 "../libcore/File.vala"
				_tmp2_ = g_strdup_printf (ngettext ("%'d item", "%'d items", (gulong) self->count), self->count);
#line 1171 "../libcore/File.vala"
				_g_free0 (self->format_size);
#line 1171 "../libcore/File.vala"
				self->format_size = _tmp2_;
#line 5550 "File.c"
			}
		}
	} else {
		GFileInfo* _tmp3_;
#line 1173 "../libcore/File.vala"
		_tmp3_ = self->info;
#line 1173 "../libcore/File.vala"
		if (g_file_info_has_attribute (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_SIZE)) {
#line 5559 "File.c"
			gchar* _tmp4_;
#line 1174 "../libcore/File.vala"
			_tmp4_ = g_format_size_full (self->size, G_FORMAT_SIZE_DEFAULT);
#line 1174 "../libcore/File.vala"
			_g_free0 (self->format_size);
#line 1174 "../libcore/File.vala"
			self->format_size = _tmp4_;
#line 5567 "File.c"
		} else {
			gchar* _tmp5_;
#line 1176 "../libcore/File.vala"
			_tmp5_ = g_strdup (_ ("Inaccessible"));
#line 1176 "../libcore/File.vala"
			_g_free0 (self->format_size);
#line 1176 "../libcore/File.vala"
			self->format_size = _tmp5_;
#line 5576 "File.c"
		}
	}
}

static void
files_file_ensure_item_count (FilesFile* self,
                              gboolean recount)
{
	gboolean _tmp0_ = FALSE;
	gboolean pref_show_hidden = FALSE;
	FilesPreferences* _tmp1_;
	FilesPreferences* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_ = FALSE;
	GFile* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1180 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1181 "../libcore/File.vala"
	if (self->count >= 0) {
#line 1181 "../libcore/File.vala"
		_tmp0_ = !recount;
#line 5601 "File.c"
	} else {
#line 1181 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 5605 "File.c"
	}
#line 1181 "../libcore/File.vala"
	if (_tmp0_) {
#line 1182 "../libcore/File.vala"
		return;
#line 5611 "File.c"
	}
#line 1185 "../libcore/File.vala"
	_tmp1_ = files_preferences_get_default ();
#line 1185 "../libcore/File.vala"
	_tmp2_ = _tmp1_;
#line 1185 "../libcore/File.vala"
	_tmp3_ = files_preferences_get_show_hidden_files (_tmp2_);
#line 1185 "../libcore/File.vala"
	_tmp4_ = _tmp3_;
#line 1185 "../libcore/File.vala"
	_tmp5_ = _tmp4_;
#line 1185 "../libcore/File.vala"
	_g_object_unref0 (_tmp2_);
#line 1185 "../libcore/File.vala"
	pref_show_hidden = _tmp5_;
#line 1186 "../libcore/File.vala"
	_tmp7_ = self->priv->_location;
#line 1186 "../libcore/File.vala"
	if (g_file_has_uri_scheme (_tmp7_, "file")) {
#line 1186 "../libcore/File.vala"
		_tmp6_ = TRUE;
#line 5633 "File.c"
	} else {
		gboolean _tmp8_ = FALSE;
#line 1187 "../libcore/File.vala"
		if (self->is_mounted) {
#line 5638 "File.c"
			GFile* _tmp9_;
#line 1187 "../libcore/File.vala"
			_tmp9_ = self->priv->_location;
#line 1187 "../libcore/File.vala"
			_tmp8_ = g_file_is_native (_tmp9_);
#line 5644 "File.c"
		} else {
#line 1187 "../libcore/File.vala"
			_tmp8_ = FALSE;
#line 5648 "File.c"
		}
#line 1187 "../libcore/File.vala"
		_tmp6_ = _tmp8_;
#line 5652 "File.c"
	}
#line 1186 "../libcore/File.vala"
	if (_tmp6_) {
#line 5656 "File.c"
		{
			GFileEnumerator* f_enum = NULL;
			GFile* _tmp10_;
			GFileEnumerator* _tmp11_;
			GFileInfo* info = NULL;
#line 1190 "../libcore/File.vala"
			_tmp10_ = self->priv->_location;
#line 1190 "../libcore/File.vala"
			_tmp11_ = g_file_enumerate_children (_tmp10_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1190 "../libcore/File.vala"
			f_enum = _tmp11_;
#line 1190 "../libcore/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5670 "File.c"
				goto __catch0_g_error;
			}
#line 1195 "../libcore/File.vala"
			self->count = 0;
#line 1198 "../libcore/File.vala"
			while (TRUE) {
#line 5677 "File.c"
				GFileInfo* _tmp12_ = NULL;
				GFileEnumerator* _tmp13_;
				GFileInfo* _tmp14_;
				GFileInfo* _tmp15_;
				GFileInfo* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 1198 "../libcore/File.vala"
				_tmp13_ = f_enum;
#line 1198 "../libcore/File.vala"
				_tmp14_ = g_file_enumerator_next_file (_tmp13_, NULL, &_inner_error0_);
#line 1198 "../libcore/File.vala"
				_tmp12_ = _tmp14_;
#line 1198 "../libcore/File.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1198 "../libcore/File.vala"
					_g_object_unref0 (info);
#line 1198 "../libcore/File.vala"
					_g_object_unref0 (f_enum);
#line 5696 "File.c"
					goto __catch0_g_error;
				}
#line 1198 "../libcore/File.vala"
				_tmp15_ = _tmp12_;
#line 1198 "../libcore/File.vala"
				_tmp12_ = NULL;
#line 1198 "../libcore/File.vala"
				_g_object_unref0 (info);
#line 1198 "../libcore/File.vala"
				info = _tmp15_;
#line 1198 "../libcore/File.vala"
				_tmp16_ = info;
#line 1198 "../libcore/File.vala"
				if (!(_tmp16_ != NULL)) {
#line 1198 "../libcore/File.vala"
					_g_object_unref0 (_tmp12_);
#line 1198 "../libcore/File.vala"
					break;
#line 5715 "File.c"
				}
#line 1199 "../libcore/File.vala"
				if (pref_show_hidden) {
#line 1199 "../libcore/File.vala"
					_tmp17_ = TRUE;
#line 5721 "File.c"
				} else {
					GFileInfo* _tmp18_;
#line 1200 "../libcore/File.vala"
					_tmp18_ = info;
#line 1200 "../libcore/File.vala"
					_tmp17_ = !g_file_info_get_attribute_boolean (_tmp18_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN);
#line 5728 "File.c"
				}
#line 1199 "../libcore/File.vala"
				if (_tmp17_) {
#line 5732 "File.c"
					gint _tmp19_;
#line 1202 "../libcore/File.vala"
					_tmp19_ = self->count;
#line 1202 "../libcore/File.vala"
					self->count = _tmp19_ + 1;
#line 5738 "File.c"
				}
#line 1198 "../libcore/File.vala"
				_g_object_unref0 (_tmp12_);
#line 5742 "File.c"
			}
#line 1189 "../libcore/File.vala"
			_g_object_unref0 (info);
#line 1189 "../libcore/File.vala"
			_g_object_unref0 (f_enum);
#line 5748 "File.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 1189 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 1206 "../libcore/File.vala"
			self->count = -1;
#line 5757 "File.c"
		}
		__finally0:
#line 1189 "../libcore/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1189 "../libcore/File.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1189 "../libcore/File.vala"
			g_clear_error (&_inner_error0_);
#line 1189 "../libcore/File.vala"
			return;
#line 5768 "File.c"
		}
	}
}

static void
files_file_update_formated_type (FilesFile* self)
{
	const gchar* ftype = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1212 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 1213 "../libcore/File.vala"
	_tmp0_ = files_file_get_ftype (self);
#line 1213 "../libcore/File.vala"
	ftype = _tmp0_;
#line 1214 "../libcore/File.vala"
	_tmp1_ = ftype;
#line 1214 "../libcore/File.vala"
	if (_tmp1_ != NULL) {
#line 1215 "../libcore/File.vala"
		if (files_file_is_symlink (self)) {
#line 5791 "File.c"
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 1216 "../libcore/File.vala"
			_tmp2_ = ftype;
#line 1216 "../libcore/File.vala"
			_tmp3_ = g_content_type_get_description (_tmp2_);
#line 1216 "../libcore/File.vala"
			_tmp4_ = _tmp3_;
#line 1216 "../libcore/File.vala"
			_tmp5_ = g_strdup_printf (_ ("link to %s"), _tmp4_);
#line 1216 "../libcore/File.vala"
			_g_free0 (self->formated_type);
#line 1216 "../libcore/File.vala"
			self->formated_type = _tmp5_;
#line 1216 "../libcore/File.vala"
			_g_free0 (_tmp4_);
#line 5810 "File.c"
		} else {
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 1218 "../libcore/File.vala"
			_tmp6_ = ftype;
#line 1218 "../libcore/File.vala"
			_tmp7_ = g_content_type_get_description (_tmp6_);
#line 1218 "../libcore/File.vala"
			_g_free0 (self->formated_type);
#line 1218 "../libcore/File.vala"
			self->formated_type = _tmp7_;
#line 5822 "File.c"
		}
	} else {
		gchar* _tmp8_;
#line 1221 "../libcore/File.vala"
		_tmp8_ = g_strdup ("");
#line 1221 "../libcore/File.vala"
		_g_free0 (self->formated_type);
#line 1221 "../libcore/File.vala"
		self->formated_type = _tmp8_;
#line 5832 "File.c"
	}
}

GIcon*
files_file_get_icon_user_special_dirs (FilesFile* self,
                                       const gchar* path)
{
	const gchar* _tmp0_;
	GIcon* result;
#line 1225 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1225 "../libcore/File.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1226 "../libcore/File.vala"
	_tmp0_ = g_get_home_dir ();
#line 1226 "../libcore/File.vala"
	if (g_strcmp0 (path, _tmp0_) == 0) {
#line 5850 "File.c"
		GThemedIcon* _tmp1_;
#line 1227 "../libcore/File.vala"
		_tmp1_ = (GThemedIcon*) g_themed_icon_new ("user-home");
#line 1227 "../libcore/File.vala"
		result = (GIcon*) _tmp1_;
#line 1227 "../libcore/File.vala"
		return result;
#line 5858 "File.c"
	} else {
		const gchar* _tmp2_;
#line 1228 "../libcore/File.vala"
		_tmp2_ = g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP);
#line 1228 "../libcore/File.vala"
		if (g_strcmp0 (path, _tmp2_) == 0) {
#line 5865 "File.c"
			GThemedIcon* _tmp3_;
#line 1229 "../libcore/File.vala"
			_tmp3_ = (GThemedIcon*) g_themed_icon_new ("user-desktop");
#line 1229 "../libcore/File.vala"
			result = (GIcon*) _tmp3_;
#line 1229 "../libcore/File.vala"
			return result;
#line 5873 "File.c"
		} else {
			const gchar* _tmp4_;
#line 1230 "../libcore/File.vala"
			_tmp4_ = g_get_user_special_dir (G_USER_DIRECTORY_DOCUMENTS);
#line 1230 "../libcore/File.vala"
			if (g_strcmp0 (path, _tmp4_) == 0) {
#line 5880 "File.c"
				GThemedIcon* _tmp5_;
#line 1231 "../libcore/File.vala"
				_tmp5_ = (GThemedIcon*) g_themed_icon_new ("folder-documents");
#line 1231 "../libcore/File.vala"
				result = (GIcon*) _tmp5_;
#line 1231 "../libcore/File.vala"
				return result;
#line 5888 "File.c"
			} else {
				const gchar* _tmp6_;
#line 1232 "../libcore/File.vala"
				_tmp6_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
#line 1232 "../libcore/File.vala"
				if (g_strcmp0 (path, _tmp6_) == 0) {
#line 5895 "File.c"
					GThemedIcon* _tmp7_;
#line 1233 "../libcore/File.vala"
					_tmp7_ = (GThemedIcon*) g_themed_icon_new ("folder-download");
#line 1233 "../libcore/File.vala"
					result = (GIcon*) _tmp7_;
#line 1233 "../libcore/File.vala"
					return result;
#line 5903 "File.c"
				} else {
					const gchar* _tmp8_;
#line 1234 "../libcore/File.vala"
					_tmp8_ = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
#line 1234 "../libcore/File.vala"
					if (g_strcmp0 (path, _tmp8_) == 0) {
#line 5910 "File.c"
						GThemedIcon* _tmp9_;
#line 1235 "../libcore/File.vala"
						_tmp9_ = (GThemedIcon*) g_themed_icon_new ("folder-music");
#line 1235 "../libcore/File.vala"
						result = (GIcon*) _tmp9_;
#line 1235 "../libcore/File.vala"
						return result;
#line 5918 "File.c"
					} else {
						const gchar* _tmp10_;
#line 1236 "../libcore/File.vala"
						_tmp10_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
#line 1236 "../libcore/File.vala"
						if (g_strcmp0 (path, _tmp10_) == 0) {
#line 5925 "File.c"
							GThemedIcon* _tmp11_;
#line 1237 "../libcore/File.vala"
							_tmp11_ = (GThemedIcon*) g_themed_icon_new ("folder-pictures");
#line 1237 "../libcore/File.vala"
							result = (GIcon*) _tmp11_;
#line 1237 "../libcore/File.vala"
							return result;
#line 5933 "File.c"
						} else {
							const gchar* _tmp12_;
#line 1238 "../libcore/File.vala"
							_tmp12_ = g_get_user_special_dir (G_USER_DIRECTORY_PUBLIC_SHARE);
#line 1238 "../libcore/File.vala"
							if (g_strcmp0 (path, _tmp12_) == 0) {
#line 5940 "File.c"
								GThemedIcon* _tmp13_;
#line 1239 "../libcore/File.vala"
								_tmp13_ = (GThemedIcon*) g_themed_icon_new ("folder-publicshare");
#line 1239 "../libcore/File.vala"
								result = (GIcon*) _tmp13_;
#line 1239 "../libcore/File.vala"
								return result;
#line 5948 "File.c"
							} else {
								const gchar* _tmp14_;
#line 1240 "../libcore/File.vala"
								_tmp14_ = g_get_user_special_dir (G_USER_DIRECTORY_TEMPLATES);
#line 1240 "../libcore/File.vala"
								if (g_strcmp0 (path, _tmp14_) == 0) {
#line 5955 "File.c"
									GThemedIcon* _tmp15_;
#line 1241 "../libcore/File.vala"
									_tmp15_ = (GThemedIcon*) g_themed_icon_new ("folder-templates");
#line 1241 "../libcore/File.vala"
									result = (GIcon*) _tmp15_;
#line 1241 "../libcore/File.vala"
									return result;
#line 5963 "File.c"
								} else {
									const gchar* _tmp16_;
#line 1242 "../libcore/File.vala"
									_tmp16_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
#line 1242 "../libcore/File.vala"
									if (g_strcmp0 (path, _tmp16_) == 0) {
#line 5970 "File.c"
										GThemedIcon* _tmp17_;
#line 1243 "../libcore/File.vala"
										_tmp17_ = (GThemedIcon*) g_themed_icon_new ("folder-videos");
#line 1243 "../libcore/File.vala"
										result = (GIcon*) _tmp17_;
#line 1243 "../libcore/File.vala"
										return result;
#line 5978 "File.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 1246 "../libcore/File.vala"
	result = NULL;
#line 1246 "../libcore/File.vala"
	return result;
#line 5992 "File.c"
}

static guint
files_file_get_number_of_uri_parts (FilesFile* self)
{
	const gchar* target_uri = NULL;
	GFileInfo* _tmp0_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	guint _tmp9_;
	guint result;
#line 1249 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1250 "../libcore/File.vala"
	target_uri = NULL;
#line 1251 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 1251 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 6016 "File.c"
		GFileInfo* _tmp1_;
		const gchar* _tmp2_;
#line 1252 "../libcore/File.vala"
		_tmp1_ = self->info;
#line 1252 "../libcore/File.vala"
		_tmp2_ = g_file_info_get_attribute_string (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 1252 "../libcore/File.vala"
		target_uri = _tmp2_;
#line 6025 "File.c"
	}
#line 1255 "../libcore/File.vala"
	_tmp3_ = target_uri;
#line 1255 "../libcore/File.vala"
	if (_tmp3_ == NULL) {
#line 6031 "File.c"
		const gchar* _tmp4_;
#line 1256 "../libcore/File.vala"
		_tmp4_ = self->priv->_uri;
#line 1256 "../libcore/File.vala"
		target_uri = _tmp4_;
#line 6037 "File.c"
	}
#line 1259 "../libcore/File.vala"
	_tmp5_ = target_uri;
#line 1259 "../libcore/File.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "/", 6);
#line 1259 "../libcore/File.vala"
	_tmp8_ = _tmp7_;
#line 1259 "../libcore/File.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1259 "../libcore/File.vala"
	_tmp9_ = (guint) _vala_array_length (_tmp6_);
#line 1259 "../libcore/File.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 1259 "../libcore/File.vala"
	result = _tmp9_;
#line 1259 "../libcore/File.vala"
	return result;
#line 6055 "File.c"
}

static gboolean
files_file_is_location_uri_default (FilesFile* self)
{
	GFileInfo* _tmp0_;
	const gchar* target_uri = NULL;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar** split = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint split_length1;
	gint _split_size_;
	gboolean _tmp8_ = FALSE;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gboolean result;
#line 1262 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1263 "../libcore/File.vala"
	_tmp0_ = self->info;
#line 1263 "../libcore/File.vala"
	g_return_val_if_fail (_tmp0_ != NULL, FALSE);
#line 1264 "../libcore/File.vala"
	_tmp1_ = self->info;
#line 1264 "../libcore/File.vala"
	_tmp2_ = g_file_info_get_attribute_string (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_TARGET_URI);
#line 1264 "../libcore/File.vala"
	target_uri = _tmp2_;
#line 1265 "../libcore/File.vala"
	_tmp3_ = target_uri;
#line 1265 "../libcore/File.vala"
	if (_tmp3_ == NULL) {
#line 6093 "File.c"
		const gchar* _tmp4_;
#line 1266 "../libcore/File.vala"
		_tmp4_ = self->priv->_uri;
#line 1266 "../libcore/File.vala"
		target_uri = _tmp4_;
#line 6099 "File.c"
	}
#line 1269 "../libcore/File.vala"
	_tmp5_ = target_uri;
#line 1269 "../libcore/File.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "/", 4);
#line 1269 "../libcore/File.vala"
	split = _tmp7_;
#line 1269 "../libcore/File.vala"
	split_length1 = _vala_array_length (_tmp6_);
#line 1269 "../libcore/File.vala"
	_split_size_ = split_length1;
#line 1270 "../libcore/File.vala"
	_tmp9_ = split;
#line 1270 "../libcore/File.vala"
	_tmp9__length1 = split_length1;
#line 1270 "../libcore/File.vala"
	_tmp10_ = _tmp9_[3];
#line 1270 "../libcore/File.vala"
	if (_tmp10_ == NULL) {
#line 1270 "../libcore/File.vala"
		_tmp8_ = TRUE;
#line 6121 "File.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 1270 "../libcore/File.vala"
		_tmp11_ = split;
#line 1270 "../libcore/File.vala"
		_tmp11__length1 = split_length1;
#line 1270 "../libcore/File.vala"
		_tmp12_ = _tmp11_[3];
#line 1270 "../libcore/File.vala"
		_tmp8_ = g_strcmp0 (_tmp12_, "") == 0;
#line 6134 "File.c"
	}
#line 1270 "../libcore/File.vala"
	result = _tmp8_;
#line 1270 "../libcore/File.vala"
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 1270 "../libcore/File.vala"
	return result;
#line 6142 "File.c"
}

gint
files_file_compare_files_by_time (FilesFile* self,
                                  FilesFile* other)
{
	gint result;
#line 1274 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1274 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1275 "../libcore/File.vala"
	if (self->modified < other->modified) {
#line 1276 "../libcore/File.vala"
		result = 1;
#line 1276 "../libcore/File.vala"
		return result;
#line 6160 "File.c"
	} else {
#line 1277 "../libcore/File.vala"
		if (self->modified > other->modified) {
#line 1278 "../libcore/File.vala"
			result = -1;
#line 1278 "../libcore/File.vala"
			return result;
#line 6168 "File.c"
		}
	}
#line 1280 "../libcore/File.vala"
	result = 0;
#line 1280 "../libcore/File.vala"
	return result;
#line 6175 "File.c"
}

gint
files_file_compare_files_by_created (FilesFile* self,
                                     FilesFile* other)
{
	gint result;
#line 1283 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1283 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1284 "../libcore/File.vala"
	if (self->created < other->created) {
#line 1285 "../libcore/File.vala"
		result = 1;
#line 1285 "../libcore/File.vala"
		return result;
#line 6193 "File.c"
	} else {
#line 1286 "../libcore/File.vala"
		if (self->created > other->created) {
#line 1287 "../libcore/File.vala"
			result = -1;
#line 1287 "../libcore/File.vala"
			return result;
#line 6201 "File.c"
		}
	}
#line 1289 "../libcore/File.vala"
	result = 0;
#line 1289 "../libcore/File.vala"
	return result;
#line 6208 "File.c"
}

gint
files_file_compare_by_type (FilesFile* self,
                            FilesFile* other)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result;
#line 1292 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1292 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1298 "../libcore/File.vala"
	if (files_file_is_folder (self)) {
#line 1298 "../libcore/File.vala"
		_tmp0_ = files_file_is_folder (other);
#line 6227 "File.c"
	} else {
#line 1298 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 6231 "File.c"
	}
#line 1298 "../libcore/File.vala"
	if (_tmp0_) {
#line 1299 "../libcore/File.vala"
		result = 0;
#line 1299 "../libcore/File.vala"
		return result;
#line 6239 "File.c"
	} else {
#line 1300 "../libcore/File.vala"
		if (files_file_is_folder (self)) {
#line 1301 "../libcore/File.vala"
			result = -1;
#line 1301 "../libcore/File.vala"
			return result;
#line 6247 "File.c"
		} else {
#line 1302 "../libcore/File.vala"
			if (files_file_is_folder (other)) {
#line 1303 "../libcore/File.vala"
				result = 1;
#line 1303 "../libcore/File.vala"
				return result;
#line 6255 "File.c"
			}
		}
	}
#line 1306 "../libcore/File.vala"
	_tmp1_ = self->formated_type;
#line 1306 "../libcore/File.vala"
	_tmp2_ = other->formated_type;
#line 1306 "../libcore/File.vala"
	result = g_utf8_collate (_tmp1_, _tmp2_);
#line 1306 "../libcore/File.vala"
	return result;
#line 6267 "File.c"
}

gint
files_file_compare_files_by_size (FilesFile* self,
                                  FilesFile* other)
{
	gint result;
#line 1309 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1309 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1310 "../libcore/File.vala"
	if (self->size < other->size) {
#line 1311 "../libcore/File.vala"
		result = -1;
#line 1311 "../libcore/File.vala"
		return result;
#line 6285 "File.c"
	} else {
#line 1312 "../libcore/File.vala"
		if (self->size > other->size) {
#line 1313 "../libcore/File.vala"
			result = 1;
#line 1313 "../libcore/File.vala"
			return result;
#line 6293 "File.c"
		}
	}
#line 1316 "../libcore/File.vala"
	result = 0;
#line 1316 "../libcore/File.vala"
	return result;
#line 6300 "File.c"
}

gint
files_file_compare_by_size (FilesFile* self,
                            FilesFile* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint result;
#line 1319 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1319 "../libcore/File.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 1323 "../libcore/File.vala"
	if (files_file_is_folder (self)) {
#line 1323 "../libcore/File.vala"
		_tmp0_ = !files_file_is_folder (other);
#line 6319 "File.c"
	} else {
#line 1323 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 6323 "File.c"
	}
#line 1323 "../libcore/File.vala"
	if (_tmp0_) {
#line 1324 "../libcore/File.vala"
		result = -1;
#line 1324 "../libcore/File.vala"
		return result;
#line 6331 "File.c"
	}
#line 1327 "../libcore/File.vala"
	if (files_file_is_folder (other)) {
#line 1327 "../libcore/File.vala"
		_tmp1_ = !files_file_is_folder (self);
#line 6337 "File.c"
	} else {
#line 1327 "../libcore/File.vala"
		_tmp1_ = FALSE;
#line 6341 "File.c"
	}
#line 1327 "../libcore/File.vala"
	if (_tmp1_) {
#line 1328 "../libcore/File.vala"
		result = 1;
#line 1328 "../libcore/File.vala"
		return result;
#line 6349 "File.c"
	}
#line 1331 "../libcore/File.vala"
	if (files_file_is_folder (self)) {
#line 1331 "../libcore/File.vala"
		_tmp2_ = files_file_is_folder (other);
#line 6355 "File.c"
	} else {
#line 1331 "../libcore/File.vala"
		_tmp2_ = FALSE;
#line 6359 "File.c"
	}
#line 1331 "../libcore/File.vala"
	if (_tmp2_) {
#line 1334 "../libcore/File.vala"
		files_file_ensure_item_count (self, FALSE);
#line 1335 "../libcore/File.vala"
		files_file_ensure_item_count (other, FALSE);
#line 1337 "../libcore/File.vala"
		if (self->count < other->count) {
#line 1338 "../libcore/File.vala"
			result = -1;
#line 1338 "../libcore/File.vala"
			return result;
#line 6373 "File.c"
		} else {
#line 1339 "../libcore/File.vala"
			if (self->count > other->count) {
#line 1340 "../libcore/File.vala"
				result = 1;
#line 1340 "../libcore/File.vala"
				return result;
#line 6381 "File.c"
			}
		}
	} else {
#line 1344 "../libcore/File.vala"
		if (self->size < other->size) {
#line 1345 "../libcore/File.vala"
			result = -1;
#line 1345 "../libcore/File.vala"
			return result;
#line 6391 "File.c"
		} else {
#line 1346 "../libcore/File.vala"
			if (self->size > other->size) {
#line 1347 "../libcore/File.vala"
				result = 1;
#line 1347 "../libcore/File.vala"
				return result;
#line 6399 "File.c"
			}
		}
	}
#line 1351 "../libcore/File.vala"
	result = 0;
#line 1351 "../libcore/File.vala"
	return result;
#line 6407 "File.c"
}

GFile*
files_file_get_location (FilesFile* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 46 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 46 "../libcore/File.vala"
	result = _tmp0_;
#line 46 "../libcore/File.vala"
	return result;
#line 6423 "File.c"
}

static void
files_file_set_location (FilesFile* self,
                         GFile* value)
{
	GFile* old_value;
#line 46 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 46 "../libcore/File.vala"
	old_value = files_file_get_location (self);
#line 46 "../libcore/File.vala"
	if (old_value != value) {
#line 6437 "File.c"
		GFile* _tmp0_;
#line 46 "../libcore/File.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 46 "../libcore/File.vala"
		_g_object_unref0 (self->priv->_location);
#line 46 "../libcore/File.vala"
		self->priv->_location = _tmp0_;
#line 46 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_LOCATION_PROPERTY]);
#line 6447 "File.c"
	}
}

GFile*
files_file_get_directory (FilesFile* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 47 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../libcore/File.vala"
	_tmp0_ = self->priv->_directory;
#line 47 "../libcore/File.vala"
	result = _tmp0_;
#line 47 "../libcore/File.vala"
	return result;
#line 6464 "File.c"
}

static void
files_file_set_directory (FilesFile* self,
                          GFile* value)
{
	GFile* old_value;
#line 47 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 47 "../libcore/File.vala"
	old_value = files_file_get_directory (self);
#line 47 "../libcore/File.vala"
	if (old_value != value) {
#line 6478 "File.c"
		GFile* _tmp0_;
#line 47 "../libcore/File.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../libcore/File.vala"
		_g_object_unref0 (self->priv->_directory);
#line 47 "../libcore/File.vala"
		self->priv->_directory = _tmp0_;
#line 47 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_DIRECTORY_PROPERTY]);
#line 6488 "File.c"
	}
}

const gchar*
files_file_get_basename (FilesFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../libcore/File.vala"
	_tmp0_ = self->priv->_basename;
#line 56 "../libcore/File.vala"
	result = _tmp0_;
#line 56 "../libcore/File.vala"
	return result;
#line 6505 "File.c"
}

static void
files_file_set_basename (FilesFile* self,
                         const gchar* value)
{
	gchar* old_value;
#line 56 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 56 "../libcore/File.vala"
	old_value = files_file_get_basename (self);
#line 56 "../libcore/File.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6519 "File.c"
		gchar* _tmp0_;
#line 56 "../libcore/File.vala"
		_tmp0_ = g_strdup (value);
#line 56 "../libcore/File.vala"
		_g_free0 (self->priv->_basename);
#line 56 "../libcore/File.vala"
		self->priv->_basename = _tmp0_;
#line 56 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_BASENAME_PROPERTY]);
#line 6529 "File.c"
	}
}

const gchar*
files_file_get_uri (FilesFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../libcore/File.vala"
	_tmp0_ = self->priv->_uri;
#line 58 "../libcore/File.vala"
	result = _tmp0_;
#line 58 "../libcore/File.vala"
	return result;
#line 6546 "File.c"
}

static void
files_file_set_uri (FilesFile* self,
                    const gchar* value)
{
	gchar* old_value;
#line 58 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 58 "../libcore/File.vala"
	old_value = files_file_get_uri (self);
#line 58 "../libcore/File.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6560 "File.c"
		gchar* _tmp0_;
#line 58 "../libcore/File.vala"
		_tmp0_ = g_strdup (value);
#line 58 "../libcore/File.vala"
		_g_free0 (self->priv->_uri);
#line 58 "../libcore/File.vala"
		self->priv->_uri = _tmp0_;
#line 58 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_URI_PROPERTY]);
#line 6570 "File.c"
	}
}

gint
files_file_get_color (FilesFile* self)
{
	gint result;
#line 62 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../libcore/File.vala"
	result = self->priv->_color;
#line 62 "../libcore/File.vala"
	return result;
#line 6584 "File.c"
}

void
files_file_set_color (FilesFile* self,
                      gint value)
{
	gint old_value;
#line 62 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 62 "../libcore/File.vala"
	old_value = files_file_get_color (self);
#line 62 "../libcore/File.vala"
	if (old_value != value) {
#line 62 "../libcore/File.vala"
		self->priv->_color = value;
#line 62 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_COLOR_PROPERTY]);
#line 6602 "File.c"
	}
}

gboolean
files_file_get_is_hidden (FilesFile* self)
{
	gboolean result;
#line 78 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../libcore/File.vala"
	result = self->priv->_is_hidden;
#line 78 "../libcore/File.vala"
	return result;
#line 6616 "File.c"
}

static void
files_file_set_is_hidden (FilesFile* self,
                          gboolean value)
{
	gboolean old_value;
#line 78 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 78 "../libcore/File.vala"
	old_value = files_file_get_is_hidden (self);
#line 78 "../libcore/File.vala"
	if (old_value != value) {
#line 78 "../libcore/File.vala"
		self->priv->_is_hidden = value;
#line 78 "../libcore/File.vala"
		g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_IS_HIDDEN_PROPERTY]);
#line 6634 "File.c"
	}
}

const gchar*
files_file_get_thumbnail_path (FilesFile* self)
{
	const gchar* result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp8_;
#line 88 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../libcore/File.vala"
	_tmp2_ = self->priv->_thumbnail_path;
#line 89 "../libcore/File.vala"
	if (_tmp2_ == NULL) {
#line 6652 "File.c"
		GFileInfo* _tmp3_;
#line 90 "../libcore/File.vala"
		_tmp3_ = self->info;
#line 90 "../libcore/File.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 6658 "File.c"
	} else {
#line 89 "../libcore/File.vala"
		_tmp1_ = FALSE;
#line 6662 "File.c"
	}
#line 89 "../libcore/File.vala"
	if (_tmp1_) {
#line 6666 "File.c"
		GFileInfo* _tmp4_;
#line 91 "../libcore/File.vala"
		_tmp4_ = self->info;
#line 91 "../libcore/File.vala"
		_tmp0_ = g_file_info_has_attribute (_tmp4_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 6672 "File.c"
	} else {
#line 89 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 6676 "File.c"
	}
#line 89 "../libcore/File.vala"
	if (_tmp0_) {
#line 6680 "File.c"
		GFileInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 94 "../libcore/File.vala"
		_tmp5_ = self->info;
#line 94 "../libcore/File.vala"
		_tmp6_ = g_file_info_get_attribute_byte_string (_tmp5_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 94 "../libcore/File.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 94 "../libcore/File.vala"
		_g_free0 (self->priv->_thumbnail_path);
#line 94 "../libcore/File.vala"
		self->priv->_thumbnail_path = _tmp7_;
#line 6694 "File.c"
	}
#line 97 "../libcore/File.vala"
	_tmp8_ = self->priv->_thumbnail_path;
#line 97 "../libcore/File.vala"
	result = _tmp8_;
#line 97 "../libcore/File.vala"
	return result;
#line 6702 "File.c"
}

void
files_file_set_thumbnail_path (FilesFile* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 100 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 101 "../libcore/File.vala"
	_tmp0_ = g_strdup (value);
#line 101 "../libcore/File.vala"
	_g_free0 (self->priv->_thumbnail_path);
#line 101 "../libcore/File.vala"
	self->priv->_thumbnail_path = _tmp0_;
#line 100 "../libcore/File.vala"
	g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_THUMBNAIL_PATH_PROPERTY]);
#line 6720 "File.c"
}

gboolean
files_file_get_exists (FilesFile* self)
{
	gboolean result;
#line 109 "../libcore/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "../libcore/File.vala"
	result = self->priv->_exists;
#line 110 "../libcore/File.vala"
	return result;
#line 6733 "File.c"
}

void
files_file_set_exists (FilesFile* self,
                       gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 113 "../libcore/File.vala"
	g_return_if_fail (self != NULL);
#line 115 "../libcore/File.vala"
	if (!value) {
#line 115 "../libcore/File.vala"
		_tmp0_ = self->priv->_exists;
#line 6747 "File.c"
	} else {
#line 115 "../libcore/File.vala"
		_tmp0_ = FALSE;
#line 6751 "File.c"
	}
#line 115 "../libcore/File.vala"
	if (_tmp0_) {
#line 6755 "File.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 116 "../libcore/File.vala"
		_tmp1_ = files_file_get_thumbnail_path (self);
#line 116 "../libcore/File.vala"
		_tmp2_ = _tmp1_;
#line 116 "../libcore/File.vala"
		if (_tmp2_ != NULL) {
#line 6764 "File.c"
			const gchar* _tmp3_;
#line 117 "../libcore/File.vala"
			_tmp3_ = self->priv->_uri;
#line 117 "../libcore/File.vala"
			files_file_utils_remove_thumbnail_paths_for_uri (_tmp3_);
#line 6770 "File.c"
		}
	}
#line 121 "../libcore/File.vala"
	self->priv->_exists = FALSE;
#line 113 "../libcore/File.vala"
	g_object_notify_by_pspec ((GObject *) self, files_file_properties[FILES_FILE_EXISTS_PROPERTY]);
#line 6777 "File.c"
}

static void
_files_file___lambda9_ (FilesFile* self)
{
	GFile* _tmp0_;
#line 215 "../libcore/File.vala"
	_tmp0_ = self->priv->_directory;
#line 215 "../libcore/File.vala"
	if (_tmp0_ != NULL) {
#line 6788 "File.c"
		FilesDirectory* dir = NULL;
		GFile* _tmp1_;
		FilesDirectory* _tmp2_;
		gboolean _tmp3_ = FALSE;
		FilesDirectory* _tmp4_;
#line 216 "../libcore/File.vala"
		_tmp1_ = self->priv->_directory;
#line 216 "../libcore/File.vala"
		_tmp2_ = files_directory_cache_lookup (_tmp1_);
#line 216 "../libcore/File.vala"
		dir = _tmp2_;
#line 217 "../libcore/File.vala"
		_tmp4_ = dir;
#line 217 "../libcore/File.vala"
		if (_tmp4_ != NULL) {
#line 6804 "File.c"
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 217 "../libcore/File.vala"
			_tmp6_ = self->priv->_is_hidden;
#line 217 "../libcore/File.vala"
			if (!_tmp6_) {
#line 217 "../libcore/File.vala"
				_tmp5_ = TRUE;
#line 6813 "File.c"
			} else {
				FilesPreferences* _tmp7_;
				FilesPreferences* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
#line 217 "../libcore/File.vala"
				_tmp7_ = files_preferences_get_default ();
#line 217 "../libcore/File.vala"
				_tmp8_ = _tmp7_;
#line 217 "../libcore/File.vala"
				_tmp9_ = files_preferences_get_show_hidden_files (_tmp8_);
#line 217 "../libcore/File.vala"
				_tmp10_ = _tmp9_;
#line 217 "../libcore/File.vala"
				_tmp5_ = _tmp10_;
#line 217 "../libcore/File.vala"
				_g_object_unref0 (_tmp8_);
#line 6831 "File.c"
			}
#line 217 "../libcore/File.vala"
			_tmp3_ = _tmp5_;
#line 6835 "File.c"
		} else {
#line 217 "../libcore/File.vala"
			_tmp3_ = FALSE;
#line 6839 "File.c"
		}
#line 217 "../libcore/File.vala"
		if (_tmp3_) {
#line 6843 "File.c"
			FilesDirectory* _tmp11_;
#line 218 "../libcore/File.vala"
			_tmp11_ = dir;
#line 218 "../libcore/File.vala"
			g_signal_emit_by_name (_tmp11_, "icon-changed", self);
#line 6849 "File.c"
		}
#line 215 "../libcore/File.vala"
		_g_object_unref0 (dir);
#line 6853 "File.c"
	}
}

static void
__files_file___lambda9__files_file_icon_changed (FilesFile* _sender,
                                                 gpointer self)
{
#line 214 "../libcore/File.vala"
	_files_file___lambda9_ ((FilesFile*) self);
#line 6863 "File.c"
}

static GObject *
files_file_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesFile * self;
	gchar* scheme = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
#line 211 "../libcore/File.vala"
	parent_class = G_OBJECT_CLASS (files_file_parent_class);
#line 211 "../libcore/File.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 211 "../libcore/File.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_FILE, FilesFile);
#line 212 "../libcore/File.vala"
	_tmp0_ = self->priv->_location;
#line 212 "../libcore/File.vala"
	_tmp1_ = g_file_get_uri_scheme (_tmp0_);
#line 212 "../libcore/File.vala"
	scheme = _tmp1_;
#line 213 "../libcore/File.vala"
	_tmp3_ = scheme;
#line 213 "../libcore/File.vala"
	if (g_strcmp0 (_tmp3_, "") != 0) {
#line 6898 "File.c"
		const gchar* _tmp4_;
#line 213 "../libcore/File.vala"
		_tmp4_ = scheme;
#line 213 "../libcore/File.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "file") != 0;
#line 6904 "File.c"
	} else {
#line 213 "../libcore/File.vala"
		_tmp2_ = FALSE;
#line 6908 "File.c"
	}
#line 213 "../libcore/File.vala"
	self->is_remote = _tmp2_;
#line 214 "../libcore/File.vala"
	g_signal_connect_object (self, "icon-changed", (GCallback) __files_file___lambda9__files_file_icon_changed, self, 0);
#line 225 "../libcore/File.vala"
	_tmp7_ = self->priv->_basename;
#line 225 "../libcore/File.vala"
	if (g_str_has_prefix (_tmp7_, ".")) {
#line 225 "../libcore/File.vala"
		_tmp6_ = TRUE;
#line 6920 "File.c"
	} else {
		const gchar* _tmp8_;
#line 226 "../libcore/File.vala"
		_tmp8_ = self->priv->_basename;
#line 226 "../libcore/File.vala"
		_tmp6_ = g_str_has_prefix (_tmp8_, "~");
#line 6927 "File.c"
	}
#line 225 "../libcore/File.vala"
	if (_tmp6_) {
#line 225 "../libcore/File.vala"
		_tmp5_ = TRUE;
#line 6933 "File.c"
	} else {
		const gchar* _tmp9_;
#line 227 "../libcore/File.vala"
		_tmp9_ = self->priv->_basename;
#line 227 "../libcore/File.vala"
		_tmp5_ = g_str_has_suffix (_tmp9_, "~");
#line 6940 "File.c"
	}
#line 225 "../libcore/File.vala"
	files_file_set_is_hidden (self, _tmp5_);
#line 211 "../libcore/File.vala"
	_g_free0 (scheme);
#line 211 "../libcore/File.vala"
	return obj;
#line 6948 "File.c"
}

static void
files_file_class_init (FilesFileClass * klass,
                       gpointer klass_data)
{
#line 19 "../libcore/File.vala"
	files_file_parent_class = g_type_class_peek_parent (klass);
#line 19 "../libcore/File.vala"
	g_type_class_adjust_private_offset (klass, &FilesFile_private_offset);
#line 19 "../libcore/File.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_file_get_property;
#line 19 "../libcore/File.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_file_set_property;
#line 19 "../libcore/File.vala"
	G_OBJECT_CLASS (klass)->constructor = files_file_constructor;
#line 19 "../libcore/File.vala"
	G_OBJECT_CLASS (klass)->finalize = files_file_finalize;
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_LOCATION_PROPERTY, files_file_properties[FILES_FILE_LOCATION_PROPERTY] = g_param_spec_object ("location", "location", "location", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_DIRECTORY_PROPERTY, files_file_properties[FILES_FILE_DIRECTORY_PROPERTY] = g_param_spec_object ("directory", "directory", "directory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_BASENAME_PROPERTY, files_file_properties[FILES_FILE_BASENAME_PROPERTY] = g_param_spec_string ("basename", "basename", "basename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_URI_PROPERTY, files_file_properties[FILES_FILE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_COLOR_PROPERTY, files_file_properties[FILES_FILE_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_IS_HIDDEN_PROPERTY, files_file_properties[FILES_FILE_IS_HIDDEN_PROPERTY] = g_param_spec_boolean ("is-hidden", "is-hidden", "is-hidden", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_THUMBNAIL_PATH_PROPERTY, files_file_properties[FILES_FILE_THUMBNAIL_PATH_PROPERTY] = g_param_spec_string ("thumbnail-path", "thumbnail-path", "thumbnail-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_FILE_EXISTS_PROPERTY, files_file_properties[FILES_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("exists", "exists", "exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../libcore/File.vala"
	files_file_signals[FILES_FILE_CHANGED_SIGNAL] = g_signal_new ("changed", FILES_TYPE_FILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 19 "../libcore/File.vala"
	files_file_signals[FILES_FILE_ICON_CHANGED_SIGNAL] = g_signal_new ("icon-changed", FILES_TYPE_FILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 19 "../libcore/File.vala"
	files_file_signals[FILES_FILE_DESTROY_SIGNAL] = g_signal_new ("destroy", FILES_TYPE_FILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../libcore/File.vala"
	g_rec_mutex_init (&__lock_files_file_files_file_file_cache);
#line 6991 "File.c"
}

static void
files_file_instance_init (FilesFile * self,
                          gpointer klass)
{
#line 19 "../libcore/File.vala"
	self->priv = files_file_get_instance_private (self);
#line 49 "../libcore/File.vala"
	self->target_location = NULL;
#line 50 "../libcore/File.vala"
	self->target_gof = NULL;
#line 52 "../libcore/File.vala"
	self->icon = NULL;
#line 53 "../libcore/File.vala"
	self->emblems_list = NULL;
#line 54 "../libcore/File.vala"
	self->n_emblems = (guint) 0;
#line 55 "../libcore/File.vala"
	self->info = NULL;
#line 57 "../libcore/File.vala"
	self->custom_display_name = NULL;
#line 59 "../libcore/File.vala"
	self->size = (guint64) 0;
#line 60 "../libcore/File.vala"
	self->count = -1;
#line 61 "../libcore/File.vala"
	self->format_size = NULL;
#line 62 "../libcore/File.vala"
	self->priv->_color = -1;
#line 65 "../libcore/File.vala"
	self->formated_modified = NULL;
#line 66 "../libcore/File.vala"
	self->formated_type = NULL;
#line 67 "../libcore/File.vala"
	self->tagstype = NULL;
#line 68 "../libcore/File.vala"
	self->pix = NULL;
#line 69 "../libcore/File.vala"
	self->custom_icon_name = NULL;
#line 70 "../libcore/File.vala"
	self->pix_size = 16;
#line 71 "../libcore/File.vala"
	self->pix_scale = 1;
#line 72 "../libcore/File.vala"
	self->priv->pix_is_final = FALSE;
#line 73 "../libcore/File.vala"
	self->width = 0;
#line 74 "../libcore/File.vala"
	self->height = 0;
#line 75 "../libcore/File.vala"
	self->sort_column_id = (gint) FILES_LIST_MODEL_COLUMN_ID_FILENAME;
#line 76 "../libcore/File.vala"
	self->sort_order = GTK_SORT_ASCENDING;
#line 79 "../libcore/File.vala"
	self->is_remote = FALSE;
#line 80 "../libcore/File.vala"
	self->is_directory = FALSE;
#line 81 "../libcore/File.vala"
	self->is_desktop = FALSE;
#line 82 "../libcore/File.vala"
	self->is_expanded = FALSE;
#line 85 "../libcore/File.vala"
	self->thumbstate = (guint) FILES_FILE_THUMB_STATE_UNKNOWN;
#line 86 "../libcore/File.vala"
	self->priv->_thumbnail_path = NULL;
#line 105 "../libcore/File.vala"
	self->thumbnail_loaded = FALSE;
#line 106 "../libcore/File.vala"
	self->is_mounted = TRUE;
#line 107 "../libcore/File.vala"
	self->priv->_exists = TRUE;
#line 126 "../libcore/File.vala"
	self->owner = NULL;
#line 127 "../libcore/File.vala"
	self->group = NULL;
#line 130 "../libcore/File.vala"
	self->mount = NULL;
#line 131 "../libcore/File.vala"
	self->is_connected = TRUE;
#line 132 "../libcore/File.vala"
	self->utf8_collation_key = NULL;
#line 7074 "File.c"
}

static void
files_file_finalize (GObject * obj)
{
	FilesFile * self;
#line 19 "../libcore/File.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_FILE, FilesFile);
#line 46 "../libcore/File.vala"
	_g_object_unref0 (self->priv->_location);
#line 47 "../libcore/File.vala"
	_g_object_unref0 (self->priv->_directory);
#line 49 "../libcore/File.vala"
	_g_object_unref0 (self->target_location);
#line 50 "../libcore/File.vala"
	_g_object_unref0 (self->target_gof);
#line 52 "../libcore/File.vala"
	_g_object_unref0 (self->icon);
#line 53 "../libcore/File.vala"
	(self->emblems_list == NULL) ? NULL : (self->emblems_list = (_g_list_free__g_free0_ (self->emblems_list), NULL));
#line 55 "../libcore/File.vala"
	_g_object_unref0 (self->info);
#line 56 "../libcore/File.vala"
	_g_free0 (self->priv->_basename);
#line 57 "../libcore/File.vala"
	_g_free0 (self->custom_display_name);
#line 58 "../libcore/File.vala"
	_g_free0 (self->priv->_uri);
#line 61 "../libcore/File.vala"
	_g_free0 (self->format_size);
#line 65 "../libcore/File.vala"
	_g_free0 (self->formated_modified);
#line 66 "../libcore/File.vala"
	_g_free0 (self->formated_type);
#line 67 "../libcore/File.vala"
	_g_free0 (self->tagstype);
#line 68 "../libcore/File.vala"
	_g_object_unref0 (self->pix);
#line 69 "../libcore/File.vala"
	_g_free0 (self->custom_icon_name);
#line 86 "../libcore/File.vala"
	_g_free0 (self->priv->_thumbnail_path);
#line 126 "../libcore/File.vala"
	_g_free0 (self->owner);
#line 127 "../libcore/File.vala"
	_g_free0 (self->group);
#line 130 "../libcore/File.vala"
	_g_object_unref0 (self->mount);
#line 132 "../libcore/File.vala"
	_g_free0 (self->utf8_collation_key);
#line 19 "../libcore/File.vala"
	G_OBJECT_CLASS (files_file_parent_class)->finalize (obj);
#line 7127 "File.c"
}

 G_GNUC_NO_INLINE static GType
files_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesFile), 0, (GInstanceInitFunc) files_file_instance_init, NULL };
	GType files_file_type_id;
	files_file_type_id = g_type_register_static (G_TYPE_OBJECT, "FilesFile", &g_define_type_info, 0);
	FilesFile_private_offset = g_type_add_instance_private (files_file_type_id, sizeof (FilesFilePrivate));
	return files_file_type_id;
}

GType
files_file_get_type (void)
{
	static volatile gsize files_file_type_id__once = 0;
	if (g_once_init_enter (&files_file_type_id__once)) {
		GType files_file_type_id;
		files_file_type_id = files_file_get_type_once ();
		g_once_init_leave (&files_file_type_id__once, files_file_type_id);
	}
	return files_file_type_id__once;
}

static void
_vala_files_file_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	FilesFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_FILE, FilesFile);
#line 19 "../libcore/File.vala"
	switch (property_id) {
#line 19 "../libcore/File.vala"
		case FILES_FILE_LOCATION_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_object (value, files_file_get_location (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_DIRECTORY_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_object (value, files_file_get_directory (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_BASENAME_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_string (value, files_file_get_basename (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_URI_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_string (value, files_file_get_uri (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_COLOR_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_int (value, files_file_get_color (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_IS_HIDDEN_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_boolean (value, files_file_get_is_hidden (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_THUMBNAIL_PATH_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_string (value, files_file_get_thumbnail_path (self));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_EXISTS_PROPERTY:
#line 19 "../libcore/File.vala"
		g_value_set_boolean (value, files_file_get_exists (self));
#line 19 "../libcore/File.vala"
		break;
#line 7210 "File.c"
		default:
#line 19 "../libcore/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../libcore/File.vala"
		break;
#line 7216 "File.c"
	}
}

static void
_vala_files_file_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	FilesFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_FILE, FilesFile);
#line 19 "../libcore/File.vala"
	switch (property_id) {
#line 19 "../libcore/File.vala"
		case FILES_FILE_LOCATION_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_location (self, g_value_get_object (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_DIRECTORY_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_directory (self, g_value_get_object (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_BASENAME_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_basename (self, g_value_get_string (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_URI_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_uri (self, g_value_get_string (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_COLOR_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_color (self, g_value_get_int (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_IS_HIDDEN_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_is_hidden (self, g_value_get_boolean (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_THUMBNAIL_PATH_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_thumbnail_path (self, g_value_get_string (value));
#line 19 "../libcore/File.vala"
		break;
#line 19 "../libcore/File.vala"
		case FILES_FILE_EXISTS_PROPERTY:
#line 19 "../libcore/File.vala"
		files_file_set_exists (self, g_value_get_boolean (value));
#line 19 "../libcore/File.vala"
		break;
#line 7278 "File.c"
		default:
#line 19 "../libcore/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../libcore/File.vala"
		break;
#line 7284 "File.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

